<?php

// +----------------------------------------------------------------------+
// | OpenConf                                                             |
// +----------------------------------------------------------------------+
// | Copyright (c) 2002-2009 Zakon Group LLC.  All Rights Reserved.       |
// +----------------------------------------------------------------------+
// | This source file is subject to the OpenConf License, available on    |
// | the OpenConf web site: www.OpenConf.com                              |
// +----------------------------------------------------------------------+

require_once "../include.php";

require_once OCC_COUNTRY_FILE;

$authorRowSpan = 4;	// # of rows for author fields 

if (OCC_CHAIR_PWD_TRUMPS && isset($_REQUEST['c']) && ($_REQUEST['c'] == 1)) {
	$hdrfn = 1;
	beginChairSession();
	$chair = TRUE;
} else {
	$hdrfn = 3;
	$chair = FALSE;
}

printHeader("Edit Submission",$hdrfn);

// Edit still allowed?
if (! $chair && ! $OC_statusAR['OC_edit_open']) {
	print '
<b>Submission edits are no longer available.</b><p>
	';
	printFooter();
	exit;
}

// Get topics
$topq = "SELECT * FROM `" . OCC_TABLE_TOPIC . "`";
$topr = ocsql_query($topq) or err('unable to retrieve topics');
if (($tnum = mysql_num_rows($topr)) < 1) {
	warn('We are still waiting for the Program Chair to finalize the list of topics before opening up for submissions.  Please check back later.');
} else {
	$half = ceil($tnum / 2);
	$topicAR = array();
	while ($topl = mysql_fetch_assoc($topr)) {
		$topicAR[$topl['topicid']] = $topl['topicname'];
	}
}

// Get non-editable fields array
$nonEditFieldsAR = preg_split("/[\s,]+/", $OC_configAR['OC_subNonEditFields'], -1, PREG_SPLIT_NO_EMPTY);

// Is this a post?
if (isset($_POST['submit'])) {
	// Check for paper ID & password
	if (! isset($_POST['pid']) || 
		! preg_match("/^\d+$/", $_POST['pid']) ||
		(! $chair && (! isset($_POST['pwd']) || empty($_POST['pwd'])))
	) {
		warn('Please go back and check the submission ID and password');
		printFooter();
		exit;
	}

	if ($chair) { // display back links
		print '<p style="text-align: center"><a href="../chair/show_paper.php?pid=' . $_POST['pid'] . '">View This Submission</a> | <a href="../chair/list_papers.php">View All Submissions</a></p>';
	} else { // check pwd
		$pq = "SELECT password FROM " . OCC_TABLE_PAPER . " WHERE paperid='".$_POST['pid']."'";
		$pr = ocsql_query($pq) or err("Unable to retrieve submission ".mysql_errno());
		if (mysql_num_rows($pr) != 1) { err("Unable to find submission id ".$_POST['pid']); }
		$pl = mysql_fetch_array($pr);
		if ((hashPassword($_POST['pwd'], $pl['password']) != $pl['password']) && (md5($_POST['pwd']) != $pl['password']) && (!OCC_CHAIR_PWD_TRUMPS || (hashPassword($_POST['pwd'], $OC_configAR['OC_chair_pwd']) != $OC_configAR['OC_chair_pwd'])) && (!defined('OCC_SUPERCHAIR_PASSWORD') || (hashPassword($_POST['pwd'], OCC_SUPERCHAIR_PASSWORD) != OCC_SUPERCHAIR_PASSWORD))) {
			warn('Password entered is not valid for submission id ' . safeHTMLstr($_POST['pid']));
			printFooter();
			exit;
		}
	}

	// Check whether we're submitting changes
	if ($_POST['submit'] == "Submit Changes") {
		if ($chair && !validToken('chair')) {
			warn('Invalid submission');
		}
      	$err = '';
		// Check title
		if (($chair || $OC_statusAR['OC_submissions_open'] || !in_array('title', $nonEditFieldsAR)) && !preg_match("/\w+/",$_POST['title'])) {
			$err .= "<li>Enter a submission title</li>";
		}
		// Check that we have a valid contact author & email
		if (!preg_match("/^[1-5]$/",$_POST['contact'])) {
			$err .= "<li>Contact author invalid</li>";
		} else {
	        $contactemail = $_POST['email'.$_POST['contact']];
			if (!preg_match("/\w/",$_POST['name_last'.$_POST['contact']]) || !preg_match("/\w/",$_POST['name_first'.$_POST['contact']])) {
				$err .= "<li>Fill in both the first &amp; last name of the contact author</li>";
			}
			if (!validEmail($contactemail)) {
				$err .= "<li>Contact author email does not seem valid</li>";
			}
		}
		// Check author countries
		for ($c=1; $c<=5; $c++) {
			if ((!isset($_POST['country'.$c]) || empty($_POST['country'.$c])) && isset($_POST['isocountry'.$c]) && !empty($_POST['isocountry'.$c])) {
				$isoUpper = oc_strtoupper($_POST['isocountry'.$c]);
				if (!in_array($isoUpper, array_keys($OC_countryAR))) {
					$err .= "<li>Author " . $c . " (2-letter) ISO country code is not valid</li>";
				} else {
					$_POST['country'.$c] = $OC_countryAR[$isoUpper];
				}
			}
		}
		// Check that we have alternate contact info for contact author
		if (!validEmail($_POST['contactaltemail']) && !preg_match("/\d/",$_POST['contactphone'])) {
			$err .= "<li>Enter a valid alternate email or phone number for contact author</li>";
		}
		// Check student
		if (!preg_match("/^[FT]$/", $_POST['student'])) {
			$err .= "<li>Student selection invalid</li>";
		}
		// Check abstract length?
		// We're not using str_word_count as numbers are not counted.
		if (isset($_POST['abstract']) && isset($OC_configAR['OC_abstractLength']) && ($OC_configAR['OC_abstractLength'] > 0)) {
			$oc_abstractLength = count(explode(' ', preg_replace("/\s+/", " ", trim($_POST['abstract']))));
			if ($oc_abstractLength > $OC_configAR['OC_abstractLength']) {
			  $err .= '<li>Abstract contains ' . $oc_abstractLength . ' words; limit is ' . $OC_configAR['OC_abstractLength'] . ' words.</li>';
			}
		}
		// Check topics
		if (($chair || $OC_statusAR['OC_submissions_open'] || !in_array('topics', $nonEditFieldsAR)) && empty($_POST['topic'])) {
			$err .= "<li>Select at least one topic area</li>";
		}

		if (oc_hookSet('author-edit-validate')) {
			foreach ($GLOBALS['OC_hooksAR']['author-edit-validate'] as $hook) {
				require_once $hook;
			}
		}
		
		// Check password
		if ($_POST['password1'] != $_POST['password2']) {
			$err .= "<li>Passwords entered do not match</li>";
		}

		// errors?
		if ($err) {
	        print '<p><span class="warn">Please go back and check the following:<ul>' . $err . '</ul></span><p />';
		} else { // process edits
			$q = "UPDATE " . OCC_TABLE_PAPER . " SET ";
			if (!empty($_POST['password1'])) {
				$q .= "password='" . hashPassword(stripslashes($_POST['password1'])) . "',";
			}
			if ($chair || $OC_statusAR['OC_submissions_open'] || !in_array('title', $nonEditFieldsAR)) {
				$q .= "title='" . safeSQLstr($_POST['title'])."',";
			}
			if ($chair || $OC_statusAR['OC_submissions_open'] || !in_array('student', $nonEditFieldsAR)) {
				$q .= "student='" . $_POST['student'] . "',";
			}
			$q .= "contactid='" . $_POST['contact'] . "',".
				   "contactemail='" . safeSQLstr(oc_strtolower($_POST['contactaltemail'])) . "',".
				   "contactphone='" . safeSQLstr($_POST['contactphone']) . "',".
				   "lastupdate='" . date("Y-m-d") . "',".
				   "otherauthors='" . safeSQLstr($_POST['otherauthors']) . "',".
				   "keywords='" . safeSQLstr($_POST['keywords']) . "',".
				   "comments='" . safeSQLstr($_POST['comments']) . "',".
				   "abstract='" . safeSQLstr($_POST['abstract']) . "'".
				   " WHERE paperid='" . $_POST['pid'] . "'";
			$r = ocsql_query($q) or err("unable to update submission ".mysql_errno());

			$q = "DELETE FROM " . OCC_TABLE_AUTHOR . " WHERE paperid='" . $_POST['pid'] . "'";
			$r = ocsql_query($q) or err("Unable to update authors (2) - ".mysql_errno());
			for ($i=1;$i<=5;$i++) {
				if (!empty($_POST["name_last$i"])) {
					$q = "INSERT INTO " . OCC_TABLE_AUTHOR . " (paperid,position,name_last,name_first,organization,country,email) VALUES (".
							"'" . $_POST['pid'] . "',".
							"'$i',".
							"'" . safeSQLstr($_POST["name_last$i"]) . "',".
							"'" . safeSQLstr($_POST["name_first$i"]) . "',".
							"'" . safeSQLstr($_POST["org$i"]) . "',".
							"'" . safeSQLstr($_POST["country$i"]) . "',".
							"'" . safeSQLstr($_POST["email$i"]) . "'".
							")";
					$r = ocsql_query($q) or err("unable to update authors or topics".mysql_errno());
	  			}
			}
	
			if ($chair || $OC_statusAR['OC_submissions_open'] || !in_array('topics', $nonEditFieldsAR)) {
				$q = "DELETE FROM " . OCC_TABLE_PAPERTOPIC . " WHERE paperid='".$_POST['pid']."'";
				$r = ocsql_query($q) or err("unable to update topics");
				foreach ($_POST['topic'] as $t) {
  					if (is_numeric($t)) {
						$q = "INSERT INTO " . OCC_TABLE_PAPERTOPIC . " (paperid,topicid) VALUES (" . $_POST['pid'] . ",$t)";
						$r = ocsql_query($q) or err("unable to update topic ".mysql_errno());
					}
					else { err("invalid submission topic - ..$t.."); }
				}
			}

			if (oc_hookSet('author-edit-save')) {
				foreach ($GLOBALS['OC_hooksAR']['author-edit-save'] as $hook) {
					require_once $hook;
				}
			}

			$confirmmsg = '
Submission ID: ' . $_POST['pid'] . '

Title: '.stripslashes($_POST['title']).'
';
			if (($OC_configAR['OC_trackStudent'] == 1) && ($chair || $OC_statusAR['OC_submissions_open'] || !in_array('student', $nonEditFieldsAR))) {
				$confirmmsg .= 'Student: ' . $_POST['student'];
			}
			for ($i=1;$i<=5;$i++) {
				$confirmmsg .= '
Author ' . $i;
			if ($i == $_POST['contact']) { $confirmmsg .= " (CONTACT AUTHOR)"; }
  			$confirmmsg .= '
  Name: ' . stripslashes($_POST["name_first$i"] . " " . $_POST["name_last$i"]) . '
  Org: ' . stripslashes($_POST["org$i"]) . '
  Country: ' . $_POST["country$i"] . '
  Email:' . $_POST["email$i"];
			}
			$confirmmsg .= '
Other Authors: ' . stripslashes($_POST['otherauthors']) . '
Contact Alt Email: ' . $_POST['contactaltemail'] . '
Contact Phone: ' . $_POST['contactphone'] . '
Keywords: ' . stripslashes($_POST['keywords']) . '
Abstract: ' . stripslashes($_POST['abstract']) . '
Comments: ' . stripslashes($_POST['comments']) . '
';

			if (oc_hookSet('author-edit-confirm')) {
				foreach ($GLOBALS['OC_hooksAR']['author-edit-confirm'] as $hook) {
					require_once $hook;
				}
			}

			//confirm it
			print '<p><b>The submission has been updated.	Below is the information submitted.</b></p><pre>' . safeHTMLstr($confirmmsg) . '</pre>';
			if (! $chair) {
				print '<p>A copy has also been emailed to the contact author.  If you notice any problems or do <b>not</b> receive the email within 24 hours, please contact the <a href="mailto:' . $OC_configAR['OC_pcemail'] . '?subject=submission edit problem - ' . $_POST['pid'] . '">Program Chair</a>.</b></p>';
				sendEmail($contactemail, "Submission Update ID " . $_POST['pid'], $confirmmsg, $OC_configAR['OC_notifyAuthorEdit']);
 			}
  		} // else no $err

		printFooter();
		exit;
	} // if Submit Changes
	// Check whether we're retrieving a submission and if so, display filled out form
	elseif ($_POST['submit'] == "Edit Submission") {
		// get paper info
		$eq = "SELECT * FROM " . OCC_TABLE_PAPER . " WHERE paperid='".$_POST['pid']."'";
		$er = ocsql_query($eq) or err("Unable to retrieve submission info - ".mysql_errno());
		$el = mysql_fetch_array($er) or err("Unable to retrieve submission data - ".mysql_errno());
		// get paper authors
		$aq = "SELECT * FROM " . OCC_TABLE_AUTHOR . " WHERE paperid='".$_POST['pid']."'";
		$ar = ocsql_query($aq) or err("Unable to retrieve author info - ".mysql_errno());
		while ($al = mysql_fetch_array($ar)) {
			$authorar[$al['position']]['name_last'] = $al['name_last'];
			$authorar[$al['position']]['name_first'] = $al['name_first'];
			$authorar[$al['position']]['organization'] = $al['organization'];
			$authorar[$al['position']]['country'] = $al['country'];
			$authorar[$al['position']]['email'] = $al['email'];
		}
		// get paper topics
		$ptq = "SELECT * FROM `" . OCC_TABLE_PAPERTOPIC . "` WHERE paperid='" . $_POST['pid'] . "'";
		$ptr = ocsql_query($ptq) or err("Unable to retrieve topic info - " . mysql_errno());
		$papertopicar = array();
		while ($ptl = mysql_fetch_array($ptr)) {
			$papertopicar[] = $ptl['topicid'];
		}

		print '
<form method="post" action="'.$_SERVER['PHP_SELF'].'">
<input type="hidden" name="pid" value="'.$_POST['pid'].'">
';
		if ($chair) {
			print '
<input type="hidden" name="c" value="1">
<input type="hidden" name="token" value="' . $_SESSION[OCC_SESSION_VAR_NAME]['chairtoken'] . '" />
';
		}
		print '
<table border=0 cellspacing=1 cellpadding=5 bgcolor="#dddddd">
<tr><td colspan=3 class="cat">General Information</td></tr>
<tr><td class="item">Submission&nbsp;ID:</td><td colspan=2>'.$el['paperid'].'</td></tr>
<tr>
<td class="item"><label for="form_title">Title:</label></td>
<td colspan=2>';

		if ($chair || $OC_statusAR['OC_submissions_open'] || !in_array('title', $nonEditFieldsAR)) {
			print '<input name="title" id="form_title" size="75" maxlength="250" value="'.safeHTMLstr($el['title']).'">';
		} else {
			print safeHTMLstr($el['title']);
	        print '<input type="hidden" name="title" id="form_title" value="'.safeHTMLstr($el['title']).'">';
		}

		print "</td></tr>\n";

		if ($OC_configAR['OC_trackStudent'] == 1) {
			print '
<tr>
<td class="item" valign="top">Student?</td>
<td colspan=2>';

			if ($chair || $OC_statusAR['OC_submissions_open'] || !in_array('student', $nonEditFieldsAR)) {
				$studoptions = '<input name="student" id="form_studentYes" type="radio" value="T"><label for="form_studentYes">Yes</label> &nbsp; &nbsp;  <input name="student" id="form_studentNo" type="radio" value="F"><label for="form_studentNo">No</label>';
				if ($el['student'] == "T") {
					print preg_replace("/(value=\"T\")/", "$1 checked", $studoptions);
				} else {
					print preg_replace("/(value=\"F\")/", "$1 checked", $studoptions);
				}
				print '
  <br>
  <span class="note">' . $OC_configAR['OC_studentNote'] . '</span>
			';
			} else {
			if ($el['student'] == "T") { print 'Yes'; } else { print 'No'; }
				print '<input type="hidden" name="student" value="F">';
			}
			print '
</td>
</tr>
			';
		} else { // not tracking students
			print '<input type="hidden" name="student" value="F">';
		}

		if (oc_hookSet('author-edit-general')) {
			foreach ($GLOBALS['OC_hooksAR']['author-edit-general'] as $hook) {
				require_once $hook;
			}
		}

		print '
<tr><td colspan=3 class="sep">&nbsp;<br>&nbsp;</td></tr>

<tr><td colspan=3 class="cat">Author(s) Information</td></tr>
';

		$colar = array(1,3,5);
		for ($i=1;$i<=5;$i++) {
			if (in_array($i,$colar)) { $it = "item2"; } else { $it = "item"; }
	 		print '
<tr><td class="' . $it . '" rowspan="' . $authorRowSpan . '">Author ' . $i . '</td>
<td class="' . $it . '">Name:</td>
<td class="' . $it . '">';
			if ($i==1) {
				print '
	<table border=0 cellspacing=0 cellpadding=0>
	<tr><td>
	<input size=33 name="name_first' . $i . '" id="form_name_first' . $i . '" value="'.safeHTMLstr($authorar[$i]['name_first']).'" maxlength=60><br /><span class="note"><label for="form_name_first' . $i . '">First/Given Name</label></span>
	</td><td><nobr> &nbsp; &nbsp; </nobr></td><td>
	<input size=33 name="name_last' . $i . '" id="form_name_last' . $i . '" value="'.safeHTMLstr($authorar[$i]['name_last']).'" maxlength=40><br /><span class="note"><label for="form_name_last' . $i . '">Last/Family Name</label></span>
	</td></tr>
	</table>';
			} else {
				print '
<input size=33 name="name_first' . $i . '" value="' . safeHTMLstr(varValue('name_first', $authorar[$i])) . '" maxlength=60> &nbsp; &nbsp; <input size=33 name="name_last' . $i . '" value="' . safeHTMLstr(varValue('name_last', $authorar[$i])) . '" maxlength=40>';
			}
	
			print '
</td>
</tr>
<tr>
<td class="' . $it . '"><label for="form_org' . $i . '">Organization:</label></td>
<td class="' . $it . '"><input name="org' . $i . '" id="form_org' . $i . '" size=75 maxlength=255 value="' . safeHTMLstr(varValue('organization', $authorar[$i])) . '">';

			if ($i==1) {
				print "<br><span class=\"note\">NOTE: Organization should be your company, university, or similar. Please do not use your department or division, unless it is part of your organization's name such as Interior Department.</span>";
			}
			print '</td>
</tr>
<tr>
<td class="' . $it . '" valign="top"><label for="form_country' . $i . '">Country:</label></td>
<td class="' . $it . '"><input name="isocountry' . $i . '" id="form_country' . $i . '" size="2" title="ISO 2-letter country code" /> <select name="country' . $i . '"><option></option>' . generateSelectOptions($OC_countryAR, varValue('country', $authorar[$i]), FALSE) . '</select>';
			if ($i == 1) {
				print '<br /><span class="note">Enter the 2-letter ISO country code above or select country name from drop-down menu.</span>';
			}
			print '</td>
</tr>
<tr>
<td class="' . $it . '"><label for="form_email' . $i . '">Email:</label></td>
<td class="' . $it . '"><input name="email' . $i . '" id="form_email' . $i . '" size=75 maxlength=100 value="' . safeHTMLstr(varValue('email', $authorar[$i])) . '"></td>
</tr>
';
			if (oc_hookSet('author-submit-author')) {
				foreach ($GLOBALS['OC_hooksAR']['author-submit-author'] as $hook) {
					require $hook;
				}
			}
		} // foreach author

		print '
<tr>
<td class="item" valign="top"><label for="form_otherauthors">Additional<br />Authors:</label></td>
<td colspan=2>
<span class="note">If you have more than 5 authors, please enter the additional information here:</span><br>
<textarea rows=4 cols=70 name="otherauthors" id="form_otherauthors">' . safeHTMLstr($el['otherauthors']) . '</textarea></td>
</tr>
';


if (oc_hookSet('author-edit-authors')) {
	foreach ($GLOBALS['OC_hooksAR']['author-edit-authors'] as $hook) {
		require_once $hook;
	}
}


print '
<tr><td colspan=3 class="sep">&nbsp;<br>&nbsp;</td></tr>

<tr><td colspan=3 class="cat">Contact Author</td></tr>
<tr><td colspan=3><span class="note">
The contact author is the person responsible for correspondence with the program chair. We ask for additional information for the contact author, so that we can ensure timely communication and make the program accurate. We will only contact authors other than the contact author if we are unable to reach the contact author (e.g., because of a bad email address). Please notify us of any changes in names, affiliations, etc. in the contact author\'s information
<p>
Note: If you have more than one email address, please put the second address under "Alternate Email". We will only use that address if there is a problem with the primary email.
</span></td></tr>
<tr>
<td class="item"><label for="form_contact">Contact Author:</label></td>
<td colspan=2><select name="contact" id="form_contact">
';

		$contactoptions = '<option value="1">Author 1</option><option value="2">Author 2</option><option value="3">Author 3</option><option value="4">Author 4</option><option value="5">Author 5</option>';
		$cid=$el['contactid'];
		if (is_numeric($cid)) {
			print preg_replace("/(value=\"$cid\")/", "$1 selected", $contactoptions);
		} else {
			print $contactoptions;
		}

		print '
</select></td>
</tr>
<tr>
<td class="item"><label for="form_contactaltemail">Alternate Email:</label></td>
<td colspan=2><input name="contactaltemail" id="form_contactaltemail" size=50 maxlength=100 value="' . safeHTMLstr($el["contactemail"]) . '"></td>
</tr>
<tr>
<td class="item"><label for="form_contactphone">Telephone:</label></td>
<td colspan=2><input name="contactphone" id="form_contactphone" size=50 maxlength=30 value="'. safeHTMLstr($el["contactphone"]) .'"></td>
</tr>
';


if (oc_hookSet('author-edit-contact')) {
	foreach ($GLOBALS['OC_hooksAR']['author-edit-contact'] as $hook) {
		require_once $hook;
	}
}


print '
<tr><td colspan=3 class="sep">&nbsp;<br>&nbsp;</td></tr>

<tr><td colspan=3 class="cat">Topic Areas</td></tr>
';

		if ($chair || $OC_statusAR['OC_submissions_open'] || !in_array('topics', $nonEditFieldsAR)) {
			print '
<tr><td colspan=3><span class="note">
To help match submissions to reviewers and sessions, please select ';

if ($OC_configAR['OC_multipleSubmissionTopics']) {
	print 'one or more area(s)';
} else {
	print 'one area';
}

print ' most applicable to your submission:
</td></tr>
<tr><td colspan=3>
  <table border=0 cellspacing=0 cellpadding=0><tr><td valign="top">
';

			$i=1;
			if ($OC_configAR['OC_multipleSubmissionTopics']) {
				$type = 'checkbox';
			} else {
				$type = 'radio';
			}
			foreach ($topicAR as $tid => $topic) {
				print '<label><input type="' . $type . '" name="topic[]" value="' . $tid . '"';
				if (isset($papertopicar) && in_array($tid, $papertopicar)) { print " checked"; }
				print ' />' . safeHTMLstr($topic) . '</label>';
				if (($OC_configAR['OC_topicColumns'] == 2) && ($i++ == $half)) {
	  				print "</td><td><nobr> &nbsp; &nbsp; &nbsp; &nbsp; </nobr></td><td valign=\"top\">";
		  		}
				else { print "<br />\n"; }
			}

			print '
  </td></tr></table>
';
		} else {
			print "<tr><td colspan=3><ul>\n";
			$q = "SELECT topicname FROM " . OCC_TABLE_TOPIC . ", " . OCC_TABLE_PAPERTOPIC . " WHERE " . OCC_TABLE_PAPERTOPIC . ".paperid='".$_POST['pid']."' AND " . OCC_TABLE_PAPERTOPIC . ".topicid=" . OCC_TABLE_TOPIC . ".topicid";
			$r = ocsql_query($q) or err("unable to retrieve topic names");
			while ($l=mysql_fetch_array($r)) {
				print "<li>" . safeHTMLstr($l['topicname']) . "</li>\n";
			}
			print "</ul></td></tr>\n";
		}
		print '
</td></tr>
';


if (oc_hookSet('author-edit-topics')) {
	foreach ($GLOBALS['OC_hooksAR']['author-edit-topics'] as $hook) {
		require_once $hook;
	}
}


print '
<tr><td colspan=3 class="sep">&nbsp;<br>&nbsp;</td></tr>

<tr><td colspan=3 class="cat">Content</td></tr>

<tr>
<td class="item"><label for="form_keywords">Keywords:</label></td>
<td colspan=2><input name="keywords" id="form_keywords" size="75" maxlength="250" value="' . safeHTMLstr($el["keywords"]) . '"></td>
</tr>

<tr>
<td class="item" valign="top"><label for="form_abstract">Abstract:</label></td>
<td colspan=2>
<textarea name="abstract" id="form_abstract" rows=6 cols=70>' . safeHTMLstr($el["abstract"]) . '</textarea>
';

if (isset($OC_configAR['OC_abstractLength']) && ($OC_configAR['OC_abstractLength'] > 0)) {
	print '
<br />
<span class="note">Abstract length is limited to ' . $OC_configAR['OC_abstractLength'] . ' words.</span>
<script language="javascript" type="text/javascript">
<!--
var oc_abstractField = document.getElementById("form_abstract");
// Check abstract length
function oc_checkAbstractLength() {
	var oc_abstractContent = oc_abstractField.value.replace(/^\s\s*/, "").replace(/\s\s*$/, "").replace(/\s+/g, " ");
	var oc_abstractFieldLength = oc_abstractContent.split(" ").length;
	if (oc_abstractFieldLength > ' . $OC_configAR['OC_abstractLength'] . ') {
		alert("The abstract is limited to ' . $OC_configAR['OC_abstractLength'] . ' words.  There are currently " + oc_abstractFieldLength + " words.  Please revise.");
	}
}
// Add blur check
if (oc_abstractField.addEventListener) {
	oc_abstractField.addEventListener("blur", oc_checkAbstractLength, false);
} else if (oc_abstractField.attachEvent) {
	oc_abstractField.attachEvent("onblur", oc_checkAbstractLength);
}
// -->
</script>
';
}

print '
</td>
</tr>
';


if (oc_hookSet('author-edit-content')) {
	foreach ($GLOBALS['OC_hooksAR']['author-edit-content'] as $hook) {
		require_once $hook;
	}
}


print '
<tr><td colspan=3 class="sep">&nbsp;<br>&nbsp;</td></tr>

<tr><td colspan=3 class="cat">Change Password</td></tr>

<tr><td colspan=3><span class="note">
Leave these fields blank if you do not want to change your password
</span></td></tr>

<tr>
<td class="item"><label for="form_password1">Password:</label></td>
<td colspan=2><input type="password" name="password1" id="form_password1" size="20" maxlength="30"></td>
</tr>

<tr>
<td class="item"><label for="form_password2">Confirm:</label></td>
<td colspan=2><input type="password" name="password2" id="form_password2" size="20" maxlength="30"></td>
</tr>

<tr><td colspan=3 class="sep">&nbsp;<br>&nbsp;</td></tr>

<tr>
<td valign="top" class="item"><label for="form_comments">Comments<br />to Chair:</label><br /><span class="note">(optional)</span></td>
<td colspan=2><textarea name="comments" id="form_comments" cols=70 rows=4>'.safeHTMLstr($el["comments"]).'</textarea></td>
</tr>
';


if (oc_hookSet('author-edit-comments')) {
	foreach ($GLOBALS['OC_hooksAR']['author-edit-comments'] as $hook) {
		require_once $hook;
	}
}


print '
<tr><td colspan=3 class="sep">&nbsp;<br>&nbsp;</td></tr>

<tr><td colspan=3 valign="top" class="cat">Submission</td></tr>
';

if (! $chair) {
	print '
<tr>
<td colspan=3>
<span class="note">
Please enter your current password and click on the <i>Submit Changes</i> button.
</span>
</td></tr>
<tr><td class="item"><label for="form_pwd">Current&nbsp;Password:</label></td>
<td colspan=2><input type="password" name="pwd" id="form_pwd" size=20 maxlength=250></td></tr>
';
}

print '
<tr><td colspan="3">
<input type="submit" name="submit" value="Submit Changes"></td>
</td></tr>
</table>
</form>
';

		printFooter();
		exit;
	} // elseif Edit Submission
} // if Submission

// display login form by default
print '
<center>
<form method="post" action="' . $_SERVER['PHP_SELF'] . '">
<table border=0 cellspacing=0 cellpadding=5>
<tr><td><b>Submission ID:</b></td><td><input name="pid" size="5" tabindex="1"> ( <a href="email_papers.php">forgot ID?</a> )</td></tr>
<tr><td><b>Password:</b></td><td><input name="pwd" type="password" tabindex="2" size="20" maxlength="255"> ( <a href="reset.php">forgot password?</a> )</td></tr>
</td></tr></table>
<p>
<input type="submit" name="submit" value="Edit Submission" tabindex="3">
</form>
</center>
<p>
<script language="javascript">
<!--
document.forms[0].elements[0].focus();
// -->
</script>

';

printFooter();

exit;

?>
