<?php

// +----------------------------------------------------------------------+
// | OpenConf                                                             |
// +----------------------------------------------------------------------+
// | Copyright (c) 2002-2009 Zakon Group LLC.  All Rights Reserved.       |
// +----------------------------------------------------------------------+
// | This source file is subject to the OpenConf License, available on    |
// | the OpenConf web site: www.OpenConf.com                              |
// +----------------------------------------------------------------------+

require_once "../include.php";
require_once OCC_MIME_FILE;

$printHeader = 'View File';
$printHeaderFunction = 3;

$formatDBFldName = 'format';
$fileDir = $OC_configAR['OC_paperDir'];
$uploadOpen = $OC_statusAR['OC_view_file_open'];

if (oc_hookSet('author-viewfile-preprocess')) {
	foreach ($GLOBALS['OC_hooksAR']['author-viewfile-preprocess'] as $hook) {
		require_once $hook;
	}
}

// Check that we're still open
if (! $uploadOpen) {
	warn('Files may no longer be viewed', $printHeader, $printHeaderFunction);
}

// Check whether this is a submission
if (isset($_POST['submit']) && ($_POST['submit'] == "View File")) {
	// Check inputs
	if (!preg_match("/^\d+$/",$_POST['pid']) || empty($_POST['pwd'])) {
		warn('Please go back and check that the correct submission ID and password were entered.', $printHeader, $printHeaderFunction);
	}

	if (oc_hookSet('author-viewfile-validate')) {
		foreach ($GLOBALS['OC_hooksAR']['author-viewfile-validate'] as $hook) {
			require_once $hook;
		}
	}
	
	// Valid pid/pwd?
	$pq = "SELECT `" . $formatDBFldName . "` AS `format`, `password` FROM `" . OCC_TABLE_PAPER . "` WHERE `paperid`='" . safeSQLstr($_POST['pid']) . "'";
	$pr = ocsql_query($pq) or err("Unable to view file (" . mysql_errno() . ")", $printHeader, $printHeaderFunction);
	if (mysql_num_rows($pr) != 1) {
		warn("Unable to find submission ID " . safeHTMLstr($_POST['pid']), $printHeader, $printHeaderFunction);
	}
	$pl = mysql_fetch_array($pr);
	if ((hashPassword($_POST['pwd'], $pl['password']) != $pl['password']) 
		&& (md5($_POST['pwd']) != $pl['password']) 
		&& (!OCC_CHAIR_PWD_TRUMPS || (hashPassword($_POST['pwd'], $OC_configAR['OC_chair_pwd']) != $OC_configAR['OC_chair_pwd']))
	) {
		warn('Password entered is not valid for submission ID '.$_POST['pid'],$printHeader,$printHeaderFunction);
	}
	
	$filename = $_POST['pid'] . '.' . $pl['format'];

	if (! oc_displayFile($fileDir . $filename, $pl['format'])) {
		warn("File does not exist", $printHeader, $printHeaderFunction);
	}
}

printHeader($printHeader, $printHeaderFunction);

print '
<form method="POST" enctype="multipart/form-data" action="' . $_SERVER['PHP_SELF'] . '">
<table border=0 cellspacing=0 cellpadding=5>
';

if (oc_hookSet('author-viewfile-formtop')) {
	foreach ($GLOBALS['OC_hooksAR']['author-viewfile-formtop'] as $hook) {
		require_once $hook;
	}
}

print '
<tr><td><b>Submission ID:</b></td><td><input name="pid" id="pid" size="5" tabindex="1"> ( <a href="email_papers.php">forgot ID?</a> )</td></tr>
<tr><td><b>Password:</b></td><td><input name="pwd" type="password" size="20" maxlength="255" tabindex="2"> ( <a href="reset.php">forgot password?</a> )</td></tr>
</table>
<p>
<input type="submit" name="submit" value="View File" tabindex="3">
</form>
<p>
<script language="javascript">
<!--
document.getElementById("pid").focus();
// -->
</script>
';

printFooter();

?>
