<?php

// +----------------------------------------------------------------------+
// | OpenConf                                                             |
// +----------------------------------------------------------------------+
// | Copyright (c) 2002-2009 Zakon Group LLC.  All Rights Reserved.       |
// +----------------------------------------------------------------------+
// | This source file is subject to the OpenConf License, available on    |
// | the OpenConf web site: www.OpenConf.com                              |
// +----------------------------------------------------------------------+

require_once "../include.php";

$uploadDir = $OC_configAR['OC_paperDir'];
$uploadOpen = $OC_statusAR['OC_upload_open'];
$extAR = $OC_configAR['OC_extar'];
$notice = $OC_configAR['OC_paperFldNote'];
$formatDBFldName = 'format';

if (OCC_CHAIR_PWD_TRUMPS && isset($_REQUEST['c']) && ($_REQUEST['c'] == 1)) {
	$hdrfn = 1;
	beginChairSession();
	$chair = TRUE;
} else {
	$hdrfn = 3;
	$chair = FALSE;
}

// Print appropriate header
printHeader("Upload File", $hdrfn);

if (oc_hookSet('author-upload-preprocess')) {
	foreach ($GLOBALS['OC_hooksAR']['author-upload-preprocess'] as $hook) {
		require_once $hook;
	}
}

if ($chair) { // display back links
	print '<p style="text-align: center"><a href="../chair/show_paper.php?pid=' . $_REQUEST['pid'] . '">View This Submission</a> | <a href="../chair/list_papers.php">View All Submissions</a></p><br />';
} elseif (! $uploadOpen) { // Check that we're still open
	warn('File upload is not available');
}

// Check whether this is a submission
if (isset($_POST['subaction']) && ($_POST['subaction'] == "Upload File")) {
	if ($chair && !validToken('chair')) {
		warn('Invalid submission');
	}

	// Check inputs
	if (!preg_match("/^\d+$/",$_POST['pid'])
		|| (! $chair && empty($_POST['pwd'])) 
		|| empty($_FILES['paper']['name'])
		|| ! in_array($_POST['format'], $extAR)
	) {
		warn('<form method="post" action="upload.php">Please fill in all fields.  <input type="hidden" name="c" value="' . ($chair ? 1 : 0) . '" /><input type="hidden" name="pid" value="' . safeHTMLstr(varValue('pid', $_POST)) . '" /><input type="submit" value="Try again" /></form>');
	}

	// Set PID to intval in case of leading 0's
	$usepid = intval($_POST['pid']);

	// Retrieve pwd, format, & contact author email
	$pq = "SELECT `" . OCC_TABLE_PAPER . "`.`" . $formatDBFldName . "`, `" . OCC_TABLE_PAPER . "`.`password`, `" . OCC_TABLE_AUTHOR . "`.`email` FROM `" . OCC_TABLE_PAPER . "` LEFT JOIN `" . OCC_TABLE_AUTHOR . "` ON (`" . OCC_TABLE_PAPER . "`.`paperid`=`" . OCC_TABLE_AUTHOR . "`.`paperid` AND `" . OCC_TABLE_PAPER . "`.`contactid`=`" . OCC_TABLE_AUTHOR . "`.`position`) WHERE `" . OCC_TABLE_PAPER . "`.`paperid`='" . $usepid . "'";
	$pr = ocsql_query($pq) or err("Unable to upload file (" . mysql_errno() . ")");
	if (mysql_num_rows($pr) != 1) {
		warn("Unable to find submission ID ".$usepid);
	}
	$pl = mysql_fetch_array($pr);

	// Valid pid/pwd?; check for chair pwd first to save db call
	if (! $chair
		&& (! OCC_CHAIR_PWD_TRUMPS || (hashPassword($_POST['pwd'], $OC_configAR['OC_chair_pwd']) != $OC_configAR['OC_chair_pwd']))
		&& (! defined('OCC_SUPERCHAIR_PASSWORD') || (hashPassword($_POST['pwd'], OCC_SUPERCHAIR_PASSWORD) != OCC_SUPERCHAIR_PASSWORD))
		&& (hashPassword($_POST['pwd'], $pl['password']) != $pl['password'])
		&& (md5($_POST['pwd']) != $pl['password'])
	) {
		warn('Password entered is not valid for submission ID '.$usepid);
	}
	
	// Was a paper successfully loaded & filesize > 0?
	if (!isset($_FILES['paper']['error']) || $_FILES['paper']['error'] || ! is_uploaded_file($_FILES['paper']['tmp_name']) || ($_FILES['paper']['size'] <= 0)) {
		warn('The file failed to load.  Please <a href="upload.php">try again</a>.  If the problem persists, contact the <a href="mailto:' . $OC_configAR['OC_pcemail'] . '?subject=File Upload failed">Program Chair</a>');
	}

	if (oc_hookSet('author-upload-validate')) {
		foreach ($GLOBALS['OC_hooksAR']['author-upload-validate'] as $hook) {
			require_once $hook;
		}
	}
	
	// Delete old file?
	$oldFileName = $uploadDir . $usepid . '.' . $pl[$formatDBFldName];
	oc_deleteFile($oldFileName);

	// Move new file
	$err = 0;
	$newFileName = $uploadDir . $usepid . '.' . $_POST['format'];
	
    // Check whether file uploaded
    if (is_uploaded_file($_FILES['paper']['tmp_name'])
		&& move_uploaded_file($_FILES['paper']['tmp_name'], $newFileName)
	) {
		// Update file permissions
		chmod($newFileName, 0666);

		$confirmmsg = 'Submission ID ' . $usepid . ' has been uploaded.';

		// Set lastupdate date, and format if needed
		$eq = "UPDATE `" . OCC_TABLE_PAPER . "` SET `lastupdate`='" . date("Y-m-d") . "'";
		// also update format if changed
		if ($_POST['format'] != $pl[$formatDBFldName]) {
			$eq .= ", `" . $formatDBFldName . "`='" . safeSQLstr($_POST['format']) . "'";
		}
		$eq .= " WHERE `paperid`='" . $usepid . "'";
		if ( ! ocsql_query($eq)) {
			$confirmmsg .= "\n\nHowever, we were unable to update the format.\n";
			$err = 1;
		}

		if (oc_hookSet('author-upload-preconfirm')) {
			foreach ($GLOBALS['OC_hooksAR']['author-upload-preconfirm'] as $hook) {
				require_once $hook;
			}
		}

		// Send email confirmation
		if ( $OC_configAR['OC_emailAuthorOnUpload'] && ! $chair) {
			$to = $pl['email'];
		} else {
			$to = NULL;
		}

   		sendEmail($to, "Submission ID " . $usepid . " file uploaded", $confirmmsg, $OC_configAR['OC_notifyAuthorUpload']);

		if (!$err) {
			print $confirmmsg;
		} else {
			err($confirmmsg);
		}
	} else { // file failed to upload or move properly
		print '<span class="err">The file failed to load properly.  Please email it directly to the <a href="mailto:' . $OC_configAR['OC_pcemail'] . '?subject=' . $OC_configAR['OC_confName'] . ' File failed - submission ID ' . $usepid . '">Program Chair</a></span><p><hr><p>';
	}

	printFooter();
	exit;
}

print '
<form method="POST" enctype="multipart/form-data" action="upload.php">
';

if ($chair) {
	print '
<input type="hidden" name="c" value="1">
<input type="hidden" name="token" value="' . $_SESSION[OCC_SESSION_VAR_NAME]['chairtoken'] . '" />
<input type="hidden" name="pid" value="' . $_REQUEST['pid'] . '" />
';
}

print '<table border=0 cellspacing=0 cellpadding=5>';

if (oc_hookSet('author-upload-formtop')) {
	foreach ($GLOBALS['OC_hooksAR']['author-upload-formtop'] as $hook) {
		require_once $hook;
	}
}

if (! $chair) {
	print '
<tr id="subid"><td><b>Submission ID:</b></td><td><input name="pid" id="pid" size="5" tabindex="1" value="' . ((isset($_GET['id']) && ctype_digit($_GET['id'])) ? safeHTMLstr($_GET['id']) : '')  . '"> ( <a href="email_papers.php">forgot ID?</a> )</td></tr>
<tr id="pwd"><td><b>Password:</b></td><td><input name="pwd" type="password" size="20" maxlength="255" tabindex="2"> ( <a href="reset.php">forgot password?</a> )</td></tr>
';
} else {
	print '
<div style="display: none;"><div id="subid"></div><div id="pwd"></div></div>
';
}

print '
<tr id="filerow"><td valign="top"><b>File:</b></td><td><input type="file" name="paper" size="30" tabindex="3"> &nbsp; &nbsp; <b><label for="format">Format:</label></b>
';

print '<select name="format" id="format">';
$formatoptions = "";
foreach ($extAR as $fval) {
	$formatoptions .= '<option value="'.$fval.'"> ' . $OC_formatAR[$fval] . '</option>';
}
print $formatoptions;
print "</select><p />\n";

print '
<div class="note3" id="fldnote">' . safeHTMLstr($notice) . '</div>
<div class="note">File limit is ' . $OC_maxFileSize . '.  If your file is larger than ' . $OC_maxFileSize . ', leave the File field empty and contact the <a href="contact.php">Program Chair</a>.</div>
</td></tr>
';

if (oc_hookSet('author-upload-formbottom')) {
	foreach ($GLOBALS['OC_hooksAR']['author-upload-formbottom'] as $hook) {
		require_once $hook;
	}
}

print '
</table>
<p>
<div id="sub"><input type="submit" name="subaction" value="Upload File" tabindex="4"></div>
</form>
<p>
';

printFooter();

?>
