<?php

// +----------------------------------------------------------------------+
// | OpenConf                                                             |
// +----------------------------------------------------------------------+
// | Copyright (c) 2002-2009 Zakon Group LLC.  All Rights Reserved.       |
// +----------------------------------------------------------------------+
// | This source file is subject to the OpenConf License, available on    |
// | the OpenConf web site: www.OpenConf.com                              |
// +----------------------------------------------------------------------+

require_once "../include.php";

beginChairSession();

printHeader("Database Reset",1);

$tableAR=getTables();

// Tables that should not be emptied
$dontEmptyTablesAR = array(OCC_TABLE_ACCEPTANCE, OCC_TABLE_CONFIG, OCC_TABLE_STATUS, OCC_TABLE_TEMPLATE, OCC_TABLE_TOPIC);
if (oc_hookSet('db-reset-dontempty')) {
	foreach ($OC_hooksAR['db-reset-dontempty'] as $t) {
		$dontEmptyTablesAR[] = $t;
	}
}

if (isset($_POST['submit'])) {
	// Check for valid submission
	if (!validToken('chair')) {
		warn('Invalid submission');
	}

	if ($_POST['submit'] == "Confirm Request") {
		foreach ($tableAR as $table) {
			if (isset($_POST['table_'.$table]) && ($_POST['table_'.$table] == 1)) {
				issueSQL("TRUNCATE $table");
			}
		}
		print '<p class="note" style="text-align: center">Selected tables have been emptied</p>';
	} elseif ($_POST['submit'] == "Empty Tables") {
		print '<p><b>Please confirm that you want to empty (truncate) the tables:</b></p><form method="post" action="' . $_SERVER['PHP_SELF'] . '"><input type="hidden" name="token" value="' . $_SESSION[OCC_SESSION_VAR_NAME]['chairtoken'] . '" /><ul>';
		foreach ($tableAR as $table) {
			if (isset($_POST['table_'.$table]) && ($_POST['table_'.$table] == 1)) {

				print '<li>' . $table . '<input type="hidden" name="table_' . $table . '" value="1" /></li>';
			}
		}
		print '</ul><p /><input type="submit" name="submit" value="Confirm Request" /></form><p />';
	} else {
		err("Unknown submit option");
	}
} else {
	print '<p><b>Select tables to empty:</b></p><form method="post" action="' . $_SERVER['PHP_SELF'] . '"><input type="hidden" name="token" value="' . $_SESSION[OCC_SESSION_VAR_NAME]['chairtoken'] . '" />';
	foreach ($tableAR as $table) {
		print '<input type="checkbox" name="table_' . $table . '" value="1" ';
		if (!in_array($table,$dontEmptyTablesAR)) { print ' checked'; }
		print ' /> ' . $table . '<br />';
	}
	print '<p /><input type="submit" name="submit" value="Empty Tables" /></form><p />';
}

printFooter();

?>
