<?php

// +----------------------------------------------------------------------+
// | OpenConf                                                             |
// +----------------------------------------------------------------------+
// | Copyright (c) 2002-2009 Zakon Group LLC.  All Rights Reserved.       |
// +----------------------------------------------------------------------+
// | This source file is subject to the OpenConf License, available on    |
// | the OpenConf web site: www.OpenConf.com                              |
// +----------------------------------------------------------------------+

require_once "../include.php";

beginChairSession();

if (isset($_POST['submit'])) {
	$OC_displayTop = '<a href="' . $_SERVER['PHP_SELF'] . '">New Email</a> &#187; ';
}

printHeader("Email",1);

clearstatcache();

// Additional vars (of interest) available for use in emails
$addvars = 'OC_pcemail, OC_confirmmail, OC_confName, OC_confNameFull, OC_confURL';

// Author comments separator
$commentSeparator = "\n***************************************************************\n";

// Retrieve templates
$templateAR = array();
$q = "SELECT `templateid`, `name`, `module` FROM `" . OCC_TABLE_TEMPLATE . "` ORDER BY `name` ASC";
$r = ocsql_query($q) or err('Unable to retrieve templates');
while ($l = mysql_fetch_assoc($r)) {
	// Skip templates for modules not active
	if (isset($l['module']) && !empty($l['module']) && ($l['module'] != 'OC') && !in_array($l['module'], $OC_activeModulesAR)) {
		continue;
	}
	// Skip PC templates if advocates not used
	if ($OC_configAR['OC_paperAdvocates'] || !preg_match("/^pc_/", $l['templateid'])) {
		$templateAR[$l['templateid']] = $l['name'];
	}
}

// Set up recipients
// authorcommentssql could be replaced with GROUP_CONCAT in sql for MySQL 4.1+
$recipientAR = array();
$specialIndexAR = array(); // tracks which DB col to use for special var handling

$recipientAR['authors_all']['text']	= 'Authors - All';
$recipientAR['authors_all']['sql']	= "SELECT " . OCC_TABLE_PAPER . ".paperid, name_last, name_first, title, email FROM " . OCC_TABLE_PAPER . ", " . OCC_TABLE_AUTHOR . " WHERE " . OCC_TABLE_PAPER . ".paperid=" . OCC_TABLE_AUTHOR . ".paperid AND " . OCC_TABLE_AUTHOR . ".position=" . OCC_TABLE_PAPER . ".contactid ORDER BY paperid";
$recipientAR['authors_all']['vars'] = 'paperid, title, name_last, name_first, email';

if ($OC_configAR['OC_trackStudent']) {
	$recipientAR['authors_students']['text']	= 'Authors - Student submissions';
	$recipientAR['authors_students']['sql']	= "SELECT " . OCC_TABLE_PAPER . ".paperid, name_last, name_first, title, email FROM " . OCC_TABLE_PAPER . ", " . OCC_TABLE_AUTHOR . " WHERE " . OCC_TABLE_PAPER . ".student='T' AND " . OCC_TABLE_PAPER . ".paperid=" . OCC_TABLE_AUTHOR . ".paperid AND " . OCC_TABLE_AUTHOR . ".position=" . OCC_TABLE_PAPER . ".contactid ORDER BY paperid";
	$recipientAR['authors_students']['vars'] = 'paperid, title, name_last, name_first, email';
}

$recipientAR['authors_nofile']['text'] = 'Authors - Missing file';
$recipientAR['authors_nofile']['sql']	= "SELECT " . OCC_TABLE_PAPER . ".paperid, name_last, name_first, title, email FROM " . OCC_TABLE_PAPER . ", " . OCC_TABLE_AUTHOR . " WHERE format is NULL AND " . OCC_TABLE_PAPER . ".paperid=" . OCC_TABLE_AUTHOR . ".paperid AND " . OCC_TABLE_AUTHOR . ".position=" . OCC_TABLE_PAPER . ".contactid ORDER BY paperid";
$recipientAR['authors_nofile']['vars'] = 'paperid, title, name_last, name_first, email';

// acceptance break down
foreach ($OC_acceptanceValuesAR as $idx => $acc) {
	$recipientAR['authors_' . $idx]['text'] = 'Authors - Submission ' . $acc['value'];
	$recipientAR['authors_' . $idx]['sql']	= "SELECT " . OCC_TABLE_PAPER . ".paperid, name_last, name_first, title, email FROM " . OCC_TABLE_PAPER . ", " . OCC_TABLE_AUTHOR . " WHERE " . OCC_TABLE_PAPER . ".accepted='" . safeHTMLstr($acc['value']) . "' AND " . OCC_TABLE_PAPER . ".paperid=" . OCC_TABLE_AUTHOR . ".paperid AND " . OCC_TABLE_AUTHOR . ".position=" . OCC_TABLE_PAPER . ".contactid ORDER BY paperid";
	$recipientAR['authors_' . $idx]['vars'] = 'paperid, title, name_last, name_first, email, author-comments';
	$recipientAR['authors_' . $idx]['special'] = 'email-authors.inc';
}

if ($OC_configAR['OC_paperAdvocates']) {
	$recipientAR['reviewer_pc_all']['text'] = 'Review and Program Committee Members - All';
	$recipientAR['reviewer_pc_all']['text'] = 'Review and Program Committee Members - All';
	$recipientAR['reviewer_pc_all']['sql']	= "SELECT reviewerid, name_last, name_first, username, email FROM " . OCC_TABLE_REVIEWER . " ORDER BY reviewerid";
	$recipientAR['reviewer_pc_all']['vars'] = 'name_last, name_first, username, email';

	$recipientAR['reviewers_all']['text'] = 'Reviewers - All (except Program Committee members)';
} else {
	$recipientAR['reviewers_all']['text'] = 'Reviewers - All';
}
$recipientAR['reviewers_all']['sql']	= "SELECT reviewerid, name_last, name_first, username, email FROM " . OCC_TABLE_REVIEWER . " WHERE onprogramcommittee='F' ORDER BY reviewerid";
$recipientAR['reviewers_all']['vars'] = 'name_last, name_first, username, email';

$recipientAR['reviewers_noreview']['text'] = 'Reviewers - Reviews not yet completed or no recommendation';
$recipientAR['reviewers_noreview']['sql']	= "SELECT " . OCC_TABLE_REVIEWER . ".reviewerid, name_last, name_first, username, email FROM " . OCC_TABLE_REVIEWER . ", " . OCC_TABLE_PAPERREVIEWER . " WHERE (" . OCC_TABLE_PAPERREVIEWER . ".completed != 'T' OR " . OCC_TABLE_PAPERREVIEWER . ".recommendation IS NULL) AND " . OCC_TABLE_PAPERREVIEWER . ".reviewerid=" . OCC_TABLE_REVIEWER . ".reviewerid GROUP BY reviewerid ORDER BY reviewerid";
$recipientAR['reviewers_noreview']['vars'] = 'name_last, name_first, username, email';

$recipientAR['reviewers_nocomment']['text'] = 'Reviewers - Missing author comments';
$recipientAR['reviewers_nocomment']['sql']	= "SELECT " . OCC_TABLE_REVIEWER . ".reviewerid, name_last, name_first, username, email FROM " . OCC_TABLE_REVIEWER . ", " . OCC_TABLE_PAPERREVIEWER . " WHERE " . OCC_TABLE_PAPERREVIEWER . ".authorcomments IS NULL AND " . OCC_TABLE_PAPERREVIEWER . ".reviewerid=" . OCC_TABLE_REVIEWER . ".reviewerid GROUP BY reviewerid ORDER BY reviewerid";
$recipientAR['reviewers_nocomment']['vars'] = 'name_last, name_first, username, email';

if ($OC_configAR['OC_paperAdvocates']) {
	$recipientAR['pc_all']['text'] = 'Program Committee - All';
	$recipientAR['pc_all']['sql']	= "SELECT reviewerid, name_last, name_first, username, email FROM " . OCC_TABLE_REVIEWER . " WHERE onprogramcommittee='T' ORDER BY reviewerid";
	$recipientAR['pc_all']['vars'] = 'name_last, name_first, username, email';

	$recipientAR['pc_norecommendation']['text'] = 'Program Committee - Missing advocate recommendation';
	$recipientAR['pc_norecommendation']['sql']	= "SELECT " . OCC_TABLE_REVIEWER . ".reviewerid, name_last, name_first, username, email FROM " . OCC_TABLE_REVIEWER . ", " . OCC_TABLE_PAPERADVOCATE . " WHERE " . OCC_TABLE_PAPERADVOCATE . ".adv_recommendation is NULL and " . OCC_TABLE_PAPERADVOCATE . ".advocateid=" . OCC_TABLE_REVIEWER . ".reviewerid GROUP BY reviewerid ORDER BY reviewerid";
	$recipientAR['pc_norecommendation']['vars'] = 'name_last, name_first, username, email';
}

// Check for addt'l (hook) recipients
if (oc_hookSet('chair-email-recipient')) {
	foreach ($OC_hooksAR['chair-email-recipient'] as $f) {
		require_once $f;
	}
}

// Get sorted list of recipients
$recipients = array();
foreach ($recipientAR as $k => $v) {
	$recipients[$v['text']] = $k;
}
ksort($recipients);

function saveTemplate($subject, $body, $templateid) {
	$q = "UPDATE `" . OCC_TABLE_TEMPLATE . "` SET `subject`='" . safeSQLstr($subject) . "', `body`='" . safeSQLstr($body) . "' WHERE `templateid`='" . safeSQLstr($templateid) . "'";
	ocsql_query($q) or err('Unable to save template');
}

function showAddresses($recipient, $sql) {
	$r = ocsql_query($sql) or err("Unable to retrieve emails " . mysql_errno());
    if (mysql_num_rows($r) == 0) {
        print '<p class="warn">No email addresses available for ' . $recipient . '</p>';
    } else {
	    print '<p><b>Email addresses for ' . $recipient . ':</b></p>';
        while ($l = mysql_fetch_array($r)){
            print $l['email'] . "<br />\n";
		}
    }
}

function specialValue($a1, $a2) {
	global $specialIndexAR, $l;
	$varName = $a1 . $a2;
	if (!empty($varName) && isset($specialIndexAR[$varName]) && isset($l[$specialIndexAR[$varName]]) && isset($GLOBALS[$varName][$l[$specialIndexAR[$varName]]])) {
		return($GLOBALS[$varName][$l[$specialIndexAR[$varName]]]);
	} else {
		return('');
	}
}

if (isset($_POST['submit'])) {
	// Check for valid submission
	if (!validToken('chair')) {
		warn('Invalid submission');
	}
	// Verify recipient
	if (!in_array($_POST['recipient'],$recipients)) {
		err("Recipient unknown");
	}

    // Verify template
    if (!empty($_POST['template']) && !in_array($_POST['template'], array_keys($templateAR))) {
        err("Invalid template");
    }

	// Which message should we use?
	if (isset($_POST['message'])) {
		$subject = stripslashes($_POST['subject']);
		$message = stripslashes($_POST['message']);

        // YMMV wrt below
        $message = preg_replace("/\r/","",$message);

		// Save template?
		if (!empty($_POST['template']) && isset($_POST['save']) && ($_POST['save'] == "yes")) {
		    saveTemplate($subject, $message, $_POST['template']);
		}
	} elseif (!empty($_POST['template'])) {
		// retrieve template
		$q = "SELECT `subject`, `body` FROM `" . OCC_TABLE_TEMPLATE . "` WHERE `templateid`='" . safeSQLstr($_POST['template']) . "'";
		$r = ocsql_query($q) or err('Unable to retrieve template');
		if (mysql_num_rows($r) != 1) {
			warn('Template not found');
		}
		$l = mysql_fetch_assoc($r);
   		$subject = $l['subject'];
		$message = $l['body'];
	} else {
		$message = "";
		$subject = "";
	}
	
	// Which submit?
	// List Email addresses
	if ($_POST['submit'] == "List Email Addresses") {
		showAddresses($recipientAR[$_POST['recipient']]['text'], $recipientAR[$_POST['recipient']]['sql']);
	} 
	// Send Email
	elseif ($_POST['submit'] == "Send Message") {
		$r = ocsql_query($recipientAR[$_POST['recipient']]['sql']) or err("Unable to retrieve information to email");
		if (mysql_num_rows($r) == 0) {
		    err("No email addresses found (send)");
		}
		
		// Special var handling
		if (isset($recipientAR[$_POST['recipient']]['special']) && is_file($recipientAR[$_POST['recipient']]['special'])) {
			require_once $recipientAR[$_POST['recipient']]['special'];
		}
		
		// Individual recipients?
		if (isset($_POST['select_recipients']) && ($_POST['select_recipients'] == 1)) {
			if (! isset($_POST['selected_recipients']) || empty($_POST['selected_recipients'])) {
				warn('No recipients selected');
			}
			$selectRecipients = true;
		} else {
			$selectRecipients = false;
		}
		
		// Log it
		$logq = "INSERT INTO `" . OCC_TABLE_LOG . "` SET `datetime`=UTC_TIMESTAMP(), `type`='email', `entry`='Email sent to ";
		if ($selectRecipients) {
			$logq .= ($extra = implode(", ", $_POST['selected_recipients']));
		} else {
			$logq .= ($extra = $recipientAR[$_POST['recipient']]['text']);
		}
		$extra .= "\nSubject: " . $subject . "\n\n" . $message;
		$logq .= "', `extra`='To: " . safeSQLstr($extra) . "'";
		ocsql_query($logq);
		
		// Send out emails
		$to = $tmpmessage = $tmpsubject = '';
		while ($l = mysql_fetch_array($r)) {
			if (empty($l['email'])) {
				continue;
			} elseif ($selectRecipients && !in_array($l['email'], $_POST['selected_recipients'])) {
				continue;
			}
			
			$tmpsubject = $subject;
			$tmpmessage = $message;
			// Replace config vars
			$tmpsubject = preg_replace("/\[:([A-Z]\w+):\]/e", "\$OC_configAR['\\1']", $tmpsubject);
			$tmpmessage = preg_replace("/\[:([A-Z]\w+):\]/e", "\$OC_configAR['\\1']", $tmpmessage);
			// Replace other vars
			$tmpsubject = preg_replace("/\[:(\w+):\]/e", "\$l['\\1']", $tmpsubject);
			$tmpmessage = preg_replace("/\[:(\w+):\]/e", "\$l['\\1']", $tmpmessage);
			// Replace special vars (\w-\w)
			if (isset($recipientAR[$_POST['recipient']]['special'])) {
				$tmpmessage = preg_replace("/\[:(\w+)-(\w+):\]/e", "specialValue('$1','$2')", $tmpmessage);
			}

            // YMMV wrt below
            $tmpmessage = preg_replace("/\r/","",$tmpmessage);

			$to = $l['email']; // req'd for OC_mailCopyLast code block below
			print 'emailing ' . $l['email'] . ' (' . $l[0] . ') ... ';
			if (oc_mail($l['email'], $tmpsubject, $tmpmessage)) {
				print "success<br />\n";
			} else {
				print "<span class=\"err\">FAILED!!!</span><br />\n";
			}
		}
		
		// Email chair a copy of last email sent
		if ($OC_configAR['OC_mailCopyLast']) {
			$msg = "To: " . $to . "\nSubject: " . $tmpsubject . "\n\n" . $tmpmessage . "\n";
			if (sendEmail($OC_configAR['OC_confirmmail'], 'Copy of last email sent', $msg)) {
				print '<p>A copy of the last message sent has been forwarded to ' . $OC_configAR['OC_confirmmail'] . '.</p>';
			} else {
				print '<p class="err">The system was unable to forward a copy of the last message sent to ' . $OC_configAR['OC_confirmmail'] . '.</p>';
			}
		}
	}
	// Preview Email
	elseif ($_POST['submit'] == "Preview Message") {
		$q = $recipientAR[$_POST['recipient']]['sql'] . " LIMIT 1";
		if (isset($_POST['selected_recipients']) && !empty($_POST['selected_recipients'])) {
			$q = preg_replace("/ WHERE /", " WHERE `email`='" . safeSQLstr($_POST['selected_recipients'][0]) .  "' AND ", $q);
		}
		$r = ocsql_query($q) or err("Unable to retrieve information to preview");
		if (mysql_num_rows($r) == 0) {
		    err("No email addresses found (preview)");
		}

		$l = mysql_fetch_array($r);
		
		// Special var handling
		if (isset($recipientAR[$_POST['recipient']]['special']) && is_file($recipientAR[$_POST['recipient']]['special'])) {
			require_once $recipientAR[$_POST['recipient']]['special'];
		}
		
		print '
<form method="post" action="' . $_SERVER['PHP_SELF'] . '">
<input type="hidden" name="token" value="' . $_SESSION[OCC_SESSION_VAR_NAME]['chairtoken'] . '" />
<input type="hidden" name="recipient" value="' . safeHTMLstr($_POST['recipient']) . '">
<input type="hidden" name="template" value="' . safeHTMLstr($_POST['template']) . '">
<input type="hidden" name="subject" value="' . safeHTMLstr($subject) . '">
<input type="hidden" name="message" value="' . safeHTMLstr($message) . '">
';
		if (isset($_POST['select_recipients']) && ($_POST['select_recipients'] == 1)) {
			print '<input type="hidden" name="select_recipients" value="1" />';
			if (isset($_POST['selected_recipients'])) {
				foreach ($_POST['selected_recipients'] as $selected_recipient) {
					print '<input type="hidden" name="selected_recipients[]" value="' . safeHTMLstr($selected_recipient) . '" />';
				}
			}
		}
		print '
<input type="submit" name="submit" value="Edit Message">
&nbsp; &nbsp; &nbsp;
<input type="submit" name="submit" value="Send Message">
</form>
<pre>
';		

		$tmpsubject = $subject;
		$tmpmessage = $message;
		// Replace config vars
		$tmpsubject = preg_replace("/\[:([A-Z]\w+):\]/e", "\$OC_configAR['\\1']", $tmpsubject);
		$tmpmessage = preg_replace("/\[:([A-Z]\w+):\]/e", "\$OC_configAR['\\1']", $tmpmessage);
		// Replace other vars
		$tmpsubject = preg_replace("/\[:(\w+):\]/e", "\$l['\\1']", $tmpsubject);
		$tmpmessage = preg_replace("/\[:(\w+):\]/e", "\$l['\\1']", $tmpmessage);
		// Replace special vars (\w-\w)
		if (isset($recipientAR[$_POST['recipient']]['special'])) {
			$tmpmessage = preg_replace("/\[:(\w+)-(\w+):\]/e", "specialValue('$1','$2')", $tmpmessage);
		}
		
		// strip extra returns from headers
		$headers = safeHTMLstr(preg_replace("/[\r\n]+/","\n", $OC_configAR['OC_mailHeaders']));
		// Show headers & msg
		print preg_replace("/([\w-]+\:)/","<b>$1</b>",$headers) . "\n";
		print '<b>To:</b> ';
		if (isset($_POST['select_recipients']) && ($_POST['select_recipients'] == 1)) {
			if (! isset($_POST['selected_recipients']) || empty($_POST['selected_recipients'])) {
				warn('No recipients selected');
			}
			print safeHTMLstr(implode("\n    ", $_POST['selected_recipients']));
		} else {
			print safeHTMLstr($l['email']);
		}
		print "\n";
		print '<b>Subject:</b> ' . safeHTMLstr($tmpsubject) . "\n\n";
		print safeHTMLstr(wordwrap($tmpmessage, $OC_configAR['OC_emailWrap'])) . "\n</pre>\n";
	} 
	// Write Email
	elseif (($_POST['submit'] == "Write Email Online") || ($_POST['submit'] == "Edit Message")) {
		// Valid recipient?
		if (!in_array($_POST['recipient'],$recipients)) {
			err("Unknown recipient group selected");
		}
        // Any addresses
	    $r = ocsql_query($recipientAR[$_POST['recipient']]['sql']) or err("Unable to retrieve email addresses " . mysql_errno());
        if (mysql_num_rows($r) == 0) {
            print '<p class="warn">No email addresses available for ' . $recipientAR[$_POST['recipient']]['text'] . '</p>';
        } else {
	
		    print '
<form method="post" action="' . $_SERVER['PHP_SELF'] . '">
<input type="hidden" name="token" value="' . $_SESSION[OCC_SESSION_VAR_NAME]['chairtoken'] . '" />
<input type="hidden" name="recipient" value="' . safeHTMLstr($_POST['recipient']) . '">
<input type="hidden" name="template" value="' . safeHTMLstr($_POST['template']) . '">
<table border=0 cellspacing=10 cellpadding=0>
<tr><td><b>From:</b></td><td>' . safeHTMLstr($OC_configAR['OC_pcemail']) . '</td><td>&nbsp;</td></tr>
<tr><td valign="top"><b>To:</b></td><td>';

			if (isset($_POST['select_recipients']) && ($_POST['select_recipients'] == 1)) {
				print '<input type="hidden" name="select_recipients" value="1" /><select name="selected_recipients[]" size="10" multiple>';
				if (! isset($_POST['selected_recipients'])) {
					$_POST['selected_recipients'] = array();
				}
				while ($l = mysql_fetch_assoc($r)) {
					if (empty($l['email'])) { continue; }
					if (isset($l['name'])) {
						$name = $l['name'];
					} elseif (isset($l['name_last'])) {
						$name = $l['name_first'] . ' ' . $l['name_last'];
					}
					if (isset($l['paperid'])) {
						$extra = '[ID: ' . $l['paperid'] . '] ';
					} elseif (isset($l['reviewerid'])) {
						$extra = '[ID: ' . $l['reviewerid'] . '] ';
					} else {
						$extra = '';
					}
					print '<option value="' . safeHTMLstr($l['email']) . '"' . (in_array($l['email'], $_POST['selected_recipients']) ? ' selected' : '') . '>' . $extra . $l['email'] . ' (' . safeHTMLstr($name) . ')</option>';
				}
				print '</select>';
			} else {
				print safeHTMLstr($recipientAR[$_POST['recipient']]['text']);
			}

			print '</td><td>&nbsp;</td></tr>
<tr><td><b>Subject:</b></td><td><input name="subject" size="60" value="' . safeHTMLstr($subject) . '"></td><td>&nbsp;</td></tr>
<tr><td colspan=3><b>Message:</b></td></tr>
<tr>
<td colspan=2><textarea name="message" rows=15 cols=60>' . safeHTMLstr($message) . '</textarea></td>
<td valign="top"><p><b>[:<i>variables</i>:]</b></p>&#8226;&nbsp; ' . preg_replace("/, /","<br />&#8226;&nbsp; ",$recipientAR[$_POST['recipient']]['vars'] . ", " . $addvars) . '</td>
</tr>';

		    // Save template?
		    if (!empty($_POST['template'])) {
			    print '<tr><td colspan=3><p><label><input type="checkbox" name="save" value="yes"> Check this box to save changes to template file</label></p></td></tr>';
		    }

		    print '
<tr><td colspan=3>
<br />
<input type="submit" name="submit" value="Preview Message">
&nbsp; &nbsp; &nbsp;
<input type="submit" name="submit" value="Send Message">
</td></tr>
</table>
</form>
<p class="note">TIP: The variables appearing next to the message field may be used in your email by enclosing each instance in [:<i>variable</i>:] .  These will be substituted for their value prior to the email being sent.  For example, to include the conference (short) name in your message use [:OC_confName:] .</p>
    ';
        } // if Any emails
    } // end submit write
} // end submit
// Not a submit - select recipient/template
else {	
	print '
<script language="javascript">
<!--
function selectTemplate(tmpl) {
	if (document.getElementById) {
		if (document.getElementById(tmpl)) {
			document.getElementById(tmpl).selected = true;
		} else {
			document.getElementById("blank").selected = true;
		}
	}
}
// -->
</script>
<form method="post" action="' . $_SERVER['PHP_SELF'] . '">
<input type="hidden" name="token" value="' . $_SESSION[OCC_SESSION_VAR_NAME]['chairtoken'] . '" />
<dl>
<dt><p><b>Select the recipient group you would like to email:</b></dt></p>
<dd><p><select name="recipient" onChange="selectTemplate(this.options[this.selectedIndex].value)">
';

	foreach ($recipients as $r) {
		print '<option value="' . $r . '"';
		if ($r == 'blank') {
			print ' disabled="disabled" style="font-style: italic; fot-weight: bold;"';
		}
		print '>' . $recipientAR[$r]['text'] . "</option>\n";
	}

	print '
</select></p>
<p style="padding-left: 50px"><label><input type="checkbox" name="select_recipients" value="1" /> Select individual recipients</label></p>
</dd>
<dd class="note">For authors, only the contact author of a submission will be emailed</dd>

<dt><p><b>Select an email template to use:</b></dt></p>
<dd><p><select name="template">
<option value="" id="blank">Blank Email</option>
';

	foreach ($templateAR as $k => $v) {
		print '<option value="' . $k . '" id="' . $k . '">' . $v . "</option>\n";
	}

	print '
</select></p></dd>

<dt>
<br />
<input type="submit" name="submit" value="Write Email Online">
&nbsp; &nbsp; &nbsp;
<input type="submit" name="submit" value="List Email Addresses">
</dt>
</dl>
</form>
';

} // else not a submit

printFooter();

?>
