<?php

// +----------------------------------------------------------------------+
// | OpenConf                                                             |
// +----------------------------------------------------------------------+
// | Copyright (c) 2002-2009 Zakon Group LLC.  All Rights Reserved.       |
// +----------------------------------------------------------------------+
// | This source file is subject to the OpenConf License, available on    |
// | the OpenConf web site: www.OpenConf.com                              |
// +----------------------------------------------------------------------+

require_once "../include.php";

beginChairSession();

// accepted or all papers?
if (isset($_REQUEST['acc']) && preg_match("/\d+/", $_REQUEST['acc']) && isset($OC_acceptanceValuesAR[$_REQUEST['acc']])) {
	$accSQL = "AND " . OCC_TABLE_PAPER . ".accepted='" . safeSQLstr($OC_acceptanceValuesAR[$_REQUEST['acc']]['value']) . "'";
	$accURL = 'acc=' . $_REQUEST['acc'];
	$scope = 'Submissions marked to ' . safeHTMLstr($OC_acceptanceValuesAR[$_REQUEST['acc']]['value']);
}
else {
	$accSQL = '';
	$accURL = '';
	$scope = "All Submissions";
}

function exporterr($e) {
	global $scope;
	err($e, 'Export ' . $scope, 1);
}

$skip = 1;

// These will require special processing to break out for each author
$authorFieldsAR = array(
	'skip' . $skip++	=> '',
	'author_name'		=> 'All Authors Full Name',
	'author_name_first' => 'All Authors First Name',
	'author_name_last'	=> 'All Authors Last Name',
	'author_email' 		=> 'All Authors Email',
	'author_organization' => 'All Authors Organization',
	'author_country'	=> 'All Authors Country'
);

$fieldAR = array(
	'paperid'    		=> 'Submission ID',
    'accepted'          => 'Acceptance',
	'title' 			=> 'Title',
	'student'   		=> 'Student Submission (T/F)',
	'abstract'			=> 'Abstract',
	'skip' . $skip++	=> '',
	'name'				=> 'Contact Author Full Name',
	'name_first'     	=> 'Contact Author First Name',
	'name_last'			=> 'Contact Author Last Name',
	'email' 			=> 'Contact Author Email',
	'organization'		=> 'Contact Author Organization',
	'country'			=> 'Contact Author Country',
	'contactphone'      => 'Contact Author Phone',
	'contactemail'		=> 'Contact Author Alternate Email',
);

$fieldAR = array_merge($fieldAR, $authorFieldsAR);

$fieldAR['skip' . $skip++]	= '';
$fieldAR['otherauthors'] = 'Other Authors';
$fieldAR['skip' . $skip++]	= '';

if (! $OC_configAR['OC_trackStudent']) {
	unset($fieldAR['student']);
}

// Default list of checked fields
$checkedFieldAR = array('paperid','title','name','email');

// Include extra fields
if (oc_hookSet('chair-export-fields')) {
	foreach ($OC_hooksAR['chair-export-fields'] as $v) {
		require_once $v;
	}
}

if (isset($_POST['submit']) && ($_POST['submit'] == "Generate File") && isset($_POST['fields']) && !empty($_POST['fields'])) {
	// Check for valid submission
	if (!validToken('chair')) {
		warn('Invalid submission');
	}
	// Verify Fields
	$fieldARkeys = array_keys($fieldAR);
	foreach ($_POST['fields'] as $f) {
		if (!in_array($f,$fieldARkeys)) {
			exporterr('Invalid field name selection');
		}
	}
	
	// Init extra field AR
	$extraAR = array();

	// List of fields to export
	$exportFieldsAR = $_POST['fields'];

	// All author data to display
	$incAuthorFieldsAR = array_intersect($_POST['fields'], array_keys($authorFieldsAR));
	if (!empty($incAuthorFieldsAR)) {
		$maxPosition = 1; // tracks max number of authors per submission
		
		// Get all authors info
		$q = "SELECT `" . OCC_TABLE_AUTHOR . "`.*, CONCAT_WS(' ', `" . OCC_TABLE_AUTHOR . "`.`name_first`, `" . OCC_TABLE_AUTHOR . "`.`name_last`) AS `name` FROM `" . OCC_TABLE_AUTHOR . "`, `" . OCC_TABLE_PAPER . "` WHERE `" . OCC_TABLE_PAPER . "`.`paperid`=`" . OCC_TABLE_AUTHOR . "`.`paperid` " . $accSQL . " ORDER BY `paperid`, `position`";
		$r = mysql_query($q) or exporterr("Unable to retrieve data for export (1)");
		while ($l = mysql_fetch_assoc($r)) {
			foreach ($authorFieldsAR as $afKey => $afVal) {
				if (preg_match("/^author_(\w+)$/", $afKey, $matches)) {
					$extraAR[$l['paperid']]['_' . $afKey . $l['position']] = $l[$matches[1]];
				}
			}
			if ($l['position'] > $maxPosition) {
				$maxPosition = $l['position'];
			}
		}

		$newAuthorFieldsAR = array();
		for ($i=1; $i<=$maxPosition; $i++) {
			foreach($incAuthorFieldsAR as $f) {
				$newAuthorFieldsAR[] = '_' . $f . $i;
			}
		}
		reset($incAuthorFieldsAR);
		array_splice(
			$exportFieldsAR, 
			array_search(current($incAuthorFieldsAR), $_POST['fields']),
			count($incAuthorFieldsAR), 
			$newAuthorFieldsAR
		);
	
	}

	// Get extra fields data
	if (oc_hookSet('chair-export-data')) {
		foreach ($OC_hooksAR['chair-export-data'] as $v) {
			require_once $v;
		}
	}

	// Get sub. data & iterate through each
	$q = "SELECT " . OCC_TABLE_PAPER . ".paperid, " . OCC_TABLE_PAPER . ".accepted, " . OCC_TABLE_PAPER . ".title, " . OCC_TABLE_PAPER . ".student, " . OCC_TABLE_PAPER . ".abstract, " . OCC_TABLE_PAPER . ".otherauthors, " . OCC_TABLE_PAPER . ".contactphone, " . OCC_TABLE_PAPER . ".contactemail, " . OCC_TABLE_AUTHOR . ".name_first, " . OCC_TABLE_AUTHOR . ".name_last, CONCAT_WS(' '," . OCC_TABLE_AUTHOR . ".name_first," . OCC_TABLE_AUTHOR . ".name_last) AS name, " . OCC_TABLE_AUTHOR . ".organization, " . OCC_TABLE_AUTHOR . ".country, " . OCC_TABLE_AUTHOR . ".email FROM " . OCC_TABLE_PAPER . ", " . OCC_TABLE_AUTHOR . " WHERE " . OCC_TABLE_PAPER . ".paperid=" . OCC_TABLE_AUTHOR . ".paperid AND " . OCC_TABLE_AUTHOR . ".position=" . OCC_TABLE_PAPER . ".contactid ". $accSQL .  " ORDER BY " . OCC_TABLE_PAPER . ".paperid";
	$r = ocsql_query($q) or exporterr("Unable to retrieve data for export");
	if (mysql_num_rows($r) == 0) {
		warn("There are no papers to export",'Export ' . $scope . ' Papers',1);
		exit;
 	} else {  // Export file
		$fileName = 'openconf';
		if (preg_match("/^\w+$/", $OC_configAR['OC_confName'])) {
			$fileName .= '-' . $OC_configAR['OC_confName'];
		}
		$fileName .= '-' . oc_strtolower($scope) . '-' . date('YmdHi') . '.csv';
        header("Expires: Mon, 18 Sep 2003 13:00:00 GMT");
		header("Last-Modified: " . gmdate("D, d M Y H:i:s") . " GMT");
		header("Cache-Control: no-store, no-cache, must-revalidate");
		header("Cache-Control: post-check=0, pre-check=0", false);
		header("Pragma: no-cache");
		header('Content-Type: text/plain');
		header('Content-Disposition: attachment; filename="' . $fileName . '"');

		// Title Row
		$titlerow = "\"" . implode('","',$exportFieldsAR) . "\"";
		print oc_strtoupper(rtrim($titlerow, ",")) . "\r\n";

		// Iterate through records
		while ($l = mysql_fetch_array($r)) {
			$row = '';
			// Add non-author/extra fields to row
			foreach ($exportFieldsAR as $f) {
				if (preg_match("/^_/", $f)) {
					$row .= '"' . (isset($extraAR[$l['paperid']][$f]) ? str_replace("\"", "\"\"", $extraAR[$l['paperid']][$f]) : '') . '",';
				} else {
					$row .= '"' . str_replace("\"", "\"\"", $l[$f]) . '",';
				}
			}

			$row = preg_replace("/\015(\012)?/", "\012", $row);
			print rtrim($row, ',') . "\015\012";
		}
		exit;
	}
	
}

// Display form
printHeader('Export ' . $scope, 1);

print '
<form method="post" action="' . $_SERVER['PHP_SELF'] . '?' . $accURL . '">
<input type="hidden" name="token" value="' . $_SESSION[OCC_SESSION_VAR_NAME]['chairtoken'] . '" />
<p>Export will generate a comma-delimited (CSV) file containing the checked fields below with one submission per row.<br />
Note: When opening the file in a spreadsheet, you may need to specify the file encoding &#8211; UTF-8.<br />
Note: When selecting All Authors, each author\'s data will appear in separate columns.</p>
<p style="font-weight: bold">Select Fields to Export:</p>
';

foreach ($fieldAR as $fieldID => $fieldName) {
	if (preg_match("/^skip\d+$/", $fieldID)) {
		print '<p />';
		continue;
	}
	print '<input type="checkbox" name="fields[]" value="' . $fieldID . '" ';
	if (in_array($fieldID,$checkedFieldAR)) { print 'checked '; }
	print '/> ' . $fieldName . "<br />\n";
}

print '
<p><input type="submit" name="submit" value="Generate File" /></p>
</form>
';

printFooter();

?>
