<?php

// +----------------------------------------------------------------------+
// | OpenConf                                                             |
// +----------------------------------------------------------------------+
// | Copyright (c) 2002-2009 Zakon Group LLC.  All Rights Reserved.       |
// +----------------------------------------------------------------------+
// | This source file is subject to the OpenConf License, available on    |
// | the OpenConf web site: www.OpenConf.com                              |
// +----------------------------------------------------------------------+

require_once "../include.php";

beginChairSession();

$skip = 1;

$fieldAR = array(
	'reviewerid'   		=> 'Reviewer ID',
	'name'				=> 'Full Name',
	'name_first'     	=> 'First Name',
	'name_last'			=> 'Last Name',
	'email' 			=> 'Email',
	'organization'		=> 'Organization',
	'country'			=> 'Country',
	'telephone'    		=> 'Phone'
);

if ($OC_configAR['OC_paperAdvocates']) {
	$fieldAR['onprogramcommittee'] = 'PC/Advocate';
}

// Default list of checked fields
$checkedFieldAR = array('reviewerid','name','email','organization','country','telephone');

// Include extra fields
if (oc_hookSet('chair-export_reviewers-fields')) {
	foreach ($OC_hooksAR['chair-export_reviewers-fields'] as $v) {
		require_once $v;
	}
}

if (isset($_POST['submit']) && ($_POST['submit'] == "Generate File") && isset($_POST['fields']) && !empty($_POST['fields'])) {
	// Check for valid submission
	if (!validToken('chair')) {
		warn('Invalid submission');
	}
	// Verify Fields
	$fieldARkeys = array_keys($fieldAR);
	foreach ($_POST['fields'] as $f) {
		if (!in_array($f,$fieldARkeys)) {
			err('Invalid field name selection');
		}
	}
	
	// Init extra field AR
	$extraAR = array();

	// List of fields to export
	$exportFieldsAR = $_POST['fields'];

	// Get extra fields data
	if (oc_hookSet('chair-export_reviewers-data')) {
		foreach ($OC_hooksAR['chair-export_reviewers-data'] as $v) {
			require_once $v;
		}
	}

	// Get sub. data & iterate through each
	$q = "SELECT `reviewerid`, `name_first`, `name_last`, CONCAT_WS(' ', `name_first`, `name_last`) AS `name`, `organization`, `country`, `email`, `telephone`, `onprogramcommittee` FROM `" . OCC_TABLE_REVIEWER . "` ORDER BY `reviewerid`";
	$r = ocsql_query($q) or err("Unable to retrieve data for export");
	if (mysql_num_rows($r) == 0) {
		warn("There are no committee members to export",'Export Committee Members',1);
		exit;
 	} else {  // Export file
		$fileName = 'openconf';
		if (preg_match("/^\w+$/", $OC_configAR['OC_confName'])) {
			$fileName .= '-' . $OC_configAR['OC_confName'];
		}
		$fileName .= '-committee-' . date('YmdHi') . '.csv';
        header("Expires: Mon, 18 Sep 2003 13:00:00 GMT");
		header("Last-Modified: " . gmdate("D, d M Y H:i:s") . " GMT");
		header("Cache-Control: no-store, no-cache, must-revalidate");
		header("Cache-Control: post-check=0, pre-check=0", false);
		header("Pragma: no-cache");
		header('Content-Type: text/plain');
		header('Content-Disposition: attachment; filename="' . $fileName . '"');

		// Title Row
		$titlerow = "\"" . implode('","',$exportFieldsAR) . "\"";
		print oc_strtoupper(rtrim($titlerow, ",")) . "\r\n";

		// Iterate through records
		while ($l = mysql_fetch_array($r)) {
			$row = '';
			// Add fields to row
			foreach ($exportFieldsAR as $f) {
				if (preg_match("/^_/", $f)) {
					$row .= '"' . (isset($extraAR[$l['reviewerid']][$f]) ? str_replace("\"", "\"\"", $extraAR[$l['reviewerid']][$f]) : '') . '",';
				} else {
					$row .= '"' . str_replace("\"", "\"\"", $l[$f]) . '",';
				}
			}

			$row = preg_replace("/\015(\012)?/", "\012", $row);
			print rtrim($row, ',') . "\015\012";
		}
		exit;
	}
	
}

// Display form
printHeader('Export Committee Members', 1);

print '
<form method="post" action="' . $_SERVER['PHP_SELF'] . '">
<input type="hidden" name="token" value="' . $_SESSION[OCC_SESSION_VAR_NAME]['chairtoken'] . '" />
<p>Export will generate a comma-delimited (CSV) file containing the checked fields below with one member per row.<br />
Note: When opening the file in a spreadsheet, you may need to specify the file encoding &#8211; UTF-8.</p>
<p style="font-weight: bold">Select Fields to Export:</p>
';

foreach ($fieldAR as $fieldID => $fieldName) {
	if (preg_match("/^skip\d+$/", $fieldID)) {
		print '<p />';
		continue;
	}
	print '<label><input type="checkbox" name="fields[]" value="' . $fieldID . '" ';
	if (in_array($fieldID,$checkedFieldAR)) { print 'checked '; }
	print '/> ' . $fieldName . "</label><br />\n";
}

print '
<p><input type="submit" name="submit" value="Generate File" /></p>
</form>
';

printFooter();

?>
