<?php

// +----------------------------------------------------------------------+
// | OpenConf                                                             |
// +----------------------------------------------------------------------+
// | Copyright (c) 2002-2009 Zakon Group LLC.  All Rights Reserved.       |
// +----------------------------------------------------------------------+
// | This source file is subject to the OpenConf License, available on    |
// | the OpenConf web site: www.OpenConf.com                              |
// +----------------------------------------------------------------------+

ini_set('default_socket_timeout', 5);  

require_once "../include.php";

beginChairSession();

printHeader("Program Chair",1);

if (isset($OC_hooksAR['chair-menu-top']) && !empty($OC_hooksAR['chair-menu-top'])) {
	foreach ($OC_hooksAR['chair-menu-top'] as $v) {
		print $v;
	}
}

$accOptions = '';
foreach ($OC_acceptanceValuesAR as $idx => $acc) {  
	$accOptions .= ' | <a href="SCRIPT?acc=' . $idx . '">' . safeHTMLstr($acc['value']) . '</a>';
}

print '

<b><a href="summary.php">At-a-Glance Summary</a></b>
<p />

<b><a href="email.php">Email</a></b> &nbsp;(<a href="log.php?type=email">log</a>)
<p />
';

if (isset($OC_hooksAR['chair-menu-top2']) && !empty($OC_hooksAR['chair-menu-top2'])) {
	foreach ($OC_hooksAR['chair-menu-top2'] as $v) {
		print $v;
	}
}

// get topic count
$r = ocsql_query("SELECT COUNT(*) FROM `" . OCC_TABLE_TOPIC . "`") or err('Unable to retrieve topic count');
$l = mysql_fetch_row($r);
$topicCount = $l[0];

/*** DO NOT MODIFY THE CODE BLOCK BELOW OR OTHERWISE DISABLE IT ***/
if (OCC_LICENSE == 'Public') {
	print '<div style="float: right; text-align: center; width: 200px; border: 2px dashed #000; line-height: 1.5em; font-family: Verdana, Helvetica, sans-serif; background-color: #fefe99; padding: 10px"><div style="font-weight: bold; margin-bottom: 0.5em;">Help Support OpenConf</div><a href="http://www.openconf.com/donation/" target="_blank">Make a Donation</a><br />or<br /><a href="http://www.openconf.com/sales/" target="_blank">Purchase a License</a></div>';
}
/*** DO NOT MODIFY THE CODE BLOCK ABOVE OR OTHERWISE DISABLE IT ***/

print '
<b>Settings:</b>
  <ul>
  <li><a href="set_config.php">Configuration</a>';

if (OCC_ADVANCED_CONFIG) {
	print ' &nbsp;(<a href="set_config_adv.php">advanced</a>)';
}

print '</li>
  <li><a href="../modules/modules.php">Modules</a></li>
  <li><a href="set_status.php">Open/Close Status</a> &nbsp;(<a href="log.php?type=status">log</a>)</li>
  <li><a href="set_topics.php">Topics</a>' . (($topicCount == 0) ? ' <span class="warn">(<i>not yet configured</i>)</span>' : '') . '</li>
';

if ($OC_configAR['OC_chairChangePassword']) {
  print '<li><a href="set_password.php">Password</a></li>';
}

print '
  <li>Database: <a href="db_backup.php">Backup</a> | <a href="db_reset.php">Reset</a></li>
';

if (isset($OC_hooksAR['chair-menu-settings']) && !empty($OC_hooksAR['chair-menu-settings'])) {
	print '<p />';
	foreach ($OC_hooksAR['chair-menu-settings'] as $v) {
		print '<li>' . $v . '</li>';
	}
}

print '
  </ul>
<p />

<b>Submissions:</b>
  <ul>
  <li class="linkHighlight"><a href="list_papers.php">List/Delete/Withdraw Submissions</a></li>
  <li><a href="set_format.php">Set File Format</a></li>
';

// Allow paper transfers?
if ($OC_configAR['OC_allowPaperTransfers'] && (is_file('transfer_paper.php'))) {
	print '	<li><a href="transfer_paper.php">Transfer Submission</a></li>';
}

print '
  <li><a href="list_paper_dir.php">View Files Directory</a></li>
<p />
  <li>List Author Names: <a href="list_authors.php">All</a>' . preg_replace("/SCRIPT/", "list_authors.php", $accOptions) . '</li>
  <li>List Submissions &amp; Topics: <a href="list_topics_p.php">All</a>' . preg_replace("/SCRIPT/", "list_topics_p.php", $accOptions) . '</li>
<li>Show Topic Count: <a href="list_authors_topics.php">All</a>' . preg_replace("/SCRIPT/", "list_authors_topics.php", $accOptions) . '</li>
<li>Show Country Count: <a href="list_authors_country.php">All</a>' . preg_replace("/SCRIPT/", "list_authors_country.php", $accOptions) . '</li>
<li>Export to CSV File: <a href="export_papers.php">All</a>' . preg_replace("/SCRIPT/", "export_papers.php", $accOptions) . '</li>
';

if (isset($OC_hooksAR['chair-menu-papers']) && !empty($OC_hooksAR['chair-menu-papers'])) {
	print '<p />';
	foreach ($OC_hooksAR['chair-menu-papers'] as $v) {
		print '<li>' . $v . '</li>';
	}
}

print '
  </ul>
<p />

';

if ($OC_configAR['OC_paperAdvocates']) {
	print '
<b>Committees:</b>
  <ul>
  <li class="linkHighlight">List/Delete: <a href="list_reviewers.php">All</a> | <a href="list_reviewers.php?cmt=rev">Reviewers</a> | <a href="list_reviewers.php?cmt=pc">Advocates</a></li>
  <p />
  <li>List by Topic: <a href="list_topics_r.php">All</a> | <a href="list_topics_r.php?cmt=rev">Reviewers</a> | <a href="list_topics_r.php?cmt=pc">Advocates</a></li>
  <li>Show Topic Count: <a href="list_reviewers_topics.php">All</a> | <a href="list_reviewers_topics.php?cmt=rev">Reviewers</a> | <a href="list_reviewers_topics.php?cmt=pc">Advocates</a></li>
  <li>Show Country Count: <a href="list_reviewers_country.php">All</a> | <a href="list_reviewers_country.php?cmt=rev">Reviewers</a> | <a href="list_reviewers_country.php?cmt=pc">Advocates</a></li>
';
} else {
	print '
<b>Reviewers:</b>
  <ul>
  <li class="linkHighlight"><a href="list_reviewers.php?cmt=rev">List/Delete Reviewers</a></li>
  <p />
  <li><a href="list_topics_r.php?cmt=rev">List Reviewers by Topic</a></li>
  <li><a href="list_reviewers_topics.php?cmt=rev">Show Reviewers Topic Count</a></li>
  <li><a href="list_reviewers_country.php?cmt=rev">Show Reviewers Country Count</a></li>
';
}

print '
  <li>Export to CSV File: <a href="export_reviewers.php">All</a></li>
 ';

if (isset($OC_hooksAR['chair-menu-committees']) && !empty($OC_hooksAR['chair-menu-committees'])) {
	print '<p />';
	foreach ($OC_hooksAR['chair-menu-committees'] as $v) {
		print '<li>' . $v . '</li>';
	}
}

print '
  </ul>
<p />
';

print '
<b>Assignments:</b>
  <ul>
  <li><a href="set_conflicts.php">Set Conflicts</a></li>
  <li><a href="list_conflicts.php">List/Unset Conflicts</a></li>
  <p />
  <li class="linkHighlight">Assign Reviews: <a href="assign_reviews.php">Manually</a> | <a href="assign_auto_reviewers.php">Automatically</a></li>
';

if ($OC_configAR['OC_paperAdvocates']) {
	print '
  <li class="linkHighlight">Assign Advocates: <a href="assign_advocates.php">Manually</a> | <a href="assign_auto_advocates.php">Automatically</a></li>
  <li class="linkHighlight">List/Unassign: <a href="list_reviews.php?s=pid">Reviews</a> | <a href="list_advocates.php">Advocates</a></li>
  <p />
  <li>Clear Data: <a href="clear_review_data.php">Reviews</a> | <a href="clear_advocate_data.php">Advocate Recommendations</a></li>
';
} else {
	print '
  <li class="linkHighlight"><a href="list_reviews.php?s=pid">List/Unassign Reviews</a></li>
  <p />
  <li><a href="clear_review_data.php">Clear Review Data</a></li>
';
}

if (oc_hookSet('chair-menu-assignments')) {
	print '<p />';
	foreach ($OC_hooksAR['chair-menu-assignments'] as $v) {
		print '<li>' . $v . '</li>';
	}
}

print '
  </ul>
<p />

<b>Selection:</b>
  <ul>
  <li class="linkHighlight"><a href="list_scores.php">Review Scores &amp; Accept/Reject</a></li>
  <p />
  <li><a href="list_topics.php">List Submissions by Score with Topics</a></li>
';

if (oc_hookSet('chair-menu-selection')) {
	foreach ($OC_hooksAR['chair-menu-selection'] as $v) {
		print '<p /><li>' . $v . '</li>';
	}
}

print '
  </ul>
<p />
';

if (oc_hookSet('chair-menu-extras')) {
	foreach ($OC_hooksAR['chair-menu-extras'] as $v) {
		if (isset($v['title']) && !empty($v['title'])) {
			print '<b>' . safeHTMLstr($v['title']) . ':</b><ul>';
			foreach ($v['extras'] as $m) {
				if (empty($m)) { 
					print "<p />\n";
				} else {
					print '<li>' . $m . '</li>';
				}
			}
			print "</ul><p />\n";
		} else {
			print $v['extras'];
		}
	}
}

// Multi-Track?
if (defined("OCC_MULTITRACK_CHAIR_VIEW_SCORES") && OCC_MULTITRACK_CHAIR_VIEW_SCORES) {
	print '
<b>Multi-Track:</b>
<dl><dd>
<form method="post" action="multitrack-list_scores.php">
<b>Track:</b> <select name="track">
';
	$currTrack = getTrack();
	foreach($OC_trackAR as $tid => $tname) {
		if ($tid == $currTrack) { continue; }
		print '<option value="' . $tid . '">' . safeHTMLstr($tname) . '</option>';
 }
print '
</select><p />
<b>Submission ID:</b> <input name="pid" size="4" /> <span class="note">(optional)</span><p />
<input type="submit" name="submit" value="View" />
</form>
</dd></dl>
<p />
';

}

printFooter();

?>
