<?php

// +----------------------------------------------------------------------+
// | OpenConf                                                             |
// +----------------------------------------------------------------------+
// | Copyright (c) 2002-2009 Zakon Group LLC.  All Rights Reserved.       |
// +----------------------------------------------------------------------+
// | This source file is subject to the OpenConf License, available on    |
// | the OpenConf web site: www.OpenConf.com                              |
// +----------------------------------------------------------------------+

$hdr = '';
$hdrfn = 1;

// Notification array
$OC_notifyAR = array(
	'notifyAuthorSubmit'			=> 'Author makes a submission',
	'notifyAuthorEdit'				=> 'Author updates (edits) submission',
	'notifyAuthorEmailPapers'		=> 'Author requests own submission list emailed',
	'notifyAuthorUpload'			=> 'Author uploads a file',
	'notifyAuthorReset'				=> 'Author requests password reset',
	'notifyAuthorWithdraw'			=> 'Author withdraws submission',
	'notifyReviewerSignup'			=> 'Reviewer signs up for account',
	'notifyReviewerReset'			=> 'Reviewer resets password',
	'notifyReviewerEmailUsername' 	=> 'Reviewer requests username emailed'
);

$notifyKeysAR = array_keys($OC_notifyAR);

require_once '../include.php';
require_once OCC_ZONE_FILE;

if (!OCC_INSTALL_COMPLETE && isset($_REQUEST['install']) && ($_REQUEST['install'] == 1)) {
	require_once "install-include.php";
	$token = '';
} else {
	beginChairSession();
	printHeader("Configuration", 1);
	$token = $_SESSION[OCC_SESSION_VAR_NAME]['chairtoken'];
	// Display active modules config
	if (isset($OC_activeModulesAR) && !empty($OC_activeModulesAR)) {
		$moduleOptions = '';
		foreach ($OC_activeModulesAR as $module) {
			if (is_file('../modules/' . $module . '/settings.inc')) {
				$moduleOptions .= '<option value="' . $module . '">' . safeHTMLstr($OC_modulesAR[$module]['name']) . '</option>';
			}
		}
		if (!empty($moduleOptions)) {
			print '
<form method="get" action="../modules/request.php">
<p style="text-align: center">
<input type="hidden" name="action" value="settings.inc" />
Config Module: <select name="module">
<option value=""></option>
' . $moduleOptions . '
</select>
<input type="submit" value="Go" />
</p>
</form>
';
		}
	}
}

$yesNoFieldsAR = array('includeSubmissionUploadLink', 'trackStudent', 'notifyIncludeIP', 'reviewerReadPapers', 'reviewerSeeAssignedReviews', 'reviewerCompleteBeforeSAR', 'reviewerSeeOtherReviews', 'reviewerSeeOtherReviewers', 'reviewerSeeAuthors', 'advocateReadPapers', 'advocateSeeOtherReviews', 'advocateSeeAuthors', 'paperAdvocates');
if ( ! oc_moduleActive('oc_aws') ) { // submission form file upload is not compatible with AWS
	$yesNoFieldsAR[] = 'includeSubmissionUploadField';
	$yesNoFieldsAR[] = 'requireSubmissionUploadField';
}

// Submission?
$e = array();
if (isset($_POST['submit']) && ($_POST['submit'] == "Save Info")) {
	// Check for valid submission
	if (OCC_INSTALL_COMPLETE && !validToken('chair')) {
		warn('Invalid submission', $hdr, $hdrfn);
	}
	// Check input
	if (!preg_match("/\w/",$_POST['OC_confName'])) {
		$e[] = 'Event Short Name must include 1 alphanumeric character';
	}
	if (!preg_match("/\w/",$_POST['OC_confNameFull'])) {
		$e[] = 'Event Full Name must include 1 alphanumeric character';
	}
	if (!validEmail($_POST['OC_pcemail'])) {
		$e[] = 'Chair Email does not appear to be valid';
	}
	if (preg_match("/,/",$_POST['OC_confirmmail'])) {   // Multiple addresses
		$cmAR = explode(",",$_POST['OC_confirmmail']);
		foreach ($cmAR as $cm) {
			$cm = trim($cm);
			if (!validEmail($cm)) {
				$e[] = 'Confirm Mail does not appear to be valid';
				break;
	 		}
    	}
	} elseif (!validEmail($_POST['OC_confirmmail'])) {  // Single address
		$e[] = 'Confirm Mail does not appear to be valid';
	}
	if (!preg_match("/^[1-9]\d*$/",$_POST['OC_minReviewersPerPaper'])) {
		$e[] = 'Reviewers per Submission is invalid';
	}
	if (($_POST['OC_trackStudent'] != 0) && ($_POST['OC_trackStudent'] != 1)) {
		$e[] = 'Track Students value is invalid';
	}
	if (!isset($_POST['formats']) || count($_POST['formats']) == 0) {
		$e[] = 'Select at least one file format';
	} else { // check formats are valid
		foreach ($_POST['formats'] as $fmat) {
			if (!isset($OC_formatAR[$fmat])) {
				$e[] = 'Invalid format selected';
				continue;
			}
		}
	}
	if (!isset($_POST['OC_timeZone']) || !in_array($_POST['OC_timeZone'], $OC_zoneAR)) {
		$e[] = 'Time Zone is invalid';
	}
	if (empty($e)) {
		// Update form's OC_ fields - w/exceptions below requiring special handling
		foreach (array_keys($_POST) as $p) {
			if (preg_match("/^[\w-]+$/", $p) && preg_match("/^OC_/", $p) && ($OC_configAR[$p] != $_POST[$p])) {
				updateConfigSetting($p, $_POST[$p], 'OC');
			}
		}
		// Update email notifcation settings
		foreach ($notifyKeysAR as $nk) {
			if (isset($_POST[$nk]) && ($_POST[$nk] == 1)) { $val = 1; }
			else { $val = 0; }
			if ($OC_configAR['OC_' . $nk] != $val) {
				updateConfigSetting('OC_' . $nk, $val, 'OC');
			}
		}
		// Update valid paper formats
		$fval = implode(',', $_POST['formats']);
		if ($fval != implode(',', $OC_configAR['OC_extar'])) {
			updateConfigSetting('OC_extar', $fval, 'OC');
		}
		
		// Success - if install, redirect, else let user know
		if (isset($_REQUEST['install']) && ($_REQUEST['install'] == 1)) {
			header("Location: set_topics.php?install=1");
		} else {
			print '<center><span class="note"><b>Settings sucessfully updated</b></span></center><p>';
		}
	}
	
	$confName = safeHTMLstr($_POST['OC_confName']);
	$confNameFull = safeHTMLstr($_POST['OC_confNameFull']);
	$pcemail = safeHTMLstr($_POST['OC_pcemail']);
	$confirmmail = safeHTMLstr($_POST['OC_confirmmail']);
	$confURL = safeHTMLstr($_POST['OC_confURL']);
	if (isset($_POST['formats'])) { $formats = $_POST['formats']; }
	else { $formats = array(); }
	$paperSubNote = safeHTMLstr($_POST['OC_paperSubNote']);
	$includeSubmissionUploadLink = safeHTMLstr($_POST['OC_includeSubmissionUploadLink']);
	$includeSubmissionUploadField = safeHTMLstr(varValue('OC_includeSubmissionUploadField', $_POST));
	$requireSubmissionUploadField = safeHTMLstr(varValue('OC_requireSubmissionUploadField', $_POST));
	$paperFldNote = safeHTMLstr($_POST['OC_paperFldNote']);
	$minReviewersPerPaper = safeHTMLstr($_POST['OC_minReviewersPerPaper']);
	$studentNote = safeHTMLstr($_POST['OC_studentNote']);
	$OC_timeZone = safeHTMLstr($_POST['OC_timeZone']);
	foreach ($notifyKeysAR as $nk) { 
		if (isset($_POST[$nk]) && ($_POST[$nk] == 1)) {
			$$nk = 1;
		} else {
			$$nk = 0;
		}
	}
   	$keycode_reviewer = safeHTMLstr($_POST['OC_keycode_reviewer']);
   	$keycode_program = safeHTMLstr($_POST['OC_keycode_program']);
   	foreach ($yesNoFieldsAR as $yn) {
		$$yn = varValue('OC_' . $yn, $_POST);
	}
} else { // not submit; init vars with config values
	$confName = safeHTMLstr($OC_configAR['OC_confName']);
	$confNameFull = safeHTMLstr($OC_configAR['OC_confNameFull']);
	$pcemail = safeHTMLstr($OC_configAR['OC_pcemail']);
	$confirmmail = safeHTMLstr($OC_configAR['OC_confirmmail']);
	$confURL = safeHTMLstr($OC_configAR['OC_confURL']);
	$formats = $OC_configAR['OC_extar'];
	$paperSubNote = safeHTMLstr($OC_configAR['OC_paperSubNote']);
	$includeSubmissionUploadLink = safeHTMLstr($OC_configAR['OC_includeSubmissionUploadLink']);
	$includeSubmissionUploadField = safeHTMLstr($OC_configAR['OC_includeSubmissionUploadField']);
	$requireSubmissionUploadField = safeHTMLstr($OC_configAR['OC_requireSubmissionUploadField']);
	$paperFldNote = safeHTMLstr($OC_configAR['OC_paperFldNote']);
	$minReviewersPerPaper = safeHTMLstr($OC_configAR['OC_minReviewersPerPaper']);
	$studentNote = safeHTMLstr($OC_configAR['OC_studentNote']);
	$OC_timeZone = $OC_configAR['OC_timeZone'];
	foreach ($notifyKeysAR as $nk) {
		$$nk = $OC_configAR['OC_' . $nk];
	}
	$keycode_reviewer = safeHTMLstr($OC_configAR['OC_keycode_reviewer']);
	$keycode_program = safeHTMLstr($OC_configAR['OC_keycode_program']);
   	foreach ($yesNoFieldsAR as $yn) {
		$$yn = $OC_configAR['OC_' . $yn];
	}
}

if ((!OCC_INSTALL_COMPLETE) && isset($_REQUEST['install']) && ($_REQUEST['install'] == 1)) {
	printHeader($hdr,$hdrfn);
	print '<p align="center"><b>Step 3 of 5: Tailor Configuration Settings</b></p>';
}

if (!empty($e)) {
	print '<p align="center"><span class="warn">Please correct the following:<br /><table border="0" cellspacing="0" cellpading="0"><tr><td class="warn"><ul><li>' . implode('</li><li>',$e) . '</li></ul></td></tr></table></span></p>';
}

foreach ($yesNoFieldsAR as $yn) {
	$ynOptions = $yn . 'Options';
	$$ynOptions = '<label><input type="radio" name="OC_' . $yn . '" value="1"> Yes</label> &nbsp; <label><input type="radio" name="OC_' . $yn . '" value="0"> No</label>';
	$$ynOptions = preg_replace("/value=\"" . $$yn . "\"/","value=\"" . $$yn . "\" checked",$$ynOptions);
}

$formatOptions = '';
foreach ($OC_formatAR as $k => $v) {
	$formatOptions .= '<label><input type="checkbox" name="formats[]" value="' . $k . '" ';
	if (in_array($k,$formats)) { $formatOptions .= 'checked '; }
	$formatOptions .= '/>' . $v . '</label><br />';
}

print '
<center>
<form method="post" action="'.$_SERVER['PHP_SELF'].'">
<input type="hidden" name="token" value="' . $token . '" />
';

if ((!OCC_INSTALL_COMPLETE) && isset($_REQUEST['install'])) {
    print '
<input type="hidden" name="install" value="' . $_REQUEST['install'] . '" />
';
}

print '
<table border="0" cellspacing="0" cellpadding="3" bgcolor="#eeeeee">

<tr><td><b>Event Full Name:</td><td><input size="50" name="OC_confNameFull" value="'.$confNameFull.'"> (OC_confNameFull)</td></tr>
<tr><td colspan=2 class="note">Event name used on Web pages and in email messages.<p /></td></tr>

<tr><td><b>Event Short Name:</td><td><input size="50" name="OC_confName" value="' . $confName . '"> (OC_confName)</td></tr>
<tr><td colspan=2 class="note">Event abbreviated name, primarily used in email subject lines.<p /></td></tr>

<tr><td><b>Event URL:</td><td><input size="50" name="OC_confURL" value="'.$confURL.'"> (OC_confURL)</td></tr>
<tr><td colspan=2 class="note">Event Web page.</td></tr>

<tr><td colspan=2 bgcolor="#ffffff">&nbsp;</td></tr>

<tr><td><b>Chair Email:</b></td><td><input size="50" name="OC_pcemail" value="'.$pcemail.'"> (OC_pcemail)</td></tr>
<tr><td colspan=2 class="note">Used as the general contact email and in case of errors or other follow-up.<p /></td></tr>

<tr><td><b>Confirm Email:</b></td><td><input size="50" name="OC_confirmmail" value="'.$confirmmail.'"> (OC_confirmmail)</td></tr>
<tr><td colspan=2 class="note">Receives a copy of confirmation emails sent to authors and reviewers (e.g., submissions, edits, signups);<br />see Email Notification below.</td></tr>

<tr><td colspan=2 bgcolor="#ffffff">&nbsp;</td></tr>

<tr><td valign="top"><b>Use Advocates?</b></td><td>' . $paperAdvocatesOptions . ' &nbsp; &nbsp; (OC_paperAdvocates)</td></tr>
<tr><td colspan="2" class="note">Select whether to make use of Advocates.  Note that if you are changing from Yes to No, some of the keycode<br />and permission options below will not apply and next time you visit this page they will not be displayed.</td></tr>

<tr><td colspan=2 bgcolor="#ffffff">&nbsp;</td></tr>

<tr><td><b>Reviewer Keycode:</td><td><input size="20" name="OC_keycode_reviewer" value="'.$keycode_reviewer.'"> (OC_keycode_reviewer)</td></tr>
<tr><td colspan=2 class="note">Keycode for signing up as a reviewer committee member.<p /></td></tr>
';

if ($paperAdvocates) {
	$permissionStr = 'Advocate/Reviewer';
	print '
<tr><td><b>Program Cmt. Keycode:</td><td><input size="20" name="OC_keycode_program" value="'.$keycode_program.'"> (OC_keycode_program)</td></tr>
<tr><td colspan=2 class="note">Keycode for signing up as a program committee member.</td></tr>
';
} else {
	$permissionStr = 'Reviewer';
	print '
<input type="hidden" name="OC_keycode_program" value="pckey" />
';
}

print '
<tr><td colspan=2 bgcolor="#ffffff">&nbsp;</td></tr>

<tr><td valign="top"><b>Submission Notice:</b><p /><span class="note">Notice appearing atop<br />submission page.</span><p />(OC_paperSubNote)</td>
<td><textarea name="OC_paperSubNote" rows="6" cols="50">'.$paperSubNote.'</textarea><p /></td></tr>
';

if ( ! oc_moduleActive('oc_aws') ) { // submission form file upload is not compatible with AWS
	print '
<tr><td><b>Include File Upload Field?</td><td>' . $includeSubmissionUploadFieldOptions . ' &nbsp; &nbsp; (OC_includeSubmissionUploadField)</td></tr>
<tr><td colspan=2 class="note">Includes file upload field on submission page, overriding Include File Upload Link setting.<p /></td></tr>

<tr><td style="padding-left: 15px"><b>Require File Upload Field?</td><td>' . $requireSubmissionUploadFieldOptions . ' &nbsp; &nbsp; (OC_requireSubmissionUploadField)</td></tr>
<tr><td colspan=2 class="note" style="padding-left: 15px">Requires file to be uploaded at submission if Include File Upload Field enabled.<p /></td></tr>
';
}

print '
<tr><td><b>Include File Upload Link?</td><td>' . $includeSubmissionUploadLinkOptions . ' &nbsp; &nbsp; (OC_includeSubmissionUploadLink)</td></tr>
<tr><td colspan=2 class="note">Includes file upload link on submission confirmation page.' . (oc_moduleActive('oc_aws') ? '' : 'Applies only if Include File Upload Field is not enabled.<br />') . '  Note that Upload File status must also be set to open.<p /></td></tr>

<tr><td colspan=2 bgcolor="#ffffff">&nbsp;</td></tr>

<tr><td><b>Track Students?</td><td>' . $trackStudentOptions . ' &nbsp; &nbsp; (OC_trackStudent)</td></tr>
<tr><td colspan=2 class="note">Is there a need to track whether submissions are by a student?<br />For example, if a best student submission award is given.<p /></td></tr>

<tr><td valign="top"><b>Student Notice:</b><p /><span class="note">Notice appearing under<br />Student Yes/No option<br />if students are tracked.</span><p />(OC_studentNote)</td>
<td><textarea name="OC_studentNote" rows="6" cols="50">'.$studentNote.'</textarea></td></tr>

<tr><td colspan=2 bgcolor="#ffffff">&nbsp;</td></tr>
';

if (oc_hookSet('set-config-fileupload')) {
	foreach ($GLOBALS['OC_hooksAR']['set-config-fileupload'] as $hook) {
		require_once $hook;
	}
} else {
	print '
<tr><td valign="top"><b>File Formats:</b><p /><span class="note">Select at least one file<br />format to accept.</span><p />(OC_extar)</td><td>' . $formatOptions . '</td></tr>

<tr><td valign="top"><b>File Upload<br />Field Notice:</b><p /><span class="note">Notice appearing with<br />file upload fields.</span><p />(OC_paperFldNote)</td>
<td><textarea name="OC_paperFldNote" rows="6" cols="50">'.$paperFldNote.'</textarea></td></tr>

<tr><td colspan=2 bgcolor="#ffffff">&nbsp;</td></tr>
';
}

print '
<tr><td><b>Reviewers per Subm.:</td><td><input size="3" name="OC_minReviewersPerPaper" value="'.$minReviewersPerPaper.'"> (OC_minReviewersPerPaper)</td></tr>
<tr><td colspan=2 class="note">Default minimum number used when auto assigning reviewers to submissions.</td></tr>

<tr><td colspan=2 bgcolor="#ffffff">&nbsp;</td></tr>

<tr><td valign="top"><b>Email Notification:</b><p /><span class="note">When to include<br />OC_confirmmail<br />in notifications<br />(see Confirm Email<br />above).</span></td>
<td>
';

foreach ($OC_notifyAR as $nk => $nv) {
	print '<input type="checkbox" name="' . $nk . '" value="1" ';
	if ($$nk) { print 'checked '; }
	print '/> ' . $nv . ' (OC_' . $nk . ')<br />';
}

print '
<p />
Include IP address in notifications?<br />' . $notifyIncludeIPOptions . ' &nbsp; &nbsp; (OC_notifyIncludeIP)
</td></tr>

<tr><td colspan=2 bgcolor="#ffffff">&nbsp;</td></tr>

<tr><td valign="top"><b>' . $permissionStr . '<br />Permissions:</b></td><td valign="top">';

print 'Allow reviewers to view all submissions?<br />' . $reviewerReadPapersOptions . ' &nbsp; &nbsp; (OC_reviewerReadPapers)<p />';
print 'Allow reviewers to see others\' review of assigned submissions?<br />' . $reviewerSeeAssignedReviewsOptions . ' &nbsp; &nbsp; (OC_reviewerSeeAssignedReviews)<p />';
print 'Only allow reviewer to see reviews of assigned submissions if own is complete?<br />' . $reviewerCompleteBeforeSAROptions . ' &nbsp; &nbsp; (OC_reviewerCompleteBeforeSAR)<p />';
print 'Allow reviewer to see reviews of non-assigned submissions?<br />' . $reviewerSeeOtherReviewsOptions . ' &nbsp; &nbsp; (OC_reviewerSeeOtherReviews)<p />';
print 'Allow reviewers to see each other\'s information? (e.g., name, email)<br />' . $reviewerSeeOtherReviewersOptions . ' &nbsp; &nbsp; (OC_reviewerSeeOtherReviewers)<p />';
print 'Allow reviewers to see authors (i.e., non-blind reviews)?<br />' . $reviewerSeeAuthorsOptions . ' &nbsp; &nbsp; (OC_reviewerSeeAuthors)<p />';

if ($paperAdvocates) {
	print '<p><hr style="margin-right: 10px;" /></p><span class="note">Reviewer permissions above are evaluated before advocate\'s:</span><p />';
	print 'Allow advocates to view all submissions?<br />' . $advocateReadPapersOptions . ' &nbsp; &nbsp; (OC_advocateReadPapers)<p />';
	print 'Allow advocates to see reviews of non-assigned submissions?<br />' . $advocateSeeOtherReviewsOptions . ' &nbsp; &nbsp; (OC_advocateSeeOtherReviews)<p />';
	print 'Allow advocates to see authors?<br />' . $advocateSeeAuthorsOptions . ' &nbsp; &nbsp; (OC_advocateSeeAuthors)<p />';
} else {
	print '
<input type="hidden" name="OC_advocateReadPapers" value="0" />
<input type="hidden" name="OC_advocateSeeOtherReviews" value="0" />
';
}

print '</td></tr>

<tr><td colspan=2 bgcolor="#ffffff">&nbsp;</td></tr>

<tr><td><b>Time Zone:</b></td><td><select name="OC_timeZone">
' . generateSelectOptions($OC_zoneAR, $OC_timeZone, FALSE) . '
</select> &nbsp; (OC_timeZone)</td></tr>

</table>

<p><input type="submit" name="submit" value="Save Info"></p>
</form>
<br />

</center>
';


printFooter();
?>
