<?php

// +----------------------------------------------------------------------+
// | OpenConf                                                             |
// +----------------------------------------------------------------------+
// | Copyright (c) 2002-2009 Zakon Group LLC.  All Rights Reserved.       |
// +----------------------------------------------------------------------+
// | This source file is subject to the OpenConf License, available on    |
// | the OpenConf web site: www.OpenConf.com                              |
// +----------------------------------------------------------------------+

$hdr = '';
$hdrfn = 1;

$minTopics = 20; // min number of fields to display

$topicColAR = array(1, 2);

require_once "../include.php";

if (!OCC_INSTALL_COMPLETE && isset($_REQUEST['install']) && ($_REQUEST['install'] == 1)) {
	require_once "install-include.php";
	$token = '';
} else {
	beginChairSession();
	printHeader("Set Topics",1);
	$token = $_SESSION[OCC_SESSION_VAR_NAME]['chairtoken'];
}

if (isset($_POST['submit']) && ($_POST['submit'] == "Set Topics")) {
	// Check for valid submission
	if (OCC_INSTALL_COMPLETE && !validToken('chair')) {
		warn('Invalid submission');
	}
	
	// Check & update topic options
	if (!preg_match("/^[01]$/", $_POST['OC_multipleSubmissionTopics'])) {
		warn('Multiple submission topics option is invalid');
	}
	if (updateConfigSetting('OC_multipleSubmissionTopics', $_POST['OC_multipleSubmissionTopics'], 'OC')) {
		$OC_configAR['OC_multipleSubmissionTopics'] = $_POST['OC_multipleSubmissionTopics'];
	}
	if (!preg_match("/^[12]$/", $_POST['OC_topicColumns'])) {
		warn('Number of topic columns option is invalid');
	}
	if (updateConfigSetting('OC_topicColumns', $_POST['OC_topicColumns'], 'OC')) {
		$OC_configAR['OC_topicColumns'] = $_POST['OC_topicColumns'];
	}
	
	// Delete current list of topics
	issueSQL("DELETE FROM " . OCC_TABLE_TOPIC );

	// Parse through submitted topics
	$j = 1;
	while (isset($_POST["name-".$j]) && !empty($_POST["name-".$j])) {
		$q2 = "INSERT INTO " . OCC_TABLE_TOPIC . " (topicid,topicname,short) VALUES ('$j','" . safeSQLstr(substr($_POST["name-".$j],0,250)) . "','" . safeSQLstr(substr($_POST["short-".$j],0,20)) . "')";
		issueSQL($q2);
		$j++;
	}
	
	// Success - if install, redirect, else let user know
	if (isset($_REQUEST['install']) && ($_REQUEST['install'] == 1)) {
		header("Location: set_status.php?install=1");
	} else {
		print '<center><span class="note"><b>Topics sucessfully updated</b></span></center><p>';
	}
}

if (isset($_REQUEST['install']) && ($_REQUEST['install'] == 1)) {
	printHeader($hdr,$hdrfn);
	print '<p align="center"><b>Step 4 of 5: Set Topics</b></p>';
} else {
	print '<i><b>Note that if submissions have been made or reviewers signed up already, you should only add new topics to the end of the list or change a topic\'s name to clarify it.  If you want to delete a topic in the middle of the list, replace its name with N/A or something authors and reviewers will know not to select.</b></i><p />';
}

print '
<form method="post" action="'.$_SERVER['PHP_SELF'].'">
<input type="hidden" name="token" value="' . $token . '" />

Topics are used when making automated review assignments.  Both authors and reviewers are asked to select topics.  Enter a sequential list of topics below.  When you click on <i>Set Topics</i>, the list of topics will be processed until the first blank topic is reached.  The <i>Short Name</i> field is optional; if present, it is used on pages where a long topic name may not display well.</i>
<p />
';

if (isset($_REQUEST['install']) && ($_REQUEST['install'] == 1)) {
    print '<input type="hidden" name="install" value="' . $_REQUEST['install'] . '" />';
}

print '
<table border="0" cellspacing="1" cellpadding="8" id="topicTable">
<tr class="rowheader"><th>Topic ID</th><th>Topic Name</th><th>Short Name (^20 chars)</th></tr>
';

// Display existing topics
$q = "SELECT * FROM " . OCC_TABLE_TOPIC;
$r = ocsql_query($q) or err("Unable to query topics - ".mysql_errno());
$topicNum = mysql_num_rows($r);
$tAR = array();
$row=1;
while ($l=mysql_fetch_array($r)) {
	print '<tr class="row' . $row . '"><td align="center">' . $l['topicid'] . '</td><td><input name="name-' . $l['topicid'] . '" value="' . (isset($l['topicname']) ? safeHTMLstr($l['topicname']) : '') . '" size="50" maxlength="250" /></td><td><input name="short-' . $l['topicid'] . '" value="' . (isset($l['short']) ? safeHTMLstr($l['short']) : '') . '" size="20" maxlength="20" /></td></tr>
';
	if ($row==1) { $row=2; } else { $row=1; }
}

// Display additional rows
$addRows = ((($topicNum + 5) < $minTopics) ? ($minTopics - $topicNum) : 5);

for ($i=1; $i <= $addRows; $i++) {
	$topicNum++;
	print '<tr class="row' . $row . '"><td align="center">' . $topicNum . '</td><td><input name="name-' . $topicNum . '" value="' . (isset($tAR[$i]['name']) ? safeHTMLstr($tAR[$i]['name']) : '') . '" size="50" maxlength="250" /></td><td><input name="short-' . $topicNum . '" value="' . (isset($tAR[$i]['short']) ? safeHTMLstr($tAR[$i]['short']) : '') . '" size="20" maxlength="20" /></td></tr>
';
	if ($row==1) { $row=2; } else { $row=1; }
}

print '
</table>

<style type="text/css">
<!--
.topic_link {
	color: #00f; cursor: pointer;
}
-->
</style><script language="javascript">
<!--
var topicNum = ' . ($topicNum+1) . ';
var row = ' . $row . ';
var j;
function addTopicRow() {
	if (document.getElementById) {
		var topicTable = document.getElementById("topicTable");
		if (topicTable) {
			for (j=1; j<=5; j++) {
				var topicRow = topicTable.insertRow(-1);
				topicRow.className = "row" + row;
				var idCell = topicRow.insertCell(-1);
				idCell.align = "center";
				idCell.innerHTML = topicNum;
				var nameCell = topicRow.insertCell(-1);
				nameCell.innerHTML = "<input name=\"name-" + topicNum + "\" value=\"\" size=\"50\" maxlength=\"250\" />";
				var shortCell = topicRow.insertCell(-1);
				shortCell.innerHTML = "<input name=\"short-" + topicNum + "\" value=\"\" size=\"20\" maxlength=\"20\" />";
				topicNum += 1;
				if (row == 1) { row = 2; } else { row = 1; }
			}
		}
	}
}
document.write(\'<span onclick="addTopicRow()" class="topic_link" style="text-decoration: underline">Add More Rows</span>\');
// -->
</script>
<noscript><span class="note">All topics filled in?  Click <i>Set Topics</i> to save topics and add more rows</span></noscript>
<p />
<p><b>Allow authors to select multiple submission topics?</b> ' . generateRadioOptions('OC_multipleSubmissionTopics', $yesNoAR, $OC_configAR['OC_multipleSubmissionTopics']) . '<br />
<span class="note">Select Yes to allow multiple topics, or No to limit author to one topic.</span></p>

<p><b>Number of topic columns:</b> ' . generateRadioOptions('OC_topicColumns', $topicColAR, $OC_configAR['OC_topicColumns'], 0) . '<br />
<span class="note">Number of columns to display topics in (1 or 2).  1 will work best for long topic names.</span></p>

<input type="submit" name="submit" value="Set Topics">

</form>
';

printFooter();

?>
