## +----------------------------------------------------------------------+
## | OpenConf                                                             |
## +----------------------------------------------------------------------+
## | Copyright (c) 2002-2009 Zakon Group LLC.  All Rights Reserved.       |
## +----------------------------------------------------------------------+
## | This source file is subject to the OpenConf License, available on    |
## | the OpenConf web site: www.OpenConf.com                              |
## +----------------------------------------------------------------------+

# NOTE: It is important that a ; only appear at the end of a SQL statement

# --------------------------------------------------------

#
# Table structure for table `acceptance`
#

CREATE TABLE `acceptance` (
  `value` varchar(30) collate utf8_unicode_ci NOT NULL default '',
  `color` varchar(6) collate utf8_unicode_ci default 'ffffff',
  `publish` tinyint(1) unsigned NOT NULL default '0',
  `title` varchar(255) collate utf8_unicode_ci default NULL,
  `accepted` tinyint(1) unsigned NOT NULL default '0',
  PRIMARY KEY  (`value`),
  KEY `publish` (`publish`),
  KEY `accepted` (`accepted`)
) DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci ;

# --------------------------------------------------------

#
# Table structure for table `author`
#

CREATE TABLE `author` (
  `paperid` smallint(4) unsigned NOT NULL default '0',
  `position` tinyint(1) unsigned NOT NULL default '0',
  `name_last` varchar(40) collate utf8_unicode_ci NOT NULL default '',
  `name_first` varchar(60) collate utf8_unicode_ci NOT NULL default '',
  `organization` varchar(255) collate utf8_unicode_ci default NULL,
  `country` varchar(100) collate utf8_unicode_ci default NULL,
  `email` varchar(100) collate utf8_unicode_ci default NULL,
  PRIMARY KEY  (`paperid`,`position`),
  KEY `organization` (`organization`),
  KEY `email` (`email`)
) DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci ;

# --------------------------------------------------------

#
# Table structure for table `config`
#

CREATE TABLE `config` (
  `module` varchar(255) collate utf8_unicode_ci NOT NULL default '',
  `setting` varchar(255) collate utf8_unicode_ci NOT NULL default '',
  `value` longtext collate utf8_unicode_ci,
  `name` varchar(100) collate utf8_unicode_ci default NULL,
  `description` text collate utf8_unicode_ci,
  `parse` tinyint(1) unsigned NOT NULL default '0',
  PRIMARY KEY  (`setting`),
  KEY `module` (`module`)
) DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci;

# --------------------------------------------------------

#
# Table structure for table `conflict`
#

CREATE TABLE `conflict` (
  `paperid` smallint(4) unsigned NOT NULL default '0',
  `reviewerid` smallint(4) unsigned NOT NULL default '0',
  PRIMARY KEY  (`paperid`,`reviewerid`)
) DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci ;

# --------------------------------------------------------

# 
# Table structure for table `log`
# 

CREATE TABLE `log` (
  `logid` int(10) unsigned NOT NULL auto_increment,
  `datetime` datetime NOT NULL default '0000-00-00 00:00:00',
  `entry` text collate utf8_unicode_ci NOT NULL,
  `type` varchar(50) collate utf8_unicode_ci NOT NULL default 'sql',
  `extra` text collate utf8_unicode_ci,
  PRIMARY KEY  (`logid`),
  KEY `type` (`type`)
) DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci AUTO_INCREMENT=1 ;

# --------------------------------------------------------

#
# Table structure for table `modules`
#

CREATE TABLE `modules` (
  `moduleId` varchar(255) collate utf8_unicode_ci NOT NULL default '',
  `moduleActive` tinyint(1) unsigned NOT NULL default '0',
  PRIMARY KEY  (`moduleId`),
  KEY `enabled` (`moduleActive`)
) DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci ;

# --------------------------------------------------------

#
# Table structure for table `paper`
#

CREATE TABLE `paper` (
  `paperid` smallint(4) unsigned NOT NULL auto_increment,
  `accepted` varchar(30) collate utf8_unicode_ci default NULL,
  `password` varchar(255) collate utf8_unicode_ci default NULL,
  `title` varchar(255) collate utf8_unicode_ci NOT NULL default '',
  `student` enum('T','F') NOT NULL default 'F',
  `contactid` tinyint(1) unsigned NOT NULL default '0',
  `contactemail` varchar(100) collate utf8_unicode_ci NOT NULL default '',
  `contactphone` varchar(30) collate utf8_unicode_ci default NULL,
  `submissiondate` date NOT NULL default '0000-00-00',
  `lastupdate` date default NULL,
  `format` varchar(10) collate utf8_unicode_ci default NULL,
  `otherauthors` text collate utf8_unicode_ci,
  `keywords` text collate utf8_unicode_ci,
  `comments` text collate utf8_unicode_ci,
  `abstract` text collate utf8_unicode_ci,
  `pcnotes` text collate utf8_unicode_ci,
  PRIMARY KEY  (`paperid`),
  KEY `accepted` (`accepted`)
) AUTO_INCREMENT=1 DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci ;

# --------------------------------------------------------

#
# Table structure for table `paperadvocate`
#

CREATE TABLE `paperadvocate` (
  `paperid` smallint(4) unsigned NOT NULL default '0',
  `advocateid` smallint(4) unsigned NOT NULL default '0',
  `adv_recommendation` varchar(30) collate utf8_unicode_ci default NULL,
  `adv_comments` text collate utf8_unicode_ci,
  PRIMARY KEY  (`paperid`)
) DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci ;

# --------------------------------------------------------

#
# Table structure for table `paperreviewer`
#

CREATE TABLE `paperreviewer` (
  `paperid` smallint(4) unsigned NOT NULL default '0',
  `reviewerid` smallint(4) unsigned NOT NULL default '0',
  `completed` enum('T','F') NOT NULL default 'F',
  `updated` date default NULL,
  `recommendation` tinyint(1) unsigned default NULL,
  `category` tinyint(1) unsigned default NULL,
  `value` varchar(20) collate utf8_unicode_ci default NULL,
  `familiar` enum('High','Low','Moderate') default NULL,
  `bpcandidate` enum('Yes','No','Unsure') default NULL,
  `length` enum('Yes','No','Unsure') default NULL,
  `difference` tinyint(1) unsigned default NULL,
  `pccomments` text collate utf8_unicode_ci,
  `authorcomments` text collate utf8_unicode_ci,
  PRIMARY KEY  (`paperid`,`reviewerid`),
  KEY `completed` (`completed`)
) DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci ;

# --------------------------------------------------------

#
# Table structure for table `papersession`
#

CREATE TABLE `papersession` (
  `paperid` smallint(4) unsigned NOT NULL default '0',
  `reviewerid` smallint(4) unsigned NOT NULL default '0',
  `topicid` tinyint(3) unsigned NOT NULL default '0',
  PRIMARY KEY  (`paperid`,`reviewerid`,`topicid`)
) DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci ;

# --------------------------------------------------------

#
# Table structure for table `papertopic`
#

CREATE TABLE `papertopic` (
  `paperid` smallint(4) unsigned NOT NULL default '0',
  `topicid` tinyint(3) unsigned NOT NULL default '0',
  PRIMARY KEY  (`paperid`,`topicid`)
) DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci ;

# --------------------------------------------------------

#
# Table structure for table `reviewer`
#

CREATE TABLE `reviewer` (
  `reviewerid` smallint(4) unsigned NOT NULL auto_increment,
  `username` varchar(255) collate utf8_unicode_ci NOT NULL default '',
  `password` varchar(255) collate utf8_unicode_ci NOT NULL default '',
  `name_last` varchar(40) collate utf8_unicode_ci NOT NULL default '',
  `name_first` varchar(60) collate utf8_unicode_ci NOT NULL default '',
  `email` varchar(100) collate utf8_unicode_ci NOT NULL default '',
  `url` varchar(255) collate utf8_unicode_ci default NULL,
  `organization` varchar(255) collate utf8_unicode_ci default NULL,
  `country` varchar(100) collate utf8_unicode_ci default NULL,
  `telephone` varchar(30) collate utf8_unicode_ci default NULL,
  `onprogramcommittee` enum('T','F') NOT NULL default 'F',
  `otherexpertise` text collate utf8_unicode_ci,
  `comments` text collate utf8_unicode_ci,
  PRIMARY KEY  (`reviewerid`),
  KEY `onprogramcommittee` (`onprogramcommittee`),
  KEY `email` (`email`),
  KEY `organization` (`organization`)
) AUTO_INCREMENT=1 DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci ;

# --------------------------------------------------------

#
# Table structure for table `reviewertopic`
#

CREATE TABLE `reviewertopic` (
  `reviewerid` smallint(4) unsigned NOT NULL default '0',
  `topicid` tinyint(3) unsigned NOT NULL default '0',
  PRIMARY KEY  (`reviewerid`,`topicid`)
) DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci ;

# --------------------------------------------------------

#
# Table structure for table `status`
#

CREATE TABLE `status` (
  `module` varchar(255) collate utf8_unicode_ci NOT NULL default '',
  `setting` varchar(255) collate utf8_unicode_ci NOT NULL default '',
  `description` text collate utf8_unicode_ci,
  `status` tinyint(1) unsigned NOT NULL default '0',
  `name` varchar(100) collate utf8_unicode_ci default NULL,
  `open` datetime default NULL,
  `close` datetime default NULL,
  `dependency` varchar(100) collate utf8_unicode_ci default NULL,
  `order` tinyint(3) unsigned default '0',
  PRIMARY KEY  (`setting`),
  KEY `module` (`module`)
) DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci ;

# --------------------------------------------------------

#
# Table structure for table `topic`
#

CREATE TABLE `template` (
  `templateid` varchar(255) collate utf8_unicode_ci NOT NULL default '',
  `module` varchar(255) collate utf8_unicode_ci NOT NULL default '',
  `name` varchar(255) collate utf8_unicode_ci NOT NULL default '',
  `subject` varchar(255) collate utf8_unicode_ci default NULL,
  `body` text collate utf8_unicode_ci NOT NULL,
  PRIMARY KEY  (`templateid`),
  KEY `module` (`module`)
) DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci;

# --------------------------------------------------------

#
# Table structure for table `topic`
#

CREATE TABLE `topic` (
  `topicid` tinyint(3) unsigned NOT NULL default '0',
  `topicname` varchar(255) collate utf8_unicode_ci NOT NULL default '',
  `short` varchar(20) collate utf8_unicode_ci default NULL,
  PRIMARY KEY  (`topicid`)
) DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci ;

# --------------------------------------------------------

#
# Table structure for table `withdrawn`
#

CREATE TABLE `withdrawn` (
  `paperid` smallint(4) unsigned NOT NULL default '0',
  `title` varchar(255) collate utf8_unicode_ci NOT NULL default '',
  `contact_author` varchar(255) collate utf8_unicode_ci NOT NULL default '',
  `contact_email` varchar(100) collate utf8_unicode_ci default NULL,
  `papersql` longtext collate utf8_unicode_ci NOT NULL,
  `authorsql` text collate utf8_unicode_ci NOT NULL,
  `topicsql` text collate utf8_unicode_ci,
  `withdraw_date` datetime default NULL,
  `withdrawn_by` enum('Author','Chair') collate utf8_unicode_ci default NULL,
  PRIMARY KEY  (`paperid`)
) DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci ;

# --------------------------------------------------------

#
# Data for table `acceptance`
#

INSERT INTO `acceptance` (`value`, `color`, `publish`, `title`, `accepted`) VALUES('Accept', 'aaffaa', 1, 'Papers', 1);
INSERT INTO `acceptance` (`value`, `color`, `publish`, `title`, `accepted`) VALUES('Reject', 'ffcccc', 0, '', 0);

# --------------------------------------------------------

#
# Data for table `config`
#

INSERT INTO `config` (`module`, `setting`, `value`, `name`, `description`, `parse`) VALUES ('OC', 'OC_abstractLength', 0, 'Abstract Length', 'Max. number of words permitted in abstract field - use 0 for no limit', 0);
INSERT INTO `config` (`module`, `setting`, `value`, `name`, `description`, `parse`) VALUES ('OC', 'OC_advocateReadPapers', '1', 'Allow Adv. to View All Submissions', 'Allow advocates to read all submitted submissions', 0);
INSERT INTO `config` (`module`, `setting`, `value`, `name`, `description`, `parse`) VALUES ('OC', 'OC_advocateSeeAuthors', '0', 'Allow Adv. See Authors?', 'Allow advocates to see submission authors', 0);
INSERT INTO `config` (`module`, `setting`, `value`, `name`, `description`, `parse`) VALUES ('OC', 'OC_advocateSeeOtherReviews', '0', 'Allow Adv. to See All Reviews', 'Allow advocates to see reviews of non-assigned submissions', 0);
INSERT INTO `config` (`module`, `setting`, `value`, `name`, `description`, `parse`) VALUES ('OC', 'OC_allowConflictOverride', '0', 'Allow Conflict Override', 'Allow Chair to override conflict settings when making manual assignments.  This will also determine whether advocate/reviewers see listings in conflict.', 0);
INSERT INTO `config` (`module`, `setting`, `value`, `name`, `description`, `parse`) VALUES ('OC', 'OC_allowOrgConflict', '0', 'Allow Organization Conflict', 'Allow a submission author and reviewer to have the same organization name.', 0);
INSERT INTO `config` (`module`, `setting`, `value`, `name`, `description`, `parse`) VALUES ('OC', 'OC_allowPaperTransfers', '0', 'Allow Submission Transfer', 'Allow transfer of submissions to another track (multitrack only)', 0);
INSERT INTO `config` (`module`, `setting`, `value`, `name`, `description`, `parse`) VALUES ('OC', 'OC_chair_pwd', 'c23a11a3dbbbb527ae1e54981868619361425340ad6b32e222', 'Chair Password', 'Chair Password', 0);
INSERT INTO `config` (`module`, `setting`, `value`, `name`, `description`, `parse`) VALUES ('OC', 'OC_chair_uname', 'chair', 'Chair Username', 'Chair Login name', 0);
INSERT INTO `config` (`module`, `setting`, `value`, `name`, `description`, `parse`) VALUES ('OC', 'OC_chairChangePassword', '1', 'Allow Chair Change Pwd', 'Allow Chair to change password?', 0);
INSERT INTO `config` (`module`, `setting`, `value`, `name`, `description`, `parse`) VALUES ('OC', 'OC_chairPasswordForgot', '1', 'Display Chair Pwd Forgot', 'Display Chair Sign In Password "i forgot it"?', 0);
INSERT INTO `config` (`module`, `setting`, `value`, `name`, `description`, `parse`) VALUES ('OC', 'OC_ChairTimeout', '60', 'Chair Timeout', 'Chair session timeout in minutes or enter 0 for no timeout.  Note: subject to server PHP settings.', 0);
INSERT INTO `config` (`module`, `setting`, `value`, `name`, `description`, `parse`) VALUES ('OC', 'OC_chairUsernameForgot', '1', 'Enable Chair Get Username', 'Display Chair Sign In Username "i forgot it"?', 0);
INSERT INTO `config` (`module`, `setting`, `value`, `name`, `description`, `parse`) VALUES ('OC', 'OC_confirmmail', 'openconf@example.com', 'Confirm Email', 'Receives a copy of confirmation emails sent to authors and reviewers (e.g., submissions, edits, signups) - see Email Notification below.', 0);
INSERT INTO `config` (`module`, `setting`, `value`, `name`, `description`, `parse`) VALUES ('OC', 'OC_confName', 'OCC2010', 'Event Short Name', 'Event abbreviated name, primarily used in email subject lines.', 0);
INSERT INTO `config` (`module`, `setting`, `value`, `name`, `description`, `parse`) VALUES ('OC', 'OC_confNameFull', 'OpenConf Conference 2010', 'Event Full Name', 'Event name used on Web pages and in email messages.', 0);
INSERT INTO `config` (`module`, `setting`, `value`, `name`, `description`, `parse`) VALUES ('OC', 'OC_confURL', 'http://www.openconf.com', 'Event URL', 'Event Web page.', 0);
INSERT INTO `config` (`module`, `setting`, `value`, `name`, `description`, `parse`) VALUES ('OC', 'OC_dataDir', 'data/', 'Data Directory', 'Directory for data files offset from openconf/ or full path, include trailing slash (/)', 0);
INSERT INTO `config` (`module`, `setting`, `value`, `name`, `description`, `parse`) VALUES ('OC', 'OC_emailAuthorOnUpload', 0, 'Email Author on Upload', 'Emails the author when a file is uploaded.', 0);
INSERT INTO `config` (`module`, `setting`, `value`, `name`, `description`, `parse`) VALUES ('OC', 'OC_emailWrap', '70', 'Email Wrap', 'Number of characters at which to wrap email lines - only used when displaying a preview message via chair/email.php', 0);
INSERT INTO `config` (`module`, `setting`, `value`, `name`, `description`, `parse`) VALUES ('OC', 'OC_extar', 'pdf', 'File Formats', 'File formats to accept (select at least one).', 0);
INSERT INTO `config` (`module`, `setting`, `value`, `name`, `description`, `parse`) VALUES('OC', 'OC_footerFile', 'footer.php', 'Footer File', 'File containing the footer section of OpenConf pages', 0);
INSERT INTO `config` (`module`, `setting`, `value`, `name`, `description`, `parse`) VALUES('OC', 'OC_headerFile', 'header.php', 'Header File', 'File containing the header section of OpenConf pages', 0);
INSERT INTO `config` (`module`, `setting`, `value`, `name`, `description`, `parse`) VALUES ('OC', 'OC_includeSubmissionUploadField', 0, 'Include File Upload Field', 'Includes file upload field on submission page, overriding Include File Upload Link setting.', 0);
INSERT INTO `config` (`module`, `setting`, `value`, `name`, `description`, `parse`) VALUES('OC', 'OC_includeSubmissionUploadLink', '1', 'Include Upload Link', 'Includes file upload link on submission confirmation page if Include File Upload Field is not enabled. Note that Upload File status must also be set to open.', 0);
INSERT INTO `config` (`module`, `setting`, `value`, `name`, `description`, `parse`) VALUES ('OC', 'OC_keycode_program', 'pckey', 'Program Cmt. Keycode', 'Keycode for signing up as a program committee member.', 0);
INSERT INTO `config` (`module`, `setting`, `value`, `name`, `description`, `parse`) VALUES ('OC', 'OC_keycode_reviewer', 'revkey', 'Reviewer Keycode', 'Keycode for signing up as a reviewer committee member.', 0);
INSERT INTO `config` (`module`, `setting`, `value`, `name`, `description`, `parse`) VALUES ('OC', 'OC_logSQL', '0', 'Log DB Update SQL', 'Log the SQL statements used to update database', 0);
INSERT INTO `config` VALUES ('OC', 'OC_mailCopyLast', '0', 'Forward Last Bulk Email', 'Forwards to the Confirm Email address a copy of the last bulk email sent', 0);
INSERT INTO `config` VALUES ('OC', 'OC_mailHeaders', 'From: $OC_confName <$OC_pcemail>\r\nReply-To: $OC_pcemail\r\nX-Mailer: PHP/OpenConf', 'Mail Headers', 'Headers sent to PHP mail() function', 1);
INSERT INTO `config` VALUES ('OC', 'OC_mailParams', NULL, 'Mail Parameters', 'Parameters sent to PHP mail() function', 1);
INSERT INTO `config` (`module`, `setting`, `value`, `name`, `description`, `parse`) VALUES ('OC', 'OC_mailUTF8', '1', 'Encode Mail for UTF-8', 'Sends out encoded messages supporting UTF-8', 0);
INSERT INTO `config` (`module`, `setting`, `value`, `name`, `description`, `parse`) VALUES ('OC', 'OC_minReviewersPerPaper', '3', 'Reviewers per Submission', 'Default minimum number used when auto assigning reviewers to submissions.', 0);
INSERT INTO `config` (`module`, `setting`, `value`, `name`, `description`, `parse`) VALUES ('OC', 'OC_multipleSubmissionTopics', '1', 'Multiple Sub. Topics', 'Allow multiple submission topics to be selected (or just one)', 0);
INSERT INTO `config` (`module`, `setting`, `value`, `name`, `description`, `parse`) VALUES ('OC', 'OC_notifyAuthorEdit', '1', 'Notify of Sub. Edit', 'Notify when a submission is edited (updated).', 0);
INSERT INTO `config` (`module`, `setting`, `value`, `name`, `description`, `parse`) VALUES ('OC', 'OC_notifyAuthorEmailPapers', '0', 'Notify Sub. Requested', 'Notify when list of submissions requested.', 0);
INSERT INTO `config` (`module`, `setting`, `value`, `name`, `description`, `parse`) VALUES ('OC', 'OC_notifyAuthorReset', '0', 'Notify Author Pwd Reset', 'Notify when author resets password', 0);
INSERT INTO `config` (`module`, `setting`, `value`, `name`, `description`, `parse`) VALUES ('OC', 'OC_notifyAuthorSubmit', '1', 'Notify Submission', 'Notify when a submission is made', 0);
INSERT INTO `config` (`module`, `setting`, `value`, `name`, `description`, `parse`) VALUES ('OC', 'OC_notifyAuthorUpload', '1', 'Notify File Uploaded', 'Notify when a file is uploaded', 0);
INSERT INTO `config` (`module`, `setting`, `value`, `name`, `description`, `parse`) VALUES ('OC', 'OC_notifyAuthorWithdraw', '1', 'Notify Sub. Withdrawn', 'Notify when a submission is withdrawn', 0);
INSERT INTO `config` (`module`, `setting`, `value`, `name`, `description`, `parse`) VALUES ('OC', 'OC_notifyIncludeIP', '0', 'Include IP', 'Include IP address in email notices', 0);
INSERT INTO `config` (`module`, `setting`, `value`, `name`, `description`, `parse`) VALUES ('OC', 'OC_notifyReviewerEmailUsername', '0', 'Notify Rev. Email Username', 'Notify when reviewer requests username be emailed', 0);
INSERT INTO `config` (`module`, `setting`, `value`, `name`, `description`, `parse`) VALUES ('OC', 'OC_notifyReviewerReset', '0', 'Notify Reviewer Pwd Reset', 'Notify when a reviewer resets their password', 0);
INSERT INTO `config` (`module`, `setting`, `value`, `name`, `description`, `parse`) VALUES ('OC', 'OC_notifyReviewerSignup', '1', 'Notify Reviewer Sign Up', 'Notify when a reviewer signs up for an account', 0);
INSERT INTO `config` (`module`, `setting`, `value`, `name`, `description`, `parse`) VALUES ('OC', 'OC_paperAdvocates', '1', 'Use Sub. Advocates', 'Indicates whether submission advocate functionality is to be used.', 0);
INSERT INTO `config` (`module`, `setting`, `value`, `name`, `description`, `parse`) VALUES ('OC', 'OC_paperDir', '$OC_dataDir$papers/', 'File Directory', 'Directory where files are stored for review - offset from openconf/[dir]/', 1);
INSERT INTO `config` (`module`, `setting`, `value`, `name`, `description`, `parse`) VALUES ('OC', 'OC_paperFldNote', 'Make sure submission file is completely blinded (i.e., no authors info).', 'File Upload Field Notice', 'Notice appearing with file upload fields.', 0);
INSERT INTO `config` (`module`, `setting`, `value`, `name`, `description`, `parse`) VALUES ('OC', 'OC_paperSubNote', 'Please review the entire form before starting to fill it out to ensure you have all the required information.', 'Submission Notice', 'Notice appearing atop submission page.', 0);
INSERT INTO `config` (`module`, `setting`, `value`, `name`, `description`, `parse`) VALUES ('OC', 'OC_pcemail', 'openconf@example.com', 'Chair Email', 'Used as the general contact email and in case of errors or other follow-up.', 0);
INSERT INTO `config` (`module`, `setting`, `value`, `name`, `description`, `parse`) VALUES ('OC', 'OC_requireSubmissionUploadField', 0, 'Require File Upload Field', 'Requires file to be uploaded at submission if Include File Upload Field enabled.', 0);
INSERT INTO `config` (`module`, `setting`, `value`, `name`, `description`, `parse`) VALUES ('OC', 'OC_reviewerCompleteBeforeSAR', '1', 'Require Rev. Complete Own First', 'Only allow reviewer to see reviews of assigned submissions if own is complete', 0);
INSERT INTO `config` (`module`, `setting`, `value`, `name`, `description`, `parse`) VALUES ('OC', 'OC_reviewerReadPapers', '1', 'Allow Rev. View All Submissions', 'Allow reviewers to read all submittions', 0);
INSERT INTO `config` (`module`, `setting`, `value`, `name`, `description`, `parse`) VALUES ('OC', 'OC_reviewerSeeAssignedReviews', '0', 'Allow Rev. See Assigned Reviews', 'Allow reviewers to see other''s review of assigned submissions', 0);
INSERT INTO `config` (`module`, `setting`, `value`, `name`, `description`, `parse`) VALUES ('OC', 'OC_reviewerSeeAuthors', '0', 'Allow Rev. See Authors', 'Allow reviewers to see submission authors (i.e., non-blind reviews)', 0);
INSERT INTO `config` (`module`, `setting`, `value`, `name`, `description`, `parse`) VALUES ('OC', 'OC_reviewerSeeOtherReviewers', '1', 'Allow Rev. See Other Rev. Info', 'Allow reviewers to see each other''s information', 0);
INSERT INTO `config` (`module`, `setting`, `value`, `name`, `description`, `parse`) VALUES ('OC', 'OC_reviewerSeeOtherReviews', '0', 'Allow Rev. to See All Reviews', 'Allow reviewer to see reviews of non-assigned submissions', 0);
INSERT INTO `config` (`module`, `setting`, `value`, `name`, `description`, `parse`) VALUES ('OC', 'OC_ReviewerTimeout', '60', 'Reviewer Timeout', 'Reviewer session timeout in minutes or enter 0 for no timeout.  Note: subject to server PHP settings.', 0);
INSERT INTO `config` (`module`, `setting`, `value`, `name`, `description`, `parse`) VALUES ('OC', 'OC_studentNote', 'Student submissions must have a full-time student as the primary author and be mostly written by students.', 'Student Notice', 'Notice appearing under Student Yes/No option if students are tracked.', 0);
INSERT INTO `config` (`module`, `setting`, `value`, `name`, `description`, `parse`) VALUES ('OC', 'OC_subBackupEmail', NULL, 'Subm. Backup Email', 'Submission Backup Address - will get a submission''s SQL statements', 0);
INSERT INTO `config` (`module`, `setting`, `value`, `name`, `description`, `parse`) VALUES ('OC', 'OC_subNonEditFields', 'title,student,topics', 'Non-Editable Subm. Fields', 'Comma-delimited list of fields that should not be editable once submission closes.  Valid fields are: title, student, topics.  CAUTION: This is likely a temporary setting.', 0);
INSERT INTO `config` (`module`, `setting`, `value`, `name`, `description`, `parse`) VALUES('OC', 'OC_timeZone', 'UTC', 'Time Zone', 'Default time zone for use by OpenConf', 0);
INSERT INTO `config` (`module`, `setting`, `value`, `name`, `description`, `parse`) VALUES ('OC', 'OC_topicColumns', '1', 'Topic Columns', 'Number of columns to display topics in (1 or 2).  1 will work best for long topic names.', 0);
INSERT INTO `config` (`module`, `setting`, `value`, `name`, `description`, `parse`) VALUES ('OC', 'OC_trackStudent', '1', 'Track Students', 'Is there a need to track whether submissions are by a student?  For example, if a best student submission award is given.', 0);
INSERT INTO `config` (`module`, `setting`, `value`, `name`, `description`, `parse`) VALUES('OC', 'OC_friendlyURLs', '0', 'Friendly URLs', 'Friendly URLs are more easily indexed by search engines.  Only limited parts of OpenConf make use of this option, and it requires RewriteEngine. Use this feature carefully (still under development).', 0);
INSERT INTO `config` (`module`, `setting`, `value`, `name`, `description`, `parse`) VALUES ('OC', 'OC_version', '3.42', 'OpenConf Version', 'Current OpenConf software version, manual modification discouraged.', 0);

# --------------------------------------------------------

#
# Data for table `status`
#

INSERT INTO `status` (`module`, `setting`, `description`, `status`, `name`, `open`, `close`, `dependency`, `order`) VALUES ('OC', 'OC_submissions_open', NULL, 0, 'New Submission', NULL, NULL, NULL, 1);
INSERT INTO `status` (`module`, `setting`, `description`, `status`, `name`, `open`, `close`, `dependency`, `order`) VALUES ('OC', 'OC_edit_open', 'Modify advanced config option OC_subNonEditFields to change field editing restrictions.', 0, 'Edit Submission', NULL, NULL, NULL, 2);
INSERT INTO `status` (`module`, `setting`, `description`, `status`, `name`, `open`, `close`, `dependency`, `order`) VALUES ('OC', 'OC_withdraw_open', NULL, 0, 'Withdraw Submission', NULL, NULL, NULL, 3);
INSERT INTO `status` (`module`, `setting`, `description`, `status`, `name`, `open`, `close`, `dependency`, `order`) VALUES ('OC', 'OC_upload_open', NULL, 0, 'Upload File', NULL, NULL, NULL, 4);
INSERT INTO `status` (`module`, `setting`, `description`, `status`, `name`, `open`, `close`, `dependency`, `order`) VALUES ('OC', 'OC_view_file_open', NULL, 0, 'View File', NULL, NULL, NULL, 5);
INSERT INTO `status` (`module`, `setting`, `description`, `status`, `name`, `open`, `close`, `dependency`, `order`) VALUES ('OC', 'OC_rev_signup_open', NULL, 0, 'Review Cmt. Sign Up', NULL, NULL, NULL, 6);
INSERT INTO `status` (`module`, `setting`, `description`, `status`, `name`, `open`, `close`, `dependency`, `order`) VALUES ('OC', 'OC_rev_signin_open', NULL, 0, 'Review Cmt. Sign In', NULL, NULL, NULL, 7);
INSERT INTO `status` (`module`, `setting`, `description`, `status`, `name`, `open`, `close`, `dependency`, `order`) VALUES ('OC', 'OC_pc_signup_open', NULL, 0, 'Program Cmt. Sign Up', NULL, NULL, 'OC_paperAdvocates', 8);
INSERT INTO `status` (`module`, `setting`, `description`, `status`, `name`, `open`, `close`, `dependency`, `order`) VALUES ('OC', 'OC_pc_signin_open', NULL, 0, 'Program Cmt. Sign In', NULL, NULL, 'OC_paperAdvocates', 9);
        
# --------------------------------------------------------

#
# Data for table `template`
#

INSERT INTO `template` VALUES ('authors_accept', 'OC', 'Authors - Accepted Submission', '[[:OC_confName:]] Your submission has been accepted!', 'On behalf of the [:OC_confNameFull:], I am pleased to inform you that your submission, titled\n\n[:title:]\n\nhas been accepted.  \n\nWe have included the reviewers'' comments at the end of this message.\n\nCongratulations,\n  Program Committee, [:OC_confName:]\n  [:OC_pcemail:]\n\n[:author-comments:]\n');
INSERT INTO `template` VALUES ('authors_nofile', 'OC', 'Authors - Missing File', '[[:OC_confName:]] Missing File', 'Thank you again for submitting to the [:OC_confNameFull:].  Please note however that we have not yet received your file.  At your earliest convenience, please upload your file so that we may begin the review process.  \n\nYour file may be uploaded through the [:OC_confName:] OpenConf system accessible at our Web site: [:OC_confURL:] .\n\nSubmission ID: [:paperid:]\nSubmission Title: [:title:]\n\nThank you,\n  Program Committee, [:OC_confName:]\n  [:OC_pcemail:]\n');
INSERT INTO `template` VALUES ('authors_reject', 'OC', 'Authors - Rejected Submission', '[[:OC_confName:]] Submission [:paperid:] declined', 'Dear Author,\n\nOn behalf of the [:OC_confNameFull:], I am sorry to inform you that your submission, titled \n\n[:title:]\n\nhas not been accepted.  We received many excellent submissions this year, and were limited in the number we could accept.\n\nAt the end of this email you will find a set of comments from the submission reviewers.  If you have questions about the comments, please contact the Program Chair.\n\nSincerely,\n  Program Committee, [:OC_confName:]\n  [:OC_pcemail:]\n\n[:author-comments:]\n');
INSERT INTO `template` VALUES ('pc_assigned', 'OC', 'Program Committee - Submissions Assigned', '[[:OC_confName:]] Submissions have been assigned to advocates', 'Now that the submission reviews have been completed, it is time to perform your advocate duties in preparation for the Program Committee meeting.  Your duties include:\n\n1.	Read all the reviews and be able to present the results of the review at the PC meeting.\n2.	If the reviews are in conflict (for example, some saying Clear Accept, while others say Reject) then we ask that you read the submission (unless you already have) to form your own opinion.\n3.	If you feel that the submission needs an additional review, let us know and we will try to obtain an additional review prior to the PC meeting.\n\nThank you again for supporting [:OC_confNameFull:].\n\n[:OC_confName:] Program Chair\n[:OC_pcemail:]\n[:OC_confURL:]\n');
INSERT INTO `template` VALUES ('pc_norecommendation', 'OC', 'Program Committee - Missing Recommendation', '[[:OC_confName:]] Missing recommendation', 'Dear [:OC_confName:] Advocate,\n\nJust a reminder to complete your submission recommendations as soon as possible.  We show that you have at least one submission assigned for which no recommendation has been provided.\n\nIn case you don''t recall the instructions:\n\nYou will find the submissions assigned to you by going to [:OC_confURL:], selecting OpenConf, and signing in under Committee Members (functions are available to reset your user id and password if you''ve forgotten them).  This will display the list of submissions you have been assigned to review.  Clicking on the submission title will bring up the online review form and clicking on the file symbol to the right of the submission title will bring up a copy of the file.  You may reopen and modify or amend previously submitted reviews.\n\nThank you for your support of [:OC_confNameFull:].\n\n[:OC_confName:] Program Chair\n[:OC_pcemail:]\n[:OC_confURL:]\n');
INSERT INTO `template` VALUES ('reviewers_assigned', 'OC', 'Reviewers - Reviews Assigned', '[[:OC_confName:]] Submissions have been assigned for review', 'Dear [:OC_confName:] Reviewer,\n\nThank you for signing up to review submissions submitted to [:OC_confName:].  It is now time for the review process to begin and submission assignments have been made.  Using the username and password you created when you registered to be a reviewer, you will find the submissions assigned to you by going to [:OC_confURL:], selecting OpenConf, and signing in under Committee Members.  This will display the list of submissions you have been assigned to review.  Clicking on the submission title will bring up the online review form and clicking on the file symbol to the right of the submission title will bring up a copy of the file.  You may reopen and modify or amend previously submitted reviews.\n\nIf you do not remember your username and password, features are available to let you reset them if you still remember the email address you specified when filling out the reviewer registration form.\n\nAs much as possible we tried to assign submissions that we think will interest you.  We apologize in advance if you are not interested or knowledgeable about the topic areas you were assigned.  If you will not be able to review a submission, please inform us IMMEDIATELY so we can reassign the submission to someone else.\n\nREMINDER: By reviewing unpublished submissions, you are accepting the ethical responsibility not to disclose their contents to anyone else.\n\nIf we assigned you your own submission or a submission for which you have a conflict of interest, let us know and we will reassign you!\n\nPlease complete these reviews as soon as possible. \n\nThanks again for helping make [:OC_confNameFull:] a success!\n\n[:OC_confName:] Program Chair\n[:OC_pcemail:]\n');
INSERT INTO `template` VALUES ('reviewers_nocomment', 'OC', 'Reviewers - Missing Author Comments', '[[:OC_confName:]] Missing comments for authors', 'Please be sure to fill out the Comments for the Authors field in all reviews.  We show that you have at least one review assigned for which you have not included any comments.\n\nIn case you don''t recall the instructions:\n\nYou will find the submissions assigned to you by going to [:OC_confURL:], selecting OpenConf, and signing in under Committee Members (functions are available to reset your user id and password if you''ve forgotten them).  This will display the list of submissions you have been assigned to review.  Clicking on the submission title will bring up the online review form and clicking on the file symbol to the right of the submission title will bring up a copy of the file.  You may reopen and modify or amend previously submitted reviews.\n\nThank you for your support of [:OC_confNameFull:].\n\n[:OC_confName:] Program Chair\n[:OC_pcemail:]\n');
INSERT INTO `template` VALUES ('reviewers_noreview', 'OC', 'Reviewers - Missing Review', '[[:OC_confName:]] Missing review', 'Just a reminder to complete your submission reviews as soon as possible.  We show that you have at least one review assigned for which you have not indicated that it is completed or that is missing a recommendation.\n\nIn case you don''t recall the instructions:\n\nYou will find the submissions assigned to you by going to [:OC_confURL:], selecting OpenConf, and signing in under Committee Members (functions are available to reset your user id and password if you''ve forgotten them).  This will display the list of submissions you have been assigned to review.  Clicking on the submission title will bring up the online review form and clicking on the file symbol to the right of the submission title will bring up a copy of the file.  You may reopen and modify or amend previously submitted reviews.\n\nThank you for your support of [:OC_confNameFull:].\n\n[:OC_confName:] Program Chair\n[:OC_pcemail:]\n');
INSERT INTO `template` VALUES ('reviewers_reminder', 'OC', 'Reviewers - Reminder', '[[:OC_confName:]] Submissions have been assigned for review', 'Just a reminder to complete your submission reviews as soon as possible.  For those who haven''t started and don''t recall the instructions:\n\nYou will find the submissions assigned to you by going to [:OC_confURL:], selecting OpenConf, and signing in under Committee Members (functions are available to reset your user id and password if you''ve forgotten them).  This will display the list of submissions you have been assigned to review.  Clicking on the submission title will bring up the online review form and clicking on the file symbol to the right of the submission title will bring up a copy of the file.  You may reopen and modify or amend previously submitted reviews.\n\nThank you for your support of [:OC_confNameFull:].\n\n[:OC_confName:] Program Chair\n[:OC_pcemail:]\n');
        
