<?php

// +----------------------------------------------------------------------+
// | OpenConf                                                             |
// +----------------------------------------------------------------------+
// | Copyright (c) 2002-2009 Zakon Group LLC.  All Rights Reserved.       |
// +----------------------------------------------------------------------+
// | This source file is subject to the OpenConf License, available on    |
// | the OpenConf web site: www.OpenConf.com                              |
// +----------------------------------------------------------------------+

// This program will generate the countries.php file used by OpenConf from
// the ISO 3166-1 XML source file.  You should only need to run this program
// if you update the ISO source file.

// ISO 3166-1 file base; available from:
// http://www.iso.org/iso/country_codes/iso_3166_code_lists.htm (file: XML zipped)
// NOTE: If your version of PHP does not have the ZIP libraries built in
// and enabled, be sure to UnZip the source file.
$isoFileBase = 'iso_3166-1_list_en'; // input (.xml or .zip)

// OpenConf countries file
$countriesFile = 'countries.php'; // output

if (is_file($isoFileBase . '.xml')) {
	$file = file_get_contents($isoFileBase . '.xml') or die('ERROR: Unable to read .xml file');
} elseif (is_file($isoFileBase . '.zip')) {
	if (!function_exists('zip_open')) {
		die('ERROR: ZIP libraries not available; UnZip file manually then run script again');
	}	
	$zipfile = zip_open($isoFileBase . '.zip') or die('ERRROR: Unable to open ZIP file');
	$zipentry = zip_read($zipfile);
	zip_entry_open($zipfile, $zipentry, 'r') or die('ERROR: Unable to open ZIP entry');
	$file = zip_entry_read($zipentry, zip_entry_filesize($zipentry));
	zip_entry_close($zipentry);
	zip_close($zipfile);
} else {
	die('ERROR: ISO source file not found');
}

if (preg_match_all("/<ISO_3166-1_Country_name>([^<]+)<\/ISO_3166-1_Country_name>\s+<ISO_3166-1_Alpha-2_Code_element>(\w\w)<\/ISO_3166-1_Alpha-2_Code_element>/s", $file, $matches)) {
	$countryList = '';
	foreach ($matches[1] as $k => $m) {
		$countryList .= "	'" . $matches[2][$k] . "' => '" . addslashes(utf8_encode(ucwords(strtolower($m)))) . "',\n";
	}
	$newfile = '<?php

// OpenConf Country List
//
// Update manually or use countries-update.php with ISO XML file
// NOTE: This file needs to be in UTF-8 encoding; use caution if editing manually

$OC_countryAR = array(
' . rtrim($countryList, ",\n") . '
);

';
	$fp = fopen($countriesFile, 'w') or die('ERROR: Unable to open output file');
	fwrite($fp, $newfile);
	fclose($fp);
	print "Countries file updated\n";
} else {
	die('ERROR: XML file format unknown');
}

?>