<?php

// +----------------------------------------------------------------------+
// | OpenConf                                                             |
// +----------------------------------------------------------------------+
// | Copyright (c) 2002-2009 Zakon Group LLC.  All Rights Reserved.       |
// +----------------------------------------------------------------------+
// | This source file is subject to the OpenConf License, available on    |
// | the OpenConf web site: www.OpenConf.com                              |
// +----------------------------------------------------------------------+

require_once "../include.php";

beginChairSession();

printHeader("Modules",1);

?>
<p>Additional OpenConf functionality is available through modules.  In order to use a module, you must first install it, and then activate it.  If a module is installed, but not active, its data will still be preserved.  Uninstalling a module will results in the module's data being deleted.</p>
<p>The <i>Source</i> column indicates whether the module was developed by the OpenConf team or a third-party.</p>
<br />

<div class="legend">
<span style="background-color: #0f0; color: #000; padding: 3px">&#8226;</span> Active
&nbsp; &nbsp;
<span style="background-color: #f99; color: #000; padding: 3px">o</span> Disabled
&nbsp; &nbsp;
<span style="background-color: #f00; color: #000; padding: 3px">x</span> Not Installed
</div>
<p />

<table border="0" cellspacing="1" cellpadding="5">
<tr class="rowheader"><th>&nbsp;</th><th>Module Name</th><th>Version</th><th>Source</th><th>Description</th><th colspan="3">Action</th></tr>

<?php

$row = 1;

// Display installed modules sorted by name
$moduleNamesAR = array();
foreach ($OC_modulesAR as $mID => $mAR) {
	$moduleNamesAR[$mID] = $mAR['name'];
}
asort($moduleNamesAR);
foreach ($moduleNamesAR as $mID => $mName) {
	// is module activate or disabled?
	if (in_array($mID,$OC_activeModulesAR)) {
		$color = '#0f0';
		$symbol = '&#8226;';
		$action = 'deactivate';
	} else {
		$color = '#f99';
		$symbol = 'o';
		$action = 'activate';
	}
	// Is module configurable?
	if (is_file($mID . '/settings.inc')) {
		$configURL = 'request.php?module=' . $mID . '&action=settings.inc';
	} else {
		$configURL = '';
	}
	// Readme?
	if (is_file($mID . '/README.html')) {
		$version = '<a href="' . $mID . '/README.html" title="Click for module info (new window)" target="_blank">' . safeHTMLstr($OC_modulesAR[$mID]['version']) . '</a>';
	} else {
		$version = safeHTMLstr($OC_modulesAR[$mID]['version']);
	}
	print '<tr class="row' . $row . ' rowselect"><td style="background-color: ' . $color . '; color: #000">' . $symbol . '</td><td>' . (empty($configURL) ? safeHTMLstr($OC_modulesAR[$mID]['name']) : ('<a href="' . $configURL . '" title="click to config">' . safeHTMLstr($OC_modulesAR[$mID]['name']) . '</a>')) . '</td><td style="text-align: center">' . $version . '</td><td>' . (($OC_modulesAR[$mID]['developer'] == 'OpenConf') ? 'OpenConf' : 'Third-Party') . '</td><td>' . safeHTMLstr($OC_modulesAR[$mID]['description']) . '</td><td>'  . (empty($configURL) ? '</td>' : ('<a href="' . $configURL . '">config</a></td>')) . '<td style="text-align: center"><a href="' . $action . '.php?module=' . $mID . '">' . $action . '</a></td><td><a href="uninstall.php?module=' . $mID . '" onclick="return confirm(\'Please confirm your request to uninstall this module.  All data stored by module will be deleted.\')">uninstall</a></td></tr>';
	$row = $rowAR[$row];
}

// Get uninstalled modules
$uninstalledModulesAR = array();
if ($dh = opendir('./')) {
	while (($dir = readdir($dh)) !== false) {
		if ((filetype($dir) == 'dir') && !preg_match("/[\.\/]/",$dir) && is_file($dir . '/module.inc') && !oc_moduleInstalled($dir) && oc_moduleValid($dir)) {
			require_once $dir . '/module.inc';
			$uninstalledModulesAR[] = $dir;
		}
	}
}
// Show a break between uninstalled modules
if (!empty($moduleNamesAR) && !empty($uninstalledModulesAR)) {
	print '<tr><td class="rowheader" colspan="10" style="height: 10px"></td></tr>';
}
// Sort & display uninstalled modules
$moduleNamesAR = array();
foreach ($uninstalledModulesAR as $mID) {
	if ((OCC_LICENSE != 'Public') || !preg_match("/^oc_/", $mID)) {
		$moduleNamesAR[$mID] = $OC_modulesAR[$mID]['name'];
	}
}
asort($moduleNamesAR);
$color = '#f33';
$symbol = 'x';
foreach ($moduleNamesAR as $mID => $mName) {
	// Readme?
	if (is_file($mID . '/README.html')) {
		$version = '<a href="' . $mID . '/README.html" title="Click for module info (new window)" target="_blank">' . safeHTMLstr($OC_modulesAR[$mID]['version']) . '</a>';
	} else {
		$version = safeHTMLstr($OC_modulesAR[$mID]['version']);
	}
	print '<tr class="row' . $row . ' rowselect"><td style="background-color: ' . $color . '; color: #000">' . $symbol . '</td><td>' . safeHTMLstr($OC_modulesAR[$mID]['name']) . '</td><td style="text-align: center">' . $version . '</td><td>' . (($OC_modulesAR[$mID]['developer'] == 'OpenConf') ? 'OpenConf' : 'Third-Party') . '</td><td>' . safeHTMLstr($OC_modulesAR[$mID]['description']) . '</td><td>&nbsp;</td><td>&nbsp;</td><td style="text-align: center"><a href="install.php?module=' . $mID . '">install</a></td></tr>';
	$row = $rowAR[$row];
}

if (OCC_LICENSE == 'Public') {
	print '
<tr><td class="rowheader" colspan="10" style="height: 10px"></td></tr>
<tr class="row' . ($row = $rowAR[$row]) . ' rowselect"><td>' . $symbol . '</td><td>Acceptance</td><td>&nbsp;</td><td>OpenConf</td><td>Provides Chair with the ability to change acceptance options</td><td colspan="3" style="text-align: center"><a href="http://www.openconf.com/sales/" target="_blank">professional edition only</a></td></tr>
<tr class="row' . ($row = $rowAR[$row]) . ' rowselect"><td>' . $symbol . '</td><td>Bidding</td><td>&nbsp;</td><td>OpenConf</td><td>Bidding on papers by reviewers, and bid-based assignments</td><td colspan="3" style="text-align: center"><a href="http://www.openconf.com/sales/" target="_blank">professional edition only</a></td></tr>
<tr class="row' . ($row = $rowAR[$row]) . ' rowselect"><td>' . $symbol . '</td><td>Discussion</td><td>&nbsp;</td><td>OpenConf</td><td>Online discussion (forum) for committee members</td><td colspan="3" style="text-align: center"><a href="http://www.openconf.com/sales/" target="_blank">professional edition only</a></td></tr>
<tr class="row' . ($row = $rowAR[$row]) . ' rowselect"><td>' . $symbol . '</td><td>Proceedings</td><td>&nbsp;</td><td>OpenConf</td><td>Online proceedings</td><td colspan="3" style="text-align: center"><a href="http://www.openconf.com/sales/" target="_blank">professional edition only</a></td></tr>
<tr class="row' . ($row = $rowAR[$row]) . ' rowselect"><td>' . $symbol . '</td><td>Program</td><td>&nbsp;</td><td>OpenConf</td><td>Program building and display options</td><td colspan="3" style="text-align: center"><a href="http://www.openconf.com/sales/" target="_blank">professional edition only</a></td></tr>
<tr class="row' . ($row = $rowAR[$row]) . ' rowselect"><td>' . $symbol . '</td><td>Rebuttal</td><td>&nbsp;</td><td>OpenConf</td><td>Author rebuttal of reviews, and reviewer rebuttal of author comments</td><td colspan="3" style="text-align: center"><a href="http://www.openconf.com/sales/" target="_blank">professional edition only</a></td></tr>
<tr class="row' . ($row = $rowAR[$row]) . ' rowselect"><td>' . $symbol . '</td><td>Sub. Type</td><td>&nbsp;</td><td>OpenConf</td><td>Enables tracking of different submission types</td><td colspan="3" style="text-align: center"><a href="http://www.openconf.com/sales/" target="_blank">professional edition only</a></td></tr>
';
}

?>
</table>
<p />

<?php
printFooter();
?>