<?php

// +----------------------------------------------------------------------+
// | OpenConf                                                             |
// +----------------------------------------------------------------------+
// | Copyright (c) 2002-2009 Zakon Group LLC.  All Rights Reserved.       |
// +----------------------------------------------------------------------+
// | This source file is subject to the OpenConf License, available on    |
// | the OpenConf web site: www.OpenConf.com                              |
// +----------------------------------------------------------------------+

// Don't cache
header("Expires: Mon, 18 Sep 2003 13:00:00 GMT");
header("Last-Modified: " . gmdate("D, d M Y H:i:s") . " GMT");
header("Cache-Control: no-store, no-cache, must-revalidate");
header("Cache-Control: post-check=0, pre-check=0", false);
header("Pragma: no-cache");

require_once "include.php";

// Has OpenConf been installed yet?
if (!defined('OCC_INSTALL_COMPLETE') || !OCC_INSTALL_COMPLETE) {
	header("Location: chair/install.php");
	exit;
}

printHeader("");

if (oc_hookSet('home-menu-top')) {
	foreach ($OC_hooksAR['home-menu-top'] as $v) {
		print $v;
	}
}


print '
<b>Authors:</b><ul>
';

if ($OC_statusAR['OC_submissions_open']) {
	print '<li><a href="author/submit.php">Make a Submission</a></li>';
} else { 
	print '<li><i>Submission is closed</i><p /></li>';
}

if ($OC_statusAR['OC_edit_open']) {
	print '<li><a href="author/edit.php">Edit Submission</a></li>';
}
if ($OC_statusAR['OC_upload_open']) {
	print '<li><a href="author/upload.php">Upload File</a></li>';
}
if ($OC_statusAR['OC_view_file_open']) {
	print '<li><a href="author/paper.php">View File</a></li>';
}
if ($OC_statusAR['OC_withdraw_open']) {
	print '<li><a href="author/withdraw.php">Withdraw Submission</a></li>';
}

if (oc_hookSet('home-menu-author')) {
	print '<p />';
	foreach ($OC_hooksAR['home-menu-author'] as $v) {
		print '<li>' . $v . '</li>';
	}
}

print '
</ul>
<p />
';

if ($OC_configAR['OC_paperAdvocates']) {
	print '
<b>Review &amp; Program Committees:</b><ul>
';
} else {
	print '
<b>Reviewers:</b><ul>
';
}

// Committee Signin open?
if ($OC_statusAR['OC_rev_signin_open'] || ($OC_configAR['OC_paperAdvocates'] && $OC_statusAR['OC_pc_signin_open'])) {
	print '<li><a href="review/signin.php">Sign In</a><p />';
	$signin = true;
} else { $signin = false; }

// Committee Signup open?
if ($OC_statusAR['OC_rev_signup_open'] || ($OC_configAR['OC_paperAdvocates'] && $OC_statusAR['OC_pc_signup_open'])) {
	print '
<li>
<form method="post" action="review/signup.php">
Sign up <br /><dl><dd><i>keycode required: </i>
<input type="password" name="keycode" size=10 />
<input type="submit" value="Enter" />
</dl>
</form>
	';
}
elseif (!$signin) {
		print "<li><i>Committee sign-in is closed</i><p /></li>\n";
}

if (oc_hookSet('home-menu-committees')) {
	print '<p />';
	foreach ($OC_hooksAR['home-menu-committees'] as $v) {
		print '<li>' . $v . '</li>';
	}
}

print '
</ul>
<p />

<b>Program Chair:</b><ul>
<li><a href="chair/signin.php">Sign In</a></li>
';

if (oc_hookSet('home-menu-chair')) {
	print '<p />';
	foreach ($OC_hooksAR['home-menu-chair'] as $v) {
		print '<li>' . $v . '</li>';
	}
}

print '
</ul>
<p />
';

if (oc_hookSet('home-menu-extras')) {
	foreach ($OC_hooksAR['home-menu-extras'] as $v) {
		print $v;
	}
}


printFooter();

?>
