<?php

// +----------------------------------------------------------------------+
// | OpenConf                                                             |
// +----------------------------------------------------------------------+
// | Copyright (c) 2002-2009 Zakon Group LLC.  All Rights Reserved.       |
// +----------------------------------------------------------------------+
// | This source file is subject to the OpenConf License, available on    |
// | the OpenConf web site: www.OpenConf.com                              |
// +----------------------------------------------------------------------+

require_once "../include.php";

beginSession();

printHeader("Reviews", 2);

// Advocate?
if ($_SESSION[OCC_SESSION_VAR_NAME]['acpc'] != "T") {
	err("You are not listed as being on the program committee");
}

// Valid PID?
if (isset($_POST['submit'])) {
	if (!isset($_POST['pid']) || !preg_match("/^\d+$/",$_POST['pid'])) {
		warn('Invalid submission id');
	} else {
		$pid = $_POST['pid'];
	}
} elseif (!isset($_GET['pid']) || !preg_match("/^\d+$/",$_GET['pid'])) {
	warn('Invalid submission id');
} else {
	$pid = $_GET['pid'];
}

require_once "../review/review_inc.php";

// Warn if conflict
$conflictAR = getConflicts($_SESSION[OCC_SESSION_VAR_NAME]['acreviewerid']);
if (in_array($_REQUEST['pid'] . '-' . $_SESSION[OCC_SESSION_VAR_NAME]['acreviewerid'], $conflictAR)) {
 	warn("You appear to have a conflict with this submission");
}


// Make sure advocate is assigned paper and get title/format
$q3 = "SELECT `title`, `format` FROM `" . OCC_TABLE_PAPER . "`, `" . OCC_TABLE_PAPERADVOCATE . "` WHERE `" . OCC_TABLE_PAPER . "`.`paperid`='" . safeSQLstr($pid) . "' AND `" . OCC_TABLE_PAPERADVOCATE . "`.`paperid`=`" . OCC_TABLE_PAPER . "`.`paperid` AND `" . OCC_TABLE_PAPERADVOCATE . "`.`advocateid`='" . $_SESSION[OCC_SESSION_VAR_NAME]['acreviewerid'] . "'";
$r3 = ocsql_query($q3) or err("Unable to get submission info");
if (mysql_num_rows($r3) != 1) { err("Unable to retrieve submission info; perhaps you are not its advocate?"); }
else {
	$l3 = mysql_fetch_array($r3);

	// Check whether its a recommendation submission
	if (isset($_POST['submit']) && ($_POST['submit'] == "Submit Recommendation")) {
		// Check for valid submission
		if (!validToken('ac')) {
			warn('Invalid submission');
		}

		$pq = "UPDATE `" . OCC_TABLE_PAPERADVOCATE . "` SET ";
		if (isset($_POST['rec']) && isset($OC_acceptanceColorAR[$_POST['rec']])) {
			$pq .= "`adv_recommendation`='" . safeSQLstr($_POST['rec']) . "', ";
		} else {
			$pq .= "`adv_recommendation`=NULL, ";
		}
		$pq .= " `adv_comments`='" . safeSQLstr(varValue('comments', $_POST)) . "'";
		$pq .= " WHERE `paperid`='" . safeSQLstr($pid) . "' AND `advocateid`='" . $_SESSION[OCC_SESSION_VAR_NAME]['acreviewerid'] . "'";
		ocsql_query($pq) or err("Unable to submit recommendation - ".mysql_errno());
		print 'Recommendation has been submitted.<p><a href="reviewer.php">Return to Reviewer page</a><p>';
		printFooter();
		exit;
	}
	
	print '
<b>Submission ID:</b> ' . safeHTMLstr($pid) . '<br>
<b>Title:</b> '. safeHTMLstr($l3['title']);

	$q = "SELECT " . OCC_TABLE_PAPERREVIEWER . ".*, CONCAT_WS(' '," . OCC_TABLE_REVIEWER . ".name_first," . OCC_TABLE_REVIEWER . ".name_last) as name, " . OCC_TABLE_REVIEWER . ".email FROM " . OCC_TABLE_PAPERREVIEWER . ", " . OCC_TABLE_REVIEWER . " WHERE " . OCC_TABLE_PAPERREVIEWER . ".paperid='" . safeSQLstr($pid) . "' AND " . OCC_TABLE_PAPERREVIEWER . ".reviewerid=" . OCC_TABLE_REVIEWER . ".reviewerid ORDER BY recommendation, reviewerid";
	$r = ocsql_query($q) or err("Unable to get information ".mysql_errno());
	if (mysql_num_rows($r)==0) { 
		print "<p />No reviewers have been assigned to this submission<p>\n";
	} else {

		// email reviewers link
		if ($emailList = getPaperReviewersEmail($pid)) {
			print '<br /><b>Email:</b> <a href="mailto:' . $emailList . '">Reviewers</a>';
		}

		// Advocate recommendation
		$advq = "SELECT adv_recommendation, adv_comments FROM " . OCC_TABLE_PAPERADVOCATE . " WHERE paperid='" . safeSQLstr($pid) . "' AND advocateid='" . $_SESSION[OCC_SESSION_VAR_NAME]['acreviewerid'] . "'";
		$advr = ocsql_query($advq) or err("Unable to get advocate info");
		$advl = mysql_fetch_array($advr);
		print '
<p />
<form method="POST" ACTION="'.$_SERVER['PHP_SELF'].'">
<input type="hidden" name="token" value="' . $_SESSION[OCC_SESSION_VAR_NAME]['actoken'] . '" />
<input type="hidden" name="pid" value="' . safeHTMLstr($pid) . '">
<table border=0 cellspacing=0 cellpadding=0>
<tr><td valign="top"><b>Recommendation:</b></td><td><nobr> &nbsp; &nbsp;</nobr></td><td>
';

		foreach ($OC_acceptanceValuesAR as $acc) {
			print '<label><input type="radio" name="rec" value="' . safeHTMLstr($acc['value']) . '"';
			if ($acc['value'] == $advl['adv_recommendation']) {
				print " checked";
			}
			print ' /> ' . safeHTMLstr($acc['value']) . "</label><br />";
		}

		print '
<label><input type="radio" name="rec" value="" /> Undecided</label><br />
<br /></td></tr>
<tr><td valign="top"><b>Committee Comments:</b></td><td>&nbsp;</td><td>
<textarea name="comments" rows=10 cols=60>' . safeHTMLstr($advl['adv_comments']) . '</textarea>
</td></tr>
</table>
<p>
<input type="submit" name="submit" value="Submit Recommendation">
</form>
';

		// Display Reviews
		displayReviews($pid, $r);
	}
}

printFooter();

?>
