<?php
require_once "../include.php";
beginSession();
printHeader("Reviewer Guidelines",2);

?>

The following are guidelines we suggest that you follow while you are reviewing submissions. By following these guidelines you will help the Program Committee in their final submission selection process and help make the Program the best ever.
<p>
1. In addition to filling out the ranking information on the Review Form, you must provide comments to the Authors and to the Program Committee (the review will not be accepted without comments). We recommend that you jot down notes while you are reading the submission. In many cases the rankings from different reviewers are at different ends of the spectrum and the comments are needed to reconcile the differences.
<p>
2. In order to get the program put together in time we need your reviews done on time. If you find that you will not be able to complete your reviews, please let the Program Chair know as soon as possible so that your submissions can be reassigned to another reviewer.
<p>
3. With the diversity of areas of expertise, it is not always possible to match a submission's topic with the reviewer's background or interests. If you believe that you cannot provide a good review of a submission due to a mismatch between your background and/or interests, please notify the Program Chair as soon as possible. If you would like to arrange a review from a colleague with the appropriate background, please coordinate this with the Program Chair.
<p>
4. A general rule is "Don't spend more time reviewing the submission than the author spent writing it." If you find that a submission has so many problems that it would require a complete rewrite to save it, make a reasonable number of comments and reject the submission.
<p>
5. If you receive a submission without references, please note this and factor it into your review.  If you can provide comments back to the authors on relevant references that they should have reviewed or at least cited, please include this information in your comments.
<p>
6. If you review a submission that is excessively similar to previously published submissions (or you have reason to believe that the submission has previously been published), please check the appropriate box on the form and note this in your comments to the Program Committee.
<p>
7. Editorial comments are helpful to authors. However, readability is a factor in a good submission. If the use of language is so poor that it makes reading difficult, please note this in your comments and reflect it in your ranking.
<p>
8. On occasion, a submission is so poor that reading the entire submission is impossible. If you were not able to read the entire submission, please note this in your comments to the Program Committee.
<p>
9. The review form includes a list of topics corresponding to potential session headings, please select the best one or two topic areas under which the submission would best fit. Please indicate this selection even if you suggest that the submission should be rejected.
<p>
10. Be on the look out for best submissions, keeping an eye out for innovative ideas and clear presentation.
<p>

If you have any questions about how to review a submission, send your questions to the <a href="mailto:<?php echo $OC_configAR['OC_pcemail']; ?>">Program Chair</a>.
<p>
Finally, thank you for being a reviewer. We hope to see you at the conference.

<?php

printFooter();

?>
