<?php

// +----------------------------------------------------------------------+
// | OpenConf                                                             |
// +----------------------------------------------------------------------+
// | Copyright (c) 2002-2009 Zakon Group LLC.  All Rights Reserved.       |
// +----------------------------------------------------------------------+
// | This source file is subject to the OpenConf License, available on    |
// | the OpenConf web site: www.OpenConf.com                              |
// +----------------------------------------------------------------------+

require_once "../include.php";

$fileTableHeader = '<th>File</th>'; // table header used for file column
$formatField = '`format`'; // paper table format field
$blanks = '<td>&nbsp;</td><td>&nbsp;</td>'; // cell padding (see below)

beginSession();

printHeader("View Submissions",2);

// Get permissions
$readOtherPapers = 0;
$seeAssignedReviews = 0;
$seeOtherReviews = 0;
$seeIncomplete = 1;
// If advocate, apply advocate permissions
if ($_SESSION[OCC_SESSION_VAR_NAME]['acpc'] == "T") {
	$seeAssignedReviews = 1;
	if ($OC_configAR['OC_advocateReadPapers']) { $readOtherPapers = 1; }
	if ($OC_configAR['OC_advocateSeeOtherReviews']) { $seeOtherReviews = 1; }
}
if ($OC_configAR['OC_reviewerReadPapers']) { $readOtherPapers = 1; }
if ($OC_configAR['OC_reviewerSeeAssignedReviews']) { $seeAssignedReviews = 1; }
if ($OC_configAR['OC_reviewerSeeOtherReviews']) { $seeOtherReviews = 1; }
if ($OC_configAR['OC_reviewerCompleteBeforeSAR']) { $seeIncomplete = 0; }
// Anything left to see?
if (!$readOtherPapers && !$seeAssignedReviews && !$seeOtherReviews) {
	warn("Settings prohibit viewing additional submission information");
}

// Get list of assigned papers & incomplete reviews
$assignedPaperAR = array();
$incompleteReviewAR = array();
$q = "SELECT `paperid`, `completed`, `recommendation` FROM `" . OCC_TABLE_PAPERREVIEWER . "` WHERE `reviewerid`='" . $_SESSION[OCC_SESSION_VAR_NAME]['acreviewerid'] . "'";
$r = ocsql_query($q) or err("Unable to retrieve permitted reviews - " . mysql_errno());
while ($l=mysql_fetch_array($r)) {
	$assignedPaperAR[] = $l['paperid'];
	if (($l['completed'] == 'F') || !$l['recommendation']) {
		$incompleteReviewAR[] = $l['paperid'];
	}
}

// If advocate, get list of advocating papers
$advocatingPaperAR = array();
if ($_SESSION[OCC_SESSION_VAR_NAME]['acpc'] == "T") {
	$q = "SELECT `paperid` FROM `" . OCC_TABLE_PAPERADVOCATE . "` WHERE `advocateid`='" . $_SESSION[OCC_SESSION_VAR_NAME]['acreviewerid'] . "'";
	$r = ocsql_query($q) or err("Unable to retrieve advocating submissions - " . mysql_errno());
	while ($l=mysql_fetch_array($r)) {
		$advocatingPaperAR[] = $l['paperid'];
	}
}

// Get list of conflicts
$conflictAR = getConflicts($_SESSION[OCC_SESSION_VAR_NAME]['acreviewerid']);

if (oc_hookSet('committee-list_papers-preprocess')) {
	foreach ($OC_hooksAR['committee-list_papers-preprocess'] as $v) {
		require_once $v;
	}
}

// List papers
$q = "SELECT `paperid`, `title`, " . $formatField . " FROM `" . OCC_TABLE_PAPER . "` ORDER BY `paperid`";
$r = ocsql_query($q) or err("Unable to get submissions");
if (mysql_num_rows($r) == 0) { print '<span class="warn">No submissions have been made yet.</span><p>'; }
else {
	$row = 1;
	print '<p class="note">Note: bold submission titles indicate ones you are reviewing';
	if ($_SESSION[OCC_SESSION_VAR_NAME]['acpc'] == "T") { print " or advocating"; }
	print '</p>';
	print '<table border="0" cellspacing="1" cellpadding="4"><tr class="rowheader">';
	if ($seeAssignedReviews || $seeOtherReviews) { print '<th>Reviews</th>'; }
	print "<th>Abstract</th>" . $fileTableHeader . "<th>Submission ID. Title</th></tr>\n";
	while ($l = mysql_fetch_array($r)) {
		// Skip if in conflict
		if (in_array($l['paperid'].'-'.$_SESSION[OCC_SESSION_VAR_NAME]['acreviewerid'],$conflictAR)) {
			continue;
		}
		
		if (in_array($l['paperid'],$assignedPaperAR)) { $assigned = 1; }
		else { $assigned = 0; }
		if (in_array($l['paperid'],$incompleteReviewAR)) { $completed = 0; }
		else { $completed = 1; }
		if (in_array($l['paperid'],$advocatingPaperAR)) { $advocating = 1; }
		else { $advocating = 0; }

		$i = 0;
		$tr = '';

		if ($seeAssignedReviews || $seeOtherReviews) {
			if ($advocating || (($seeIncomplete || $completed) && (($seeOtherReviews && !$assigned) || ($seeAssignedReviews && $assigned)))) {
				$tr .= '<td align="center"><a href="show_reviews.php?pid=' . $l['paperid'] . '">view</a></td>';
				$i++;
			} else {
				$tr .= '<td>&nbsp;</td>';
			}
	  	}
		if (($assigned || $advocating || $readOtherPapers)) {
			$i++;
			$tr .= '<td align="center"><a href="show_abstract.php?pid=' . $l['paperid'] . '"><img src="../images/document-sm.gif" border="0" alt="view abstract" title="view abstract" width="13" height="16" /></a></td>' . oc_printFileCells($l);
		} else {
			$tr .= $blanks;
		}
		if ($i > 0) {
			print '<tr class="row' . $row . '">' . $tr . '<td>';
			$paperstr = $l['paperid'] . '. ' . safeHTMLstr($l['title']);
			if ($assigned || $advocating) { print "<b><i>$paperstr</i></b>"; }
			else { print $paperstr; }
			print '</td></tr>';
			$row = $rowAR[$row];
		}
	}
	print '</table>';
}

printFooter();

?>
