<?php

// +----------------------------------------------------------------------+
// | OpenConf                                                             |
// +----------------------------------------------------------------------+
// | Copyright (c) 2002-2009 Zakon Group LLC.  All Rights Reserved.       |
// +----------------------------------------------------------------------+
// | This source file is subject to the OpenConf License, available on    |
// | the OpenConf web site: www.OpenConf.com                              |
// +----------------------------------------------------------------------+

require_once "../include.php";
require_once OCC_MIME_FILE;

$dir = $OC_configAR['OC_paperDir'];

if (isset($_GET['c']) && ($_GET['c'] == 1)) {
	beginChairSession();
	$printHeaderFunction = 1;   // chair
} else {    // not chair
	beginSession();
	$printHeaderFunction = 2;   //reviewer
}

// Check for valid file name
if (!preg_match("/^(\d+)\.(\w+)$/",$_GET['p'],$matches)) {
	printHeader("File Retrieval Error",$printHeaderFunction);
	warn("Invalid submission file: " . safeHTMLstr($_GET['p']));
}

// Extract paper ID
$pid = $matches[1];

// Permission checks for reviewers
if ($printHeaderFunction == 2) {
	// Check for conflict
	$conflictAR = getConflicts($_SESSION[OCC_SESSION_VAR_NAME]['acreviewerid']);
	if (in_array($pid.'-'.$_SESSION[OCC_SESSION_VAR_NAME]['acreviewerid'],$conflictAR)) {
		printHeader("File Retrieval",2);
		warn("You have a conflict with this submission and may not retrieve it");
	}

	$ok = 0;
	// Check that reviewer has permission
	if ($OC_configAR['OC_reviewerReadPapers']) {
		$ok = 1;
	} else {    // make sure reviewer is assigned
		$q = "SELECT paperid FROM " . OCC_TABLE_PAPERREVIEWER . " WHERE paperid=" . $pid . " AND reviewerid=" . $_SESSION[OCC_SESSION_VAR_NAME]['acreviewerid'];
		$r = ocsql_query($q) or err("Unable to check reviewer permissions " . mysql_errno());
		if (mysql_num_rows($r) == 1) {
 			$ok = 1;
		}
	}
	// If not ok, check if advocate & has permission
	if (!$ok && ($_SESSION[OCC_SESSION_VAR_NAME]['acpc'] == "T")) {
		if ($OC_configAR['OC_advocateReadPapers']) {
			$ok = 1;
		} else { // make sure advocate is assigned
			$q = "SELECT paperid FROM " . OCC_TABLE_PAPERADVOCATE . " WHERE paperid=" . $pid . " AND advocateid=" . $_SESSION[OCC_SESSION_VAR_NAME]['acreviewerid'];
			$r = ocsql_query($q) or err("Unable to check advocate permissions " . mysql_errno());
			if (mysql_num_rows($r) == 1) {
	  			$ok = 1;
	  		}
		}
	}
	
	// If still not ok, show error
	if (!$ok) {
		printHeader("File Retrieval",2);
		warn("You do not have permission to retrieve this submission");
	}
} // reviewer

if (oc_hookSet('committee-paper-predisplay')) {
	foreach ($OC_hooksAR['committee-paper-predisplay'] as $v) {
		require_once $v;
	}
}

if (! oc_displayFile($dir . $_GET['p'], $matches[2])) {
	printHeader("File Retrieval Error", $printHeaderFunction);
	warn("Unable to retrieve file " . $_GET['p']);
}

exit;
?>
