<?php

// +----------------------------------------------------------------------+
// | OpenConf                                                             |
// +----------------------------------------------------------------------+
// | Copyright (c) 2002-2009 Zakon Group LLC.  All Rights Reserved.       |
// +----------------------------------------------------------------------+
// | This source file is subject to the OpenConf License, available on    |
// | the OpenConf web site: www.OpenConf.com                              |
// +----------------------------------------------------------------------+

require_once "../include.php";
require_once "review_inc.php";

$fileTableHeader = '<th>File</th>'; // table header used for file column
$formatField = '`format`'; // paper table format field

beginSession();

printHeader("Committee Member",2);

print "<dl>\n";

$conflictAR = getConflicts($_SESSION[OCC_SESSION_VAR_NAME]['acreviewerid']);

if (oc_hookSet('committee-menu-preprocess')) {
	foreach ($OC_hooksAR['committee-menu-preprocess'] as $v) {
		require_once $v;
	}
}

// Can reviewers still sign-in?
if ($OC_statusAR['OC_rev_signin_open']) {
	if ($OC_configAR['OC_reviewerReadPapers'] || $OC_configAR['OC_reviewerSeeAssignedReviews'] || $OC_configAR['OC_reviewerSeeOtherReviews'] || (($_SESSION[OCC_SESSION_VAR_NAME]['acpc'] == "T") && $OC_configAR['OC_advocateSeeOtherReviews'])) {
		print '<dt>&#8226; <b><a href="list_papers.php">View Submissions</a></b><p /></dt>';
	}
	
	if (oc_hookSet('committee-menu-prereview')) {
		foreach ($OC_hooksAR['committee-menu-prereview'] as $v) {
			print '<dt>&#8226; ' . $v . '<p /></dt>';
		}
	}
	if (oc_hookSet('committee-menu-pc-prereview') && ($_SESSION[OCC_SESSION_VAR_NAME]['acpc'] == "T") && $OC_statusAR['OC_pc_signin_open']) {
		foreach ($OC_hooksAR['committee-menu-pc-prereview'] as $v) {
			print '<dt>&#8226; ' . $v . '<p /></dt>';
		}
	}

	print '
<dt>&#8226; <b>Submissions to Review:</b></dt>
<dd><br />
';
	$q = "SELECT `" . OCC_TABLE_PAPERREVIEWER . "`.`paperid`, " . $formatField . ", `title`, `completed` FROM `" . OCC_TABLE_PAPERREVIEWER . "`, `" . OCC_TABLE_PAPER . "` WHERE `reviewerid`='" . $_SESSION[OCC_SESSION_VAR_NAME]['acreviewerid'] . "' AND `" . OCC_TABLE_PAPERREVIEWER . "`.`paperid`=`" . OCC_TABLE_PAPER . "`.`paperid`";
	$r = ocsql_query($q) or err("Unable to retrieve submissions for review<p>$q");
	if (mysql_num_rows($r) == 0) { 
		print '<span class="err">You do not have any submissions to review.</span><p>';
	} else {
		print '<table border="0" cellspacing="0" cellpadding="0"><tr><td><i>Legend:</i> &nbsp; &nbsp; &nbsp; </td><td bgcolor="#66ff66"> &nbsp;o&nbsp; </td><td> &nbsp; <i>Review completed</i> &nbsp; &nbsp; &nbsp; </td><td bgcolor="#ff6666"> &nbsp;x&nbsp; </td><td> &nbsp; <i>Review not yet completed</i></td></tr></table><p>';
		print '<table border="0" cellspacing="1" cellpadding="3"><tr class="rowheader"><th>&nbsp;</th><th>Title / Review Form</th><th>Abstract</th>' . $fileTableHeader . '</tr>';
		$row = 1;
		while ($p = mysql_fetch_array($r)) {
			// Skip if in conflict
			if (in_array($p['paperid'] . '-' . $_SESSION[OCC_SESSION_VAR_NAME]['acreviewerid'], $conflictAR)) { continue; }

			if ($p['completed'] == "T") { $color = "#66ff66"; $symbol = "o"; }
			else { $color = "#ff6666"; $symbol = "x"; }
			print '<tr class="row' . $row . '"><td valign="top" bgcolor="' . $color.'">&nbsp;' . $symbol . '&nbsp;</td><td valign="top"><a href="review.php?pid=' . $p['paperid'] . '" alt="review form for submission ID ' . $p['paperid'] . '">' . $p['paperid'] . ' - ' .  safeHTMLstr($p['title']) . '</a></td><td align="center"><a href="show_abstract.php?pid=' . $p['paperid'] . '"><img src="../images/document-sm.gif" border="0" alt="view abstract" title="view abstract" width="13" height="16" /></a></td>' . oc_printFileCells($p) . "</tr>\n";
			$row = $rowAR[$row];
		}
		print "</table>\n";
		print "<p><br /><i>Tip:</i> To download a file instead of opening it, right-click on the file icon and select <i>Save ...</i></p>\n"; 
		print 'A <a href="review.php?pid=blank" target="_blank">blank review form</a> (that opens in a separate window) is available for you to print out if you prefer writing it out before typing it in.<p>';
	}
	print '</dd>';
}

if (($_SESSION[OCC_SESSION_VAR_NAME]['acpc'] == "T") && $OC_statusAR['OC_pc_signin_open']) {
	if (! $OC_statusAR['OC_rev_signin_open']) {
		if ($OC_configAR['OC_advocateReadPapers'] || $OC_configAR['OC_advocateSeeAssignedReviews'] || $OC_configAR['OC_advocateSeeOtherReviews']) {
			print '<dt>&#8226; <b><a href="list_papers.php">View Submissions</a></b><p /></dt>';
		}
		if (oc_hookSet('committee-menu-prereview')) {
			foreach ($OC_hooksAR['committee-menu-prereview'] as $v) {
				print '<dt>&#8226; ' . $v . '<p /></dt>';
			}
		}
		if (oc_hookSet('committee-menu-pc-prereview') && ($_SESSION[OCC_SESSION_VAR_NAME]['acpc'] == "T") && $OC_statusAR['OC_pc_signin_open']) {
			foreach ($OC_hooksAR['committee-menu-pc-prereview'] as $v) {
				print '<dt>&#8226; ' . $v . '<p /></dt>';
			}
		}
	}
    if ($OC_configAR['OC_paperAdvocates']) {
		print '
<dt>&#8226; <b>Submissions to Advocate:</b></dt>
<dd><br />
';
		$q = "SELECT `" . OCC_TABLE_PAPERADVOCATE . "`.`paperid`, `" . OCC_TABLE_PAPERADVOCATE . "`.`adv_recommendation`, `" . OCC_TABLE_PAPERREVIEWER . "`.`reviewerid`, " . $formatField . ", `title`, AVG(`recommendation`) AS `paperavg` FROM (`" . OCC_TABLE_PAPERADVOCATE . "`, `" . OCC_TABLE_PAPER . "`) LEFT JOIN `" . OCC_TABLE_PAPERREVIEWER . "` ON `" . OCC_TABLE_PAPERADVOCATE . "`.`paperid`=`" . OCC_TABLE_PAPERREVIEWER . "`.`paperid` WHERE `" . OCC_TABLE_PAPERADVOCATE . "`.`advocateid`='".$_SESSION[OCC_SESSION_VAR_NAME]['acreviewerid']."' AND `" . OCC_TABLE_PAPERADVOCATE . "`.`paperid`=`" . OCC_TABLE_PAPER . "`.`paperid` GROUP BY `paperid`";
		$r = ocsql_query($q) or err("Unable to retrieve submissions for advocating<p>");
		if (mysql_num_rows($r) == 0) { 
			print '<span class="err">You do not have any submissions to advocate.</span><p>';
		} else {
			print '<table border="0" cellspacing="0" cellpadding="0"><tr><td><i>Score Legend:</i> &nbsp; &nbsp; </td><td style="background-color: #ff9; border: 1px solid #666;"> &nbsp;#.##&nbsp; </td><td> &nbsp; <i>2 &lt; Avg Score &lt; 4</i> &nbsp; &nbsp; &nbsp; </td></tr></table><p>';
			print '<table border="1" cellspacing="0" cellpadding="3">';
			print '<table border="0" cellspacing="1" cellpadding="3"><tr class="rowheader"><th>Recomm.</th><th>Score</th><th>Title / Recommendation Form</th><th>Abstract</th>' . $fileTableHeader . '</tr>';
			$row = 1;
			while ($p = mysql_fetch_array($r)) {
				// Skip if in conflict
				if (in_array($p['paperid'] . '-' . $_SESSION[OCC_SESSION_VAR_NAME]['acreviewerid'], $conflictAR)) { continue; }

				if (($p['paperavg'] > 2) && ($p['paperavg'] < 4)) {
					$scoreColor = 'background-color: #ff9;';
				} else {
					$scoreColor = '';
				}
				print '<tr class="row' . $row . '"><td valign="top" align="center" style="color: #555; ' . (!empty($p['adv_recommendation']) ? ('background-color: #' . $OC_acceptanceColorAR[$p['adv_recommendation']]) : '') . '">'. safeHTMLstr($p['adv_recommendation']) . '</td><td valign="top" align="center" style="' . $scoreColor . '">' . number_format($p['paperavg'],2).'</td><td valign="top"><a href="advocate.php?pid='.$p['paperid'].'" title="see reviews and make recommendation for submission ID ' . $p['paperid'] . '">' . $p['paperid'] . ' - ' .  safeHTMLstr($p['title']) . '</a></td><td align="center"><a href="show_abstract.php?pid=' . $p['paperid'] . '"><img src="../images/document-sm.gif" border="0" alt="view abstract" title="view abstract" width="13" height="16" /></a></td>' . oc_printFileCells($p) . "</tr>\n";
				$row = $rowAR[$row];
			}
			print "</table>\n";
		}
		print '</dd>';
	}
}
print "</dl>\n";

if ($OC_statusAR['OC_rev_signin_open']) {
	require_once "reviewer_info.html";
}

printFooter();

?>
