<?php

// +----------------------------------------------------------------------+
// | OpenConf                                                             |
// +----------------------------------------------------------------------+
// | Copyright (c) 2002-2009 Zakon Group LLC.  All Rights Reserved.       |
// +----------------------------------------------------------------------+
// | This source file is subject to the OpenConf License, available on    |
// | the OpenConf web site: www.OpenConf.com                              |
// +----------------------------------------------------------------------+

require_once "../include.php";

beginSession();

printHeader("Show Abstract",2);

if (!preg_match("/^\d+$/",$_REQUEST['pid'])) {
	warn("Invalid Submission ID");
}

$pid = $_REQUEST['pid'];

// Check for conflict
$conflictAR = getConflicts($_SESSION[OCC_SESSION_VAR_NAME]['acreviewerid']);
if (in_array($pid . '-' . $_SESSION[OCC_SESSION_VAR_NAME]['acreviewerid'], $conflictAR)) {
	warn("You appear to have a conflict with this submission");
}

$ok = 0;
$blind = true;
// Check that reviewer has permission
if ($OC_configAR['OC_reviewerReadPapers']) {
	$ok = 1;
} else {    // make sure reviewer is assigned
	$q = "SELECT `paperid` FROM `" . OCC_TABLE_PAPERREVIEWER . "` WHERE `paperid`=" . $pid . " AND `reviewerid`=" . $_SESSION[OCC_SESSION_VAR_NAME]['acreviewerid'];
	$r = ocsql_query($q) or err("Unable to check reviewer permissions " . mysql_errno());
	if (mysql_num_rows($r) == 1) {
		$ok = 1;
	}
}
if ($OC_configAR['OC_reviewerSeeAuthors']) {
	$blind = false;
}
// If not ok, check if advocate & has permission
if ($_SESSION[OCC_SESSION_VAR_NAME]['acpc'] == "T") {
	if ( ! $ok ) {
		if ($OC_configAR['OC_advocateReadPapers']) {
			$ok = 1;
		} else { // make sure advocate is assigned
			$q = "SELECT `paperid` FROM `" . OCC_TABLE_PAPERADVOCATE . "` WHERE `paperid`=" . $pid . " AND `advocateid`=" . $_SESSION[OCC_SESSION_VAR_NAME]['acreviewerid'];
			$r = ocsql_query($q) or err("Unable to check advocate permissions " . mysql_errno());
			if (mysql_num_rows($r) == 1) {
				$ok = 1;
			}
		}
	}
	if ( $blind && $OC_configAR['OC_advocateSeeAuthors'] ) {
		$blind = false;
	}
}
// If still not ok, show error
if (!$ok) {
	warn("You do not have permission to retrieve this submission");
}

// Get abstract
$q = "SELECT `title`, `abstract` FROM `" . OCC_TABLE_PAPER . "` WHERE paperid='" . $pid . "'";
$r = ocsql_query($q) or err("Unable to retrieve abstract");
if (mysql_num_rows($r) != 1) {
	warn("Submission ID " . $pid . " was not found");
}
$l = mysql_fetch_array($r);
print '
<p><b>Submission ID:</b> ' . $pid . '</p>

<p><b>Title:</b> ' . safeHTMLstr($l['title']);

if ( ! $blind ) {
	print ' &nbsp; <span style="white-space: none">[ 
<a href="http://citeseerx.ist.psu.edu/search?q=title' . urlencode(':("' . $l['title'] . '"') . ')" target="_blank">CiteSeer</a> | 
<a href="http://scholar.google.com/scholar?q=intitle' . urlencode(':"' . $l['title'] . '"') . '" target="_blank">Google Scholar</a> | 
<a href="http://www.scirus.com/srsapp/search?q=title' . urlencode(':"' . $l['title'] . '"') . '" target="_blank">Scirus</a>
 ]</span>';
 }
 
 print '</p>';

if (! $blind) { // show author info
	$aq = "SELECT `name_last`, `name_first`, `organization`, `country` FROM `" . OCC_TABLE_AUTHOR . "` WHERE `paperid`=" . $pid . " ORDER BY `position`";
	$ar = ocsql_query($aq) or err("Unable to retrieve authors");
	if (($arnum = mysql_num_rows($ar)) == 1) {
		$al = mysql_fetch_assoc($ar);
		print '<p><b>Author:</b> ' . safeHTMLstr($al['name_first'] . ' ' . $al['name_last'] . ', ' . $al['organization'] . ', ' . $al['country']) . ' &nbsp; <span style="white-space: none">[ 
<a href="http://citeseerx.ist.psu.edu/search?q=' . urlencode('"' . $al['name_first'] . ' ' . $al['name_last'] . '"') . '&t=auth" target="_blank">CiteSeer</a> | 
<a href="http://scholar.google.com/scholar?q=author' . urlencode(':"' . $al['name_first'] . ' ' . $al['name_last'] . '"') . '" target="_blank">Google Scholar</a> | 
<a href="http://www.scirus.com/srsapp/search?q=author' . urlencode(':"' . $al['name_first'] . ' ' . $al['name_last'] . '"') . '" target="_blank">Scirus</a>
 ]</span></p>';
	} elseif ($arnum > 1) {
		print '<p><b>Authors:</b></p>';
		while ($al = mysql_fetch_assoc($ar)) {
			print '
<p>' . safeHTMLstr($al['name_first'] . ' ' . $al['name_last'] . ', ' . $al['organization'] . ', ' . $al['country']) . ' &nbsp; <span style="white-space: none">[ 
<a href="http://citeseerx.ist.psu.edu/search?q=' . urlencode('"' . $al['name_first'] . ' ' . $al['name_last'] . '"') . '&t=auth" target="_blank">CiteSeer</a> | 
<a href="http://scholar.google.com/scholar?q=author' . urlencode(':"' . $al['name_first'] . ' ' . $al['name_last'] . '"') . '" target="_blank">Google Scholar</a> | 
<a href="http://www.scirus.com/srsapp/search?q=author' . urlencode(':"' . $al['name_first'] . ' ' . $al['name_last'] . '"') . '" target="_blank">Scirus</a>
 ]</span></p>
';
		}
	}
}

print '<p><b>Abstract:</b></p>' . "\n" . nl2br(safeHTMLstr($l['abstract']));

printFooter();

?>
