<?php

// +----------------------------------------------------------------------+
// | OpenConf                                                             |
// +----------------------------------------------------------------------+
// | Copyright (c) 2002-2009 Zakon Group LLC.  All Rights Reserved.       |
// +----------------------------------------------------------------------+
// | This source file is subject to the OpenConf License, available on    |
// | the OpenConf web site: www.OpenConf.com                              |
// +----------------------------------------------------------------------+

require_once "../include.php";

require_once OCC_COUNTRY_FILE;

function signUpClosed() {
	print '<p align="center"><span class="warn">Committee sign-up is closed.</span></p>';
	printFooter();
	exit;
}

if ($OC_configAR['OC_paperAdvocates'] && isset($_POST['keycode']) && ($_POST['keycode'] == $OC_configAR['OC_keycode_program'])) {
  printHeader("Program Committee Signup",3);
  if (! $OC_statusAR['OC_pc_signup_open']) { signUpClosed(); }
  $committee = "program";
  $oncommittee = "T";
}
elseif (isset($_POST['keycode']) && ($_POST['keycode'] == $OC_configAR['OC_keycode_reviewer'])) {
  printHeader("Reviewer Committee Signup",3);
  if (! $OC_statusAR['OC_rev_signup_open']) { signUpClosed(); }
  $committee = "reviewer";
  $oncommittee = "F";
} else {
	printHeader("Committee Sign-Up",3);
	print '
<p class="warn">
The keycode entered is incorrect.  Please click on the Back button to try again.  If you are still unable to access the committee sign up page, please contact the <a href="mailto:' . $OC_configAR['OC_pcemail'] . '?subject=OpenConf keycode problem">Program Chair</a>.
</p>
';
	printFooter();
	exit;
}

if (isset($_POST['submit']) && ($_POST['submit'] == "Submit Form")) {
	// do some basic error checking
	$errmsg = "";
	if (empty($_POST['name_last']) || empty($_POST['name_first']) || empty($_POST['phone']) || !validEmail($_POST['email'])) {
		$errmsg .= "<li>Check that you have entered your first and last name, telephone, and email correctly and without extra spaces.</li>";
	} else {    // check that user does not yet have an account; notify & bail if they do
		$eq = "SELECT * FROM " . OCC_TABLE_REVIEWER . " WHERE email='" . safeSQLstr($_POST['email']) . "'";
		$er = ocsql_query($eq) or err("could not check email address " . mysql_errno($ur));
		if (mysql_num_rows($er) != 0) {
			print '<p class="warn" style="text-align: center">An account for that email address already exists.<br />Would you like to <a href="signin.php">Sign-In</a> or <a href="email_username.php">Recover Username</a>?</p>';
			printFooter();
			exit;
		}
	}
	if (!empty($_POST['url']) && !preg_match("/:\/\//",$_POST['url'])) {
		$errmsg .= "<li>Web Address needs to contain full URL (including http:// )</li>";
	}
	if (!preg_match("/^[\w\.\-]{5,30}$/",$_POST['username'])) {
		$errmsg .= "<li>Username should be between 5 and 30 alphanumeric characters</li>";
	}
	if (!preg_match("/^.{6,30}$/",$_POST['password'])) {
		$errmsg .= "<li>Password should be between 6 and 30 characters</li>";
	}
	elseif ($_POST['password'] == $_POST['username']) { 
		$errmsg .= "<li>Password needs to be more creative than your username</li>";
	}
	if ($_POST['password'] != $_POST['confirm']) { 
		$errmsg .= "<li>Passwords do not match</li>";
	}
	if (!isset($_POST['topic']) || (sizeof($_POST['topic']) < 1)) {
		$errmsg .= "<li>Select at least one area of interest</li>";
	}
	if (empty($errmsg)) {
		$lowusername = oc_strtolower($_POST['username']);
		$uq = "SELECT * FROM " . OCC_TABLE_REVIEWER . " WHERE username='" . $lowusername . "'";
		$ur = ocsql_query($uq) or err("could not check username " . mysql_errno($ur));
		if (mysql_num_rows($ur) != 0) {
			$errmsg .= '<li>Username is already taken; select a different username (or <a href="signin.php">Sign-In</a> if you already registered)</li>';
		}
	}
	if (!empty($errmsg)) {
		#$errmsg .= "<br /><br /><li><i>Note that the password fields have been reset</i></li>";
		showError($errmsg);
		print '<span class="err">Note that the password fields have been reset.</span><p>';
	}
	else { // let's submit
		$q = "INSERT INTO " . OCC_TABLE_REVIEWER . " (username,password,name_last,name_first,email,url,organization,country,telephone,onprogramcommittee,otherexpertise,comments) VALUES (" .
			"'" . $lowusername . "'," .
			"'" . hashPassword(stripslashes($_POST['password'])) . "'," .
			"'" . safeSQLstr($_POST['name_last']) . "'," .
			"'" . safeSQLstr($_POST['name_first']) . "'," .
			"'" . safeSQLstr($_POST['email']) . "'," .
			"'" . safeSQLstr($_POST['url']) . "'," .
			"'" . safeSQLstr($_POST['org']) . "'," .
			"'" . safeSQLstr($_POST['country']) . "'," .
			"'" . safeSQLstr($_POST['phone']) . "'," .
			"'" . $oncommittee . "'," .
			"'" . safeSQLstr($_POST['otherareas']) . "'," .
			"'" . safeSQLstr($_POST['comments']) . "'" .
			")";
		$r = ocsql_query($q) or err("unable to submit form ".mysql_errno());
		$rid = mysql_insert_id() or err("unable to get reviewer id ".mysql_errno());

		$topiclist = "";
		foreach ($_POST['topic'] as $t) {
			if (is_numeric($t)) {
				$q = "INSERT INTO " . OCC_TABLE_REVIEWERTOPIC . " (reviewerid,topicid) VALUES ($rid,$t)";
				$r = ocsql_query($q) or err("unable to add reviewer topic " . mysql_errno($r));
			}
			else { err("invalid submission topic - ..$t.."); }
		}

		print '
Thank you for signing up.   We have emailed you a confirmation with your information.  
<p>
If you have any questions, please contact the <a href="mailto:' . $OC_configAR['OC_pcemail'] . '?subject=' . $OC_configAR['OC_confName'] . ' Committee Sign Up Question">Program Chair</a>
';
		printFooter();

		$mailbody = '
Thank you for signing for the ' . $OC_configAR['OC_confName'] . ' ' . $committee . ' committee.  Below is the information you provided.  If you have any questions, please contact ' . $OC_configAR['OC_pcemail'] . ' or reply to this email.

Username:     ' . $_POST['username'] . '
Name:         ' . stripslashes($_POST['name_first'] . " " . $_POST['name_last']) . '
Email:        ' . $_POST['email'] . '
Web Address:  ' . $_POST['url'] . '
Organization: ' . stripslashes($_POST['org']) . '
Country:      ' . $_POST['country'] . '
Telephone:    ' . $_POST['phone'] . '
Other Areas:  ' . stripslashes($_POST['otherareas']) . '
Comments:     ' . stripslashes($_POST['comments']) . '

Note that your areas of interest are not listed above, but they have been recorded.
';
		sendEmail($_POST['email'], "Committee Signup", $mailbody, $OC_configAR['OC_notifyReviewerSignup']);
		exit;
	}
} // if submit form
else {
  require_once "signup_$committee.html";
}

// Get topics
$tq = "SELECT * FROM " . OCC_TABLE_TOPIC;
$tr = ocsql_query($tq) or err("unable to retrieve topics " . mysql_error());
$half = ceil(mysql_num_rows($tr)/2);

// Print form
print '
<p><hr><p>

<form method="post" action="' . $_SERVER['PHP_SELF'] . '">
<input type="hidden" name="keycode" value="' . safeHTMLstr(varValue('keycode', $_POST)) . '">
<table border=0 cellspacing=0 cellpadding=0>
<tr><td class="item" valign="bottom">Name:</td><td>
	<table border=0 cellspacing=0 cellpadding=0>
	<tr><td>
	<i>First/Given Name</i><br />
	<input size=21 name="name_first" value="' . safeHTMLstr(varValue('name_first', $_POST)) . '" maxlength=60>
	</td><td><nobr> &nbsp; &nbsp; </nobr></td><td>
	<i>Last/Family Name</i><br />
	<input size=21 name="name_last" value="' . safeHTMLstr(varValue('name_last', $_POST)) . '" maxlength=40>
	</td></tr>
	</table>
</td></tr>
<tr><td class="item">Email:</td><td><input size=50 name="email" value="' . safeHTMLstr(varValue('email', $_POST)) . '"></td></tr>
<tr><td valign="top" class="item">Organization:</td><td><input size=50 name="org" value="' . safeHTMLstr(varValue('org', $_POST)) . '"><br>
<span class="note"><b>Note:</b> Organization should be your company, university, or similar. Please do not use your department or division, unless it is part of your organization\'s name such as Interior Department.</span> 
</td></tr>
<tr><td class="item">Country:</td><td><select name="country"><option></option>' . generateSelectOptions($OC_countryAR, varValue('country', $_POST), FALSE) . '</select></td></tr>
<tr><td class="item">Telephone:</td><td><input size=50 name="phone" value="' . safeHTMLstr(varValue('phone', $_POST)) . '"></td></tr>
<tr><td class="item">Web Address:</td><td><input size=50 name="url" value="' . safeHTMLstr(varValue('url', $_POST)) . '"> <span class="note">include http://</span></td></tr>

<tr><td colspan=2><br><hr><p></td></tr>

<tr><td class="note2" colspan=2>Please select a username and password to authenticate yourself to the review system in the future. Be sure to choose an appropriate password, and one that you will remember.<p></td></tr>
<tr><td class="item">Username:</td><td><input size=50 name="username" value="' . safeHTMLstr(varValue('username', $_POST)) . '"> <span class="note">(5-30 characters)</span></td></tr>
<tr><td class="item">Password:</td><td><input size=50 name="password" type="password"> <span class="note">(6-30 characters)</span></td></tr>
<tr><td class="item">Retype Pwd:</td><td><input size=50 name="confirm" type="password"></td></tr>

<tr><td colspan=2><br><hr><p></td></tr>

<tr><td class="item" colspan=2>Areas of Interest:<p></td></tr>
<tr><td colspan=2>
<span class="note2">To help match submissions to reviewers, please select one or more areas that you are most comfortable reviewing:</span><p>
</td></tr>
<tr><td colspan=2><dl><dd>
  <table border=0 cellspacing=0 cellpadding=0><tr><td valign="top">
';

// Display topics
$i=1;
while ($l = mysql_fetch_array($tr)) {
	print '<input type="checkbox" name="topic[]" value="' . $l['topicid'] . '"';
	if (isset($_POST['topic']) && in_array($l['topicid'],$_POST['topic'])) { print " checked"; }
	print '>' . $l['topicname'];
	if (($OC_configAR['OC_topicColumns'] == 2) && ($i++ == $half)) {
		print "</td><td><nobr> &nbsp; &nbsp; </nobr></td><td valign=\"top\">";
	}
	else {
		print "<br>\n";
	}
}

print '
  </td></tr></table>
</dl></td></tr>
<tr><td valign="top" class="item">Other Areas:</td><td><textarea name="otherareas" rows=4 cols=50>' . safeHTMLstr(varValue('otherareas', $_POST)) . '</textarea></td></tr>

<tr><td colspan=2><br><hr><p></td></tr>

<tr><td valign="top" class="item">Comments to Chair:</td><td><textarea name="comments" rows=4 cols=50>' . safeHTMLstr(varValue('comments', $_POST)) . '</textarea></td></tr>

<tr><td colspan=2><br><hr><p></td></tr>
</table>
<input type="submit" name="submit" value="Submit Form">
<p>

';

printFooter();

?>
