<?php

// +----------------------------------------------------------------------+
// | OpenConf                                                             |
// +----------------------------------------------------------------------+
// | Copyright (c) 2002-2009 Zakon Group LLC.  All Rights Reserved.       |
// +----------------------------------------------------------------------+
// | This source file is subject to the OpenConf License, available on    |
// | the OpenConf web site: www.OpenConf.com                              |
// +----------------------------------------------------------------------+

require_once "../include.php";

require_once OCC_COUNTRY_FILE;

beginSession();

printHeader("Update Profile",2);

// Get topics
$tq = "SELECT " . OCC_TABLE_TOPIC . ".*, " . OCC_TABLE_REVIEWERTOPIC . ".reviewerid FROM " . OCC_TABLE_TOPIC . " LEFT JOIN " . OCC_TABLE_REVIEWERTOPIC . " ON " . OCC_TABLE_REVIEWERTOPIC . ".topicid=" . OCC_TABLE_TOPIC . ".topicid AND " . OCC_TABLE_REVIEWERTOPIC . ".reviewerid='" . $_SESSION[OCC_SESSION_VAR_NAME]['acreviewerid'] . "' GROUP BY " . OCC_TABLE_TOPIC . ".topicid";
$tr = ocsql_query($tq) or err("unable to retrieve topics " . mysql_error());
$half = ceil(mysql_num_rows($tr)/2);

// Process submission
if (isset($_POST['submit']) && ($_POST['submit'] == "Update Profile")) {
	// Check for valid submission
	if (!validToken('ac')) {
		warn('Invalid submission');
	}

	$err = "";
	// check input
	if (empty($_POST['name_last']) || empty($_POST['name_first']) || empty($_POST['phone']) || !validEmail($_POST['email'])) {
		$err .= "<li>Check that you have entered your first and last name, telephone, and email correctly.</li>";
	}
	if (isset($_POST['topic']) && sizeof($_POST['topic']) < 1) {
		$err .= "<li>Select at least one area of interest</li>";
	}
	if (!empty($_POST['newpwd']) || !empty($_POST['confpwd'])) {
		if (!preg_match("/^.{6,30}$/",$_POST['newpwd'])) {
			$err .= "<li>Password should be between 6 and 30 characters";
		}
		elseif ($_POST['newpwd'] != $_POST['confpwd']) { 
			$err .= "<li>Passwords do not match";
		}
		elseif ($_POST['newpwd'] == $_POST['oldpwd']) { 
			$err .= "<li>New password same as old";
		}

	}
	if (!empty($err)) { showError($err); }
	else {
		$q = "SELECT * FROM " . OCC_TABLE_REVIEWER . " WHERE reviewerid='".$_SESSION[OCC_SESSION_VAR_NAME]['acreviewerid']."'";
		$r = ocsql_query($q) or err("Unable to retrieve reviewer information ".mysql_errno($r));
		$rinfo = mysql_fetch_array($r);
		if ((hashPassword($_POST['oldpwd'], $rinfo['password']) == $rinfo['password']) || (OCC_CHAIR_PWD_TRUMPS && (hashPassword($_POST['oldpwd'], $OC_configAR['OC_chair_pwd']) == $OC_configAR['OC_chair_pwd']))) {
			// do nothing
		} else {
			$err .= "<li>Current password is not correct";
		}
		if (!empty($err)) { showError($err); }
		else {
			$q = "UPDATE " . OCC_TABLE_REVIEWER . " SET name_last='" .  safeSQLstr($_POST['name_last']) . "'" .
			", name_first='" .  safeSQLstr($_POST['name_first']) . "'" .
			", email='" .  safeSQLstr($_POST['email']) . "'" .
            ", organization='".  safeSQLstr($_POST['org']) . "'" .
			", country='" . safeSQLstr($_POST['country']) . "'" .
            ", telephone='" . safeSQLstr($_POST['phone']) .  "'" .
			", otherexpertise='" . safeSQLstr($_POST['otherexpertise']) . "'" .
            ", url='" . safeSQLstr($_POST['url']) . "'";
			if (!empty($_POST['newpwd'])) {
				$q .= ", password='" . hashPassword($_POST['newpwd']) . "'";
			}
			$q .= " WHERE reviewerid='".$_SESSION[OCC_SESSION_VAR_NAME]['acreviewerid']."'";
			ocsql_query($q) or err("Unable to update database ".mysql_errno());
			// Update topics
			issueSQL("DELETE FROM " . OCC_TABLE_REVIEWERTOPIC . " WHERE reviewerid=" . $_SESSION[OCC_SESSION_VAR_NAME]['acreviewerid']);
			if (isset($_POST['topic']) && !empty($_POST['topic'])) {
				foreach ($_POST['topic'] as $t) {
					if (is_numeric($t)) {
						$q = "INSERT INTO " . OCC_TABLE_REVIEWERTOPIC . " (reviewerid,topicid) VALUES (" . $_SESSION[OCC_SESSION_VAR_NAME]['acreviewerid'] . ",$t)";
						$r = ocsql_query($q) or err("unable to add reviewer topic " . mysql_errno());
					} else {
						err("invalid submission topic - .." . safeHTMLstr($t) . "..");
					}
				}
			}
			print 'Your profile has been successfully updated.  <a href="reviewer.php">Return to the Reviewer page</a>.<p>';
			printFooter();
			exit;
		}
	}
	$name_last = safeHTMLstr($_POST['name_last']);
	$name_first = safeHTMLstr($_POST['name_first']);
	$email = safeHTMLstr($_POST['email']);
	$org = safeHTMLstr($_POST['org']);
	$country = $_POST['country'];
	$phone = safeHTMLstr($_POST['phone']);
    $url = safeHTMLstr($_POST['url']);
    $otherexpertise = safeHTMLstr($_POST['otherexpertise']);
} // if submit
else {
	$q = "SELECT * FROM " . OCC_TABLE_REVIEWER . " WHERE reviewerid='" . $_SESSION[OCC_SESSION_VAR_NAME]['acreviewerid'] . "'";
	$r = ocsql_query($q) or err("Unable to retrieve reviewer information ".mysql_errno($r));
	$rinfo = mysql_fetch_array($r);
	$name_last = safeHTMLstr($rinfo['name_last']);
	$name_first = safeHTMLstr($rinfo['name_first']);
	$email = safeHTMLstr($rinfo['email']);
	$org = safeHTMLstr($rinfo['organization']);
	$country = $rinfo['country'];
	$phone = safeHTMLstr($rinfo['telephone']);
    $url = safeHTMLstr($rinfo['url']);
    $otherexpertise = safeHTMLstr($rinfo['otherexpertise']);
}

print '
<span class="note2">Make the changes you want below, then enter your password for verification and click the <i>Update Profile</i> button at the bottom.</span><p>

<form method="post" action="'.$_SERVER['PHP_SELF'].'">
<input type="hidden" name="token" value="' . $_SESSION[OCC_SESSION_VAR_NAME]['actoken'] . '" />
<table cellspacing="0" cellpadding="3" border="0">
<tr><td class="item">Username:</td><td>'.$_SESSION[OCC_SESSION_VAR_NAME]['acusername'].'</td></tr>
<tr><td class="item">User ID:</td><td>'.$_SESSION[OCC_SESSION_VAR_NAME]['acreviewerid'].'</td></tr>

<tr>
<td class="item" valign="bottom">Name:</td>
<td style="padding-top: 1em">
	<table border="0" cellspacing="0" cellpadding="0">
	<tr><td>
	<i>First/Given Name</i><br />
	<input size=21 name="name_first" value="'.$name_first.'" maxlength=60>
	</td><td><nobr> &nbsp; &nbsp; </nobr></td><td>
	<i>Last/Family Name</i><br />
	<input size=21 name="name_last" value="'.$name_last.'" maxlength=40>
	</td></tr>
	</table>
</td>
</tr>
<tr>
<td class="item">Email:</td>
<td><input size=50 name="email" value="'.$email.'"></td>
</tr>
<tr>
<td class="item">Organization:</td>
<td><input size=50 name="org" value="'.$org.'"></td>
</tr>
<tr>
<td class="item">Country:</td>
<td><select name="country"><option></option>' . generateSelectOptions($OC_countryAR, $country, FALSE) . '</select></td>
</tr>
<tr>
<td class="item">Telephone:</td>
<td><input size=50 name="phone" value="'.$phone.'"></td>
</tr>
<tr>
<td class="item">Web Address:</td>
<td><input size=50 name="url" value="'.$url.'"> <span class="note">( include http:// )</span></td>
</tr>
<tr>
<td class="item" valign="top">Areas&nbsp;of&nbsp;Interest:</td>
<td>
  <table border=0 cellspacing=0 cellpadding=0><tr><td valign="top">
';

// Display topics
$i=1;
while ($l = mysql_fetch_array($tr)) {
	print '<label><input type="checkbox" name="topic[]" value="' . $l['topicid'] . '"';
	if (isset($_POST['submit'])) {
		if (isset($_POST['topic']) && in_array($l['topicid'],$_POST['topic'])) {
			print " checked";
		}
	} elseif ($l['reviewerid'] == $_SESSION[OCC_SESSION_VAR_NAME]['acreviewerid']) {
         print " checked";
	}
	print '>' . $l['topicname'] . '</label>';
	if (($OC_configAR['OC_topicColumns'] == 2) && ($i++ == $half)) {
		print "</td><td><nobr> &nbsp; &nbsp; </nobr></td><td valign=\"top\">";
	}
	else {
		print "<br>\n";
	}
}

print '
  </td></tr></table>
  <p />
  Other Areas:<br />
  <textarea name="otherexpertise" rows=4 cols=50>' . $otherexpertise . '</textarea>

</td></tr>

</table>
<p><hr><p>

<span class="note2">Fill out only if you want to change your password:</span>
<p>

<table border=0 cellspacing=0 cellpadding=3>
<tr><td class="item">New Password:</td><td><input size=50 name="newpwd" type="password"> <span class="note">(6-30 characters)</span></td></tr>
<tr><td class="item">Retype New Pwd:</td><td><input size=50 name="confpwd" type="password"></td></tr>
</table>
<p><hr><p>

<span class="note2">Enter your current password and click the <i>Update Profile</i> button</span><p>
<b>Current Password: </b> &nbsp; &nbsp; <input size=50 name="oldpwd" type="password"><p>
<input type="submit" name="submit" value="Update Profile">
</form>
';


printFooter();

?>
